cc ---7--o----+----o----+----o----+----o----+----o----+----o----+----o-|--+----o
cc
cc --- apr'06 13-12:13
cc
cc     implement crude guess at largest dimension given for a FLUKA geometry
cc     only a very few shapes supported as of yet: BOX/RPP/SPH
cc     could see major improvements
cc
cc     jul'06
cc     vasilis implemented bounding boxes - should use those rather and simply
cc     find largest one(s)
cc
cc     developed for use with the flukaGUI application
cc     subject to the FLUKA user license
cc     contact anton.empl@cern.ch
cc     the FLEUR project
cc


      subroutine myTest()
cc   ---------------------

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'

      INCLUDE '(BLNKCM)'
      INCLUDE '(GOMLOC)'

      logical larger
      integer corner(3,8)
      dimension nn(19),par(30),IBIAS(19)
      DATA IBIAS/24,-2,1,6,2,1,6,6,0,-3,-2,-5,-5,-5,0,-3,-2,-3,-2/

      common /mylimits/ xl,yl,zl,xu,yu,zu,itsType

      data corner/1,1,1,1,0,1,0,0,1,0,1,1, 1,1,0,1,0,0,0,0,0,0,1,0/

cc --------------------------- taken from flkgci() --- jul'06 06-01:38
      IFPD= KFPD / KALGNM
      IFPD= IFPD + JALGNM

      itsType= 0

      do i=1,19
        nn(i)= IBIAS(i)+6
        enddo

      xl=  10e10
      yl=  10e10
      zl=  10e10
      xu= -10e10
      yu= -10e10
      zu= -10e10

      do i=1,NUMB
        loc= 7*i-6
        jbody= nstor(KMA-1 +loc)
        itype= nstor(KMA-1 +loc+2)
        kloc= nstor(KMA-1 +loc+6)

        do j=1,nn(itype)
          par(j)= gmstor(IFPD-1 +kloc+1+j)
          enddo

c       write(0,*) ' myTest ',i,jbody,itype,kloc,nn(itype)

cc
cc --- regard closed volumes only
cc
        if (itype.lt.10) then

          if (itype.eq.9) then
cc       ------------------------------------ RPP
            if (par(1).lt.xl .or. par(2).gt.xu .or. par(3).lt.yl .or.
     .           par(4).gt.yu .or. par(5).lt.zl .or. par(6).gt.zu) then
              xl= par(1)
              xu= par(2)
              yl= par(3)
              yu= par(4)
              zl= par(5)
              zu= par(6)
              itsType= 9
              endif

          elseif (itype.eq.8) then
cc       ------------------------------------ WED
c             itsType= 8

          elseif (itype.eq.7) then
cc       ------------------------------------ BOX
            larger= .FALSE.
            do n=1,8
              x= par(1)+corner(1,n)*par(4)
              y= par(2)+corner(2,n)*par(5)
              z= par(3)+corner(3,n)*par(6)
              larger= x.lt.xl .or. x.gt.xu .or. y.lt.yl .or. y.gt.yu
     .                .or. z.lt.zl .or. z.gt.zu   .or. larger
              enddo
            if (larger) then
              do n=1,8
                x= par(1)+corner(1,n)*par(4)
                if (x.lt.xl) xl= x
                if (x.gt.xu) xu= x
                y= par(2)+corner(2,n)*par(5)
                if (y.lt.yl) yl= y
                if (y.gt.yu) yu= y
                z= par(3)+corner(3,n)*par(6)
                if (z.lt.zl) zl= z
                if (z.gt.zu) zu= z
                enddo
              itsType= 7
              endif

          elseif (itype.eq.6) then
cc       ------------------------------------ ELL
c             itsType= 6

          elseif (itype.eq.5) then
cc       ------------------------------------ TRC
c             itsType= 5

          elseif (itype.eq.4) then
cc       ------------------------------------ REC
c             itsType= 4

          elseif (itype.eq.3) then
cc       ------------------------------------ RCC
c             itsType= 3

          elseif (itype.eq.2) then


cc       slight trouble here if sphere should be close to actual volumes used
cc       in this problem, we keep max values and remember it's a sphere
cc
cc       ------------------------------------ SPH
            if (par(1)-par(4).lt.xl .or. par(1)+par(4).gt.xu .or.
     .           par(2)-par(4).lt.yl .or. par(2)+par(4).gt.yu .or.
     .            par(3)-par(4).lt.zl .or. par(3)+par(4).gt.zu) then
              xl= par(1)-par(4)/sqrt(3.)
              xu= par(1)+par(4)/sqrt(3.)
              yl= par(2)-par(4)/sqrt(3.)
              yu= par(2)+par(4)/sqrt(3.)
              zl= par(3)-par(4)/sqrt(3.)
              zu= par(3)+par(4)/sqrt(3.)
              itsType= 2
              endif

          elseif (itype.eq.1) then
cc       ------------------------------------ ARB
c             itsType= 1
          endif

          endif
        enddo

      end
