cc ---7--o----+----o----+----o----+----o----+----o----+----o----+----o-|--+----o
cc                     
cc --- mar'06 13-17:41
cc                  
cc     new FLUKA wrapper to exercise plotgeom related 2D cut feature   
cc     this one is called from C such that each time FLUKA is started anew
cc     care was taken to catch most(all) input/output ususally generated/needed
cc        
cc     developed for use with the flukaGUI application
cc     subject to the FLUKA user license
cc     contact anton.empl@cern.ch
cc     the FLEUR project
cc        


      subroutine pgmdrv( IX, FILNAM, IY, GEOMETRY )
cc   -----------------------------------------------

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'

      common /iextra/ispace(1024)
      INCLUDE '(BLNKCM)'
      INCLUDE '(CTITLE)'

cc
cc    wrapper for pgmdrv
cc -----------------------------
cc    created   may 2004
cc    project   fleur - UH/NASA/CERN
cc    contact   anton.empl@cern.ch
cc
cc    changed   mar'06 11-11:35
cc              try and keep pgmdrv.f code visible as much as reasonable
cc              changed reading through the input file with basically a
cc              modified/shortened version of flukam.f (2005.6)
cc
cc    changed   mar'06 21-23:51
cc              adapted to fluka2006.1
cc              this is only us now, no more code left of pgmdrv()
cc              we just tailored flukam() such that we get a little
cc              extra information and call geoinp() differently - of
cc              course we also stop at START/PLOTGEOM and come back here
cc
cc    changed   apr'28 08:45
cc              cleanup, so mow we need minimal changes to FLUKA code
cc              run complete new flukam()
cc              this is now a forked 'child' process
cc

      INCLUDE '(COMPUT)'

      CHARACTER*80 FILNAM,GEOMETRY
      character*80 inpFile,geoFile

      character*8 sdum, gtitle*60,runtitle*80
      real*8 what(6)
      common /apr06/ n,m,rname,mname
      character rname*9,mname*9

      LOGICAL LPGMOP,LUNPGI,LPGPRN,LPGUNF,LPGSHR
      COMMON/PGMOUT/LUNPGI,LPGPRN,LPGUNF,LPGSHR
      COMMON/PGMFLK/NSURF,NREG,LPGMOP
      COMMON/PGMAXS/X0,Y0,Z0,TYX,TYY,TYZ,TXX,TXY,TXZ,
     1              XAXLEN,YAXLEN,EXPANX,EXPANY,X1,Y1,Z1,LWMHOL,
     .              nix,rnix(6),
     .              gtitle,runtitle
      integer*2 mc(1000000)
      real*4 c(1000000)
      common /draw/ c,mc,nc

      do i=1,1024
        ispace(i)= i
        enddo

      do i=1,6
        what(i)= 0
        enddo
      sdum= '        '

      n= KALGNM*NBLNMX
      call cnstor(n,NSTOR)
      call capr06(n)

      inpFile= FILNAM(1:IX)
      geoFile= geometry(1:IY)

      OPEN ( UNIT=LUNIN , FILE=inpFile, STATUS='OLD' )
      OPEN ( UNIT=LUNOUT, FILE='/dev/null', STATUS='UNKNOWN' )

cc   ----------------
      LNMGEO= .false.
      LNMINP= .true.
      LFRFMT= .false.
cc   ----------------
      open(unit=6,file='/dev/null',status='unknown')

      HFLDIR= geoFile
      KFLDIR= LNNBLN (HFLDIR)
      KFLDIR = MIN ( KFLDIR, 80 )

cc                          communication from/to FLUKA common
cc                          try to find largest region
cc  ----------------------- select compressed binary mode only ---
      call clpgmop(LPGMOP)
      call cpgmaxs(X0)
      call cdraw(c,mc,nc)

      call flukam(-1)

      close(unit=LUNGEO,DISP='DELETE')
      close(unit=6,disp='DELETE')

      runtitle= RUNTIT
      gtitle= RUNGEO

      call mytest()

      LPGSHR = .TRUE.
      LPGUNF = .TRUE.

      close(LUNOUT)
      close(LUNIN)

      return
      end


cc --- to force linking from our library
cc
      subroutine never()
      call pgmufz()
      call pgmgui()
c     call jomin()    !<--- not there anymore ion 2006.3 --- mar'07
      end


cc ----------------------------------
cc  sep'06 03-17:11
cc  hey, self defense ---

      subroutine nix()
      call eveout
      call evdini
      call eventd
      call eveqmd
      call evqmd
      call evqmdi
cc -----------------------
      call lattic
      call usrini
      end
 
cc -----------------------
      subroutine eveout
      end
      subroutine evdini
      end
      subroutine eventd
      end
      subroutine eveqmd
      end
      subroutine evqmd
      end
      subroutine evqmdi
      end
