
//
//    (feb'07 19-02:07) - version v.07a
//                                                                                 the FLEUR project
// -------------------------------------------------------------------------------------------------
//                                                                                anton.empl@cern.ch
//                                                                                  Matt LeBourgeois
// --- FLUKA user back-end project -Fbe-
//     this is part of the main class - set up the GUI and make use of the Fbe classes
//



#include "FlukaMainFrame.h"

//
// --- sep'06 19-05:54
//     small C helper routine to chop string at blanks for FLUKA user routine names

int N=0;
char *P=NULL;

char *one(int j)
{
 int i;
 char *p,*q; static char name[256];
 if (j>N) return (char*)NULL;

 p= P;
 for (i=0;i<=j;i++) { q= strstr(p," ");
                      if (q-p>0) { strcpy(name,""); strncpy(name,p,++q-p); name[q-p-1]= '\0'; }
                      p= q++; }
 return name;
}






void FlukaMainFrame::AddTab1(TGCompositeFrame *tab1,
                             char *flukaVersion, char *rootVersion,
                             int nrOfUserRoutines, char *listOfUserRoutines, char** theirDates)
{
   char a[256];
   fFrame1=tab1;

   N= nrOfUserRoutines;
   P= listOfUserRoutines;

   fTitleFrame1 = new TGCompositeFrame(fFrame1,0,0,0);
   fTitle0 = new TGLabel(fTitleFrame1,"flukaGUI - dec'04/aug'07");
   strcpy(a,"FLUKA version: "); strcat(a,flukaVersion);
      fTitle2 = new TGLabel(fTitleFrame1,a, myGC(),myFont->GetFontStruct());
   strcpy(a,"root version: "); strcat(a,rootVersion);
      fTitle3 = new TGLabel(fTitleFrame1,a, myGC(),myFont->GetFontStruct());
   fTitle4 = new TGLabel(fTitleFrame1,"use of the input file to obtain geometry informaiton is preferred");
   fTitle5 = new TGLabel(fTitleFrame1,"NEW: specify FLUKA input file only and inspect/scan the geometry");
   fTitle1 = new TGLabel(fTitleFrame1," ");
   fTitleFrame1->AddFrame(fTitle0,fL9);
   fTitleFrame1->AddFrame(fTitle1,fL9);
   fTitleFrame1->AddFrame(fTitle2,fL9);
   fTitleFrame1->AddFrame(fTitle3,fL9);
   fTitleFrame1->AddFrame(fTitle4,fL9);
   fTitleFrame1->AddFrame(fTitle5,fL9);
   fFrame1->AddFrame(fTitleFrame1,fL0);

   fTitleFrame1->SetBackgroundColor(grey->GetPixel());
   fTitle0->SetBackgroundColor(grey->GetPixel());
   fTitle1->SetBackgroundColor(grey->GetPixel());
   fTitle2->SetBackgroundColor(grey->GetPixel());
   fTitle3->SetBackgroundColor(grey->GetPixel());
   fTitle4->SetBackgroundColor(grey->GetPixel());
   fTitle5->SetBackgroundColor(grey->GetPixel());

   fFrameDecor9 = new TGHorizontalFrame(fFrame1,0,_sepheight,_sepshape);
   fFrameDecor9->SetBackgroundColor(matt->GetPixel());
   fFrame1->AddFrame(fFrameDecor9, fL3);

   const TGPicture *iClose= openIcon("close.xpm");

// --- sep'06 22-01:17
//     try and measure out the longest of our button labels here

// --- may'07 23:16
//     well, now we see a hidden TGLabel which was unvisible before, kill
//     it and try to let root 'measure' the length

   int width= gVirtualX->TextWidth(myFont->GetFontStruct(),"Geometry File",13);
   width+= 20;

// TGLabel *l= new TGLabel(fFrame1,"Geometry File");
// TGDimension wh= l->GetDefaultSize();
// fFrame1->AddFrame(l);
// fFrame1->Layout();
// fFrame1->HideFrame(l);
// int width= wh.fWidth+20;
// ---

   fFrame11 = new TGHorizontalFrame(fFrame1,0,0);

   fTextData = new TGTextEntry(fFrame11,"(binary) USRBIN data file", MDATAFILE);
   fTextData->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fTextData->Associate(this);
   fFrame11->AddFrame(fTextData,fLL4);
   fCloseDB= new TGPictureButton(fFrame11,iClose,MDclose);
   fCloseDB->SetToolTipText("explicitly disconnect data file");
   fCloseDB->Connect("Clicked()", "FlukaMainFrame", this, "disconnectFile()");
   fFrame11->AddFrame(fCloseDB, new TGLayoutHints(kLHintsCenterY, 3,0,0,0));
   fFakeFrame1 = new TGHorizontalFrame(fFrame11,width,0, kChildFrame|kFixedWidth);
   fData = new TGTextButton(fFakeFrame1, new TGHotString("&Data File"), MGETDATA);
   fData->Connect("Clicked()", "FlukaMainFrame", this, "OpenFile()");
   fData->SetToolTipText("Push to select the data file.");
   fFakeFrame1->AddFrame(fData,fLL5);
   fFrame11->AddFrame(fFakeFrame1,0);
   fFrame1->AddFrame(fFrame11,fL3);

   fFrame14 = new TGHorizontalFrame(fFrame1,0,0);
   fTextInput = new TGTextEntry(fFrame14,"FLUKA Input file", MINPUTFILE);
   fTextInput->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fTextInput->Associate(this);
   fFrame14->AddFrame(fTextInput,fLL4);
   fCloseIB= new TGPictureButton(fFrame14,iClose,MIclose);
   fCloseIB->SetToolTipText("explicitly disconnect FLUKA input file");
   fCloseIB->Connect("Clicked()", "FlukaMainFrame", this, "disconnectFile(int)");
   fFrame14->AddFrame(fCloseIB, new TGLayoutHints(kLHintsCenterY, 3,0,0,0));
   fFakeFrame3 = new TGHorizontalFrame(fFrame14,width,0,kChildFrame|kFixedWidth);
   fInput = new TGTextButton(fFakeFrame3, new TGHotString("&Input File"), MGETINPUT);
   fInput->Connect("Clicked()", "FlukaMainFrame", this, "OpenFile()");
   fInput->SetToolTipText("Push to select the input file.");
   fFakeFrame3->AddFrame(fInput,fLL5);
   fFrame14->AddFrame(fFakeFrame3,0);
   fFrame1->AddFrame(fFrame14,fL3);

   fEmpty0 = new TGLabel(fFrame1," ");
   fFrame1->AddFrame(fEmpty0,fL6);

   fFrame13 = new TGHorizontalFrame(fFrame1,0,0);
   fTextGeom = new TGTextEntry(fFrame13,"pre-processed geometry file (PLOTGEOM)", MGEOMFILE);
   fTextGeom->Associate(this);
   fTextGeom->SetBackgroundColor(grey->GetPixel());
   fTextGeom->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fFrame13->AddFrame(fTextGeom,fLL4);
   fCloseGB= new TGPictureButton(fFrame13,iClose,MGclose);
   fCloseGB->SetToolTipText("explicitly disconnect PLOTGEOM file");
   fCloseGB->Connect("Clicked()", "FlukaMainFrame", this, "disconnectFile()");
   fFrame13->AddFrame(fCloseGB, new TGLayoutHints(kLHintsCenterY, 3,0,0,0));
   fFakeFrame2 = new TGHorizontalFrame(fFrame13,width,0,kChildFrame|kFixedWidth);
   fGeom = new TGTextButton(fFakeFrame2, "Geometry File", MGETGEOM);
   fGeom->Connect("Released()", "FlukaMainFrame", this, "OpenFile()");
   fGeom->SetToolTipText("Push to select a traditional PLOTGEOM.STORE geometry file - DEPRECATED");
   fFakeFrame2->AddFrame(fGeom,fLL5);
   fFrame13->AddFrame(fFakeFrame2,0);
   fFrame1->AddFrame(fFrame13,fL3);


   fFrameDecor0 = new TGHorizontalFrame(fFrame1,0,_sepheight,_sepshape);
   fFrameDecor0->SetBackgroundColor(matt->GetPixel());
   fFrame1->AddFrame(fFrameDecor0,fL3);


// --- add a status field to the first tab in order to display usrbin file info

   fFrame5 = new TGCompositeFrame(fFrame1,0,0,0);

   fTitleFrame5 = new TGCompositeFrame(fFrame5,0,0,0);
// ---
   fTitleUsr0 = new TGLabel(fTitleFrame5,"connected USRBIN data file", myGC(),myFont->GetFontStruct());
   fTitleUsr1 = new TGLabel(fTitleFrame5,"");
   fTitleUsr2 = new TGLabel(fTitleFrame5,"Title:");
   fTitleUsr3 = new TGLabel(fTitleFrame5,"Events:");
   fTitleUsr4 = new TGLabel(fTitleFrame5,"Binnings:");
   fTitleUsr5 = new TGLabel(fTitleFrame5,"Date:");
   fTitleFrame5->AddFrame(fTitleUsr0,fL9);
   fTitleFrame5->AddFrame(fTitleUsr1,fL9);
   fTitleFrame5->AddFrame(fTitleUsr2,fL9);
   fTitleFrame5->AddFrame(fTitleUsr3,fL9);
   fTitleFrame5->AddFrame(fTitleUsr4,fL9);
   fTitleFrame5->AddFrame(fTitleUsr5,fL9);
// ---
   fFrame5->AddFrame(fTitleFrame5,fL3);
   fFrame1->AddFrame(fFrame5,fL00);

   fTitleFrame5->SetBackgroundColor(grey->GetPixel());
   fTitleUsr0->SetBackgroundColor(grey->GetPixel());
   fTitleUsr1->SetBackgroundColor(grey->GetPixel());
   fTitleUsr2->SetBackgroundColor(grey->GetPixel());
   fTitleUsr3->SetBackgroundColor(grey->GetPixel());
   fTitleUsr4->SetBackgroundColor(grey->GetPixel());
   fTitleUsr5->SetBackgroundColor(grey->GetPixel());
// ---
   fFrame1->HideFrame(fFrame5);


// --- add a status field to the first tab in order to display geometry file info
//     maybe we move this later into it's own tab - (4) which is sorta there already

   fFrame4 = new TGCompositeFrame(fFrame1,0,0,0);

   fTitleFrame4 = new TGCompositeFrame(fFrame4,0,0,0);
// ---
   fTitleGeo0 = new TGLabel(fTitleFrame4,"connected PLOTGEOM.STORE like geometry file");
   fTitleGeo1 = new TGLabel(fTitleFrame4,"");
   fTitleGeo2 = new TGLabel(fTitleFrame4,"Title:");
   fTitleGeo3 = new TGLabel(fTitleFrame4,"Date:");
   fTitleGeo4 = new TGLabel(fTitleFrame4,"Orientation:");
   fTitleGeo5 = new TGLabel(fTitleFrame4,"Limits:");
   fTitleFrame4->AddFrame(fTitleGeo0,fL9);
   fTitleFrame4->AddFrame(fTitleGeo1,fL9);
   fTitleFrame4->AddFrame(fTitleGeo2,fL9);
   fTitleFrame4->AddFrame(fTitleGeo3,fL9);
   fTitleFrame4->AddFrame(fTitleGeo4,fL9);
   fTitleFrame4->AddFrame(fTitleGeo5,fL9);
// ---
   fFrame4->AddFrame(fTitleFrame4,fL3);
   fFrame1->AddFrame(fFrame4,fL00);

   fTitleFrame4->SetBackgroundColor(grey->GetPixel());
   fTitleGeo0->SetBackgroundColor(grey->GetPixel());
   fTitleGeo1->SetBackgroundColor(grey->GetPixel());
   fTitleGeo2->SetBackgroundColor(grey->GetPixel());
   fTitleGeo3->SetBackgroundColor(grey->GetPixel());
   fTitleGeo4->SetBackgroundColor(grey->GetPixel());
   fTitleGeo5->SetBackgroundColor(grey->GetPixel());
// ---
   fFrame1->HideFrame(fFrame4);


// --- add a status field to the first tab in order to display FLUKA input file info

   fFrame6 = new TGCompositeFrame(fFrame1,0,0,0);

   fTitleFrame6 = new TGCompositeFrame(fFrame6,0,0,0);
// ---
   fTitleInp0 = new TGLabel(fTitleFrame6,"connected FLUKA input file", myGC(),myFont->GetFontStruct());
   fTitleInp1 = new TGLabel(fTitleFrame6,"");
   fTitleInp3 = new TGLabel(fTitleFrame6,"external geometry file from:");
   fTitleInp3n = new TGLabel(fTitleFrame6,"empty");
   fTitleInp2 = new TGLabel(fTitleFrame6,"geometry title:");
   fTitleInp4 = new TGLabel(fTitleFrame6,"FLUKA input file, Date:");
   fTitleInp5 = new TGLabel(fTitleFrame6,"corresponding FLUKA run title:");
   fTitleInp6 = new TGLabel(fTitleFrame6,"empty:");
   fTitleFrame6->AddFrame(fTitleInp0,fL9);
   fTitleFrame6->AddFrame(fTitleInp1,fL9);
   fTitleFrame6->AddFrame(fTitleInp3,fL9);
   fTitleFrame6->AddFrame(fTitleInp3n,fL9);
   fTitleFrame6->AddFrame(fTitleInp2,fL9);
   fTitleFrame6->AddFrame(fTitleInp4,fL9);
   fTitleFrame6->AddFrame(fTitleInp5,fL9);
   fTitleFrame6->AddFrame(fTitleInp6,fL9);
// ---
   fFrame6->AddFrame(fTitleFrame6,fL3);
   fFrame1->AddFrame(fFrame6,fL00);

   fTitleFrame6->SetBackgroundColor(grey->GetPixel());
   fTitleInp0->SetBackgroundColor(grey->GetPixel());
   fTitleInp1->SetBackgroundColor(grey->GetPixel());
   fTitleInp2->SetBackgroundColor(grey->GetPixel());
   fTitleInp3->SetBackgroundColor(grey->GetPixel());
   fTitleInp3n->SetBackgroundColor(grey->GetPixel());
   fTitleInp4->SetBackgroundColor(grey->GetPixel());
   fTitleInp5->SetBackgroundColor(grey->GetPixel());
   fTitleInp6->SetBackgroundColor(grey->GetPixel());
// ---
   fFrame1->HideFrame(fFrame6);


   fTitleFrame1B = new TGCompositeFrame(fFrame1,0,0,0);

    TString astr(" pwd: "); astr+= gSystem->WorkingDirectory();
    fTitle1B = new TGLabel(fTitleFrame1B, astr);  //-(bold)- , myGC(),myFont->GetFontStruct());
    fTitle1B->SetTextColor(red);
    fTitle1B->SetBackgroundColor(grey->GetPixel());
    fTitleFrame1B->AddFrame(fTitle1B,0);

    if (_userRoutines) {
      TString bstr(" user routines:");
      for (int i=0;i<nrOfUserRoutines;i++) { bstr+= " "; bstr+= one(i); bstr+= " "; bstr+= theirDates[i]; bstr+= "  "; }
      fTitle2B = new TGLabel(fTitleFrame1B, bstr);
      fTitle2B->SetTextColor(red);
      fTitle2B->SetBackgroundColor(grey->GetPixel());
      fTitleFrame1B->AddFrame(fTitle2B,0); }

   fTitleFrame1B->SetBackgroundColor(grey->GetPixel());
   fFrame1->AddFrame(fTitleFrame1B, new TGLayoutHints(kLHintsBottom|kLHintsExpandX, 2,2,0,2));

}



