
//
//    (feb'07 19-02:07) - version v.07a
//                                                                                 the FLEUR project
// -------------------------------------------------------------------------------------------------
//                                                                                anton.empl@cern.ch
//                                                                                  Matt LeBourgeois
// --- FLUKA user back-end project -Fbe-
//     this is part of the main class - set up the GUI and make use of the Fbe classes
//


#ifndef FlukaMainFrame_h
#include "FlukaMainFrame.h"
#endif

void FlukaMainFrame::AddTab2(TGCompositeFrame *tab2)
{
   fFrame2 = tab2;

// --- titles

   fTitleFrame2 = new TGCompositeFrame(fFrame2,0,0,0);
   fText3 = new TGLabel(fTitleFrame2, "flukaGUI - dec'04/aug'07");
   fText4 = new TGLabel(fTitleFrame2, "");
   fText2 = new TGLabel(fTitleFrame2, "Title Stuff From File");
   fText5 = new TGLabel(fTitleFrame2, "file");
   fText1 = new TGLabel(fTitleFrame2, "binnings");
   fText0 = new TGLabel(fTitleFrame2, "single/multiple - date");
   fTitleFrame2->AddFrame(fText3,fL9);
   fTitleFrame2->AddFrame(fText4,fL9);
   fTitleFrame2->AddFrame(fText5,fL9);
   fTitleFrame2->AddFrame(fText2,fL9);
   fTitleFrame2->AddFrame(fText1,fL9);
   fTitleFrame2->AddFrame(fText0,fL9);
   fFrame2->AddFrame(fTitleFrame2,fL0);

   fTitleFrame2->SetBackgroundColor(grey->GetPixel());
   fText2->SetBackgroundColor(grey->GetPixel());
   fText5->SetBackgroundColor(grey->GetPixel());
   fText3->SetBackgroundColor(grey->GetPixel());
   fText4->SetBackgroundColor(grey->GetPixel());
   fText1->SetBackgroundColor(grey->GetPixel());
   fText0->SetBackgroundColor(grey->GetPixel());

// --- binning stuff, all dependent on input file
//     just creating it so it will be ready

   fFrameDecor5 = new TGHorizontalFrame(fFrame2,0,_sepheight,_sepshape);
   fFrameDecor5->SetBackgroundColor(matt->GetPixel());
   fFrame2->AddFrame(fFrameDecor5, fL3);

   fBinningTitle = new TGLabel(fFrame2,"Please select one of these Binnings: ");
   fFrame2->AddFrame(fBinningTitle,fL6);

   fBinningFrame = new TGComboBox(fFrame2,MBINNING);
   fBinningFrame->SetHeight(20);
   fBinningFrame->AddEntry("Empty",1000);
   fBinningFrame->Associate(this);
   fFrame2->AddFrame(fBinningFrame,fL2);

   fFrameDecor4 = new TGHorizontalFrame(fFrame2,0,_sepheight,_sepshape);
   fFrameDecor4->SetBackgroundColor(matt->GetPixel());
   fFrame2->AddFrame(fFrameDecor4, fL3);


// --- XYZ buttons

   fXYZButtonGroup= new TGHButtonGroup(fFrame2,"select view plane ");
   fXYButton= new TGRadioButton(fXYZButtonGroup, " ", MXY);
   _xyLx= new TGLabel(fXYZButtonGroup,"X"); fXYZButtonGroup->AddFrame(_xyLx, new TGLayoutHints(kLHintsLeft,-9,0,3,-7));
   _xyLy= new TGLabel(fXYZButtonGroup,"Y"); fXYZButtonGroup->AddFrame(_xyLy, new TGLayoutHints(kLHintsLeft,0,12,3,-7));
   fXYButton->Associate(this);
   fXYButton->SetToolTipText("press to view the XY plane");

   fYZButton= new TGRadioButton(fXYZButtonGroup, " ", MYZ);
   fYZButton->Associate(this);
   _yzLy= new TGLabel(fXYZButtonGroup,"Y"); fXYZButtonGroup->AddFrame(_yzLy, new TGLayoutHints(kLHintsLeft,-9,0,3,-7));
   _yzLz= new TGLabel(fXYZButtonGroup,"Z"); fXYZButtonGroup->AddFrame(_yzLz, new TGLayoutHints(kLHintsLeft,0,12,3,-7));
   fYZButton->SetToolTipText("press to view the YZ plane");

   fZXButton= new TGRadioButton(fXYZButtonGroup, "ZX ", MZX);
   fZXButton->Associate(this);
   fZXButton->SetToolTipText("press to view the ZX plane");
   fXYZButtonGroup->Show();

// fXYZButtonGroup->Connect("Clicked(Int_t)","FlukaMainFrame",this,"ChangePlane(Int_t)");

   fXYZButtonGroup->SetExclusive(kTRUE);
   fXYZButtonGroup->SetLayoutHints(new TGLayoutHints(kLHintsLeft,4,4,2,-7), fXYButton);
   fXYZButtonGroup->SetLayoutHints(new TGLayoutHints(kLHintsLeft,4,4,2,-7), fYZButton);
   fXYZButtonGroup->SetLayoutHints(new TGLayoutHints(kLHintsLeft,4,4,2,-7), fZXButton);
   fFrame2->AddFrame(fXYZButtonGroup,new TGLayoutHints(kLHintsTop,2,2,4,4));


// --- values for binnings settings

   fFrame200= new TGHorizontalFrame(fFrame2,0,0);

   fFrame201= new TGVerticalFrame(fFrame200,0,0);
   fBinLabels= new TGVerticalLayout(fFrame201);

   fLabel= new TGLabel(fFrame201, " "); fFrame201->AddFrame(fLabel, new TGLayoutHints(kLHintsNormal, 0,0,5,5));
   fPlane1= new TGLabel(fFrame201,"X"); fFrame201->AddFrame(fPlane1, new TGLayoutHints(kLHintsNormal, 0,0,4,4));

   _yp= new TGHorizontalFrame(fFrame201,0,0);
   fPlane2= new TGLabel(_yp,"Y"); _yp->AddFrame(fPlane2,0); 
   fPlane2g= new TGLabel(_yp,"",greekGC(),greekFont->GetFontStruct()); _yp->AddFrame(fPlane2g,0);
   fFrame201->AddFrame(_yp, new TGLayoutHints(kLHintsNormal, 0,0,4,4));

   fPlane3= new TGLabel(fFrame201,"Z"); fFrame201->AddFrame(fPlane3,new TGLayoutHints(kLHintsNormal, 0,0,4,4));
   fFrame200->AddFrame(fFrame201, new TGLayoutHints(kLHintsNormal, 2,2,0,0));

   fFrame21= new TGCompositeFrame(fFrame200, 0, 0, 0);
   fBinMatrix= new TGMatrixLayout(fFrame21, 4, 4, 2);
   fFrame21->SetLayoutManager(fBinMatrix);
   fMinLabel= new TGLabel(fFrame21, "    Min");
   fFrame21->AddFrame(fMinLabel,0);
   fMaxLabel= new TGLabel(fFrame21, "    Max");
   fFrame21->AddFrame(fMaxLabel,0);

   fAllowReBin= new TGTextButton(fFrame21,"       Bins      ",MALLOWREBIN);
   fAllowReBin->Connect("Clicked()","FlukaMainFrame",this,"AllowReBinSlot()");
   fAllowReBin->SetToolTipText("(Deprecated Feature!) Rebin only applies to range already selected -"
                               " click again to revert to original binning");
   fFrame21->AddFrame(fAllowReBin,0);

   fBinSizeLabel= new TGLabel(fFrame21, "    Bin Size");
   fFrame21->AddFrame(fBinSizeLabel,0);

   Double_t dummy[2]={0,1};
   fXMin= new TGBinEntry(fFrame21,dummy,2,10,MXMIN);
   fXMin->Associate(this);
   fFrame21->AddFrame(fXMin,0);
   fXMax= new TGBinEntry(fFrame21,dummy,2,10,MXMAX);
   fXMax->Associate(this);
   fFrame21->AddFrame(fXMax,0);
   fXBin= new TGBinEntry(fFrame21,dummy,2,10,MXBIN);
   fXBin->Associate(this);
   fFrame21->AddFrame(fXBin,0);
   fXBinSize= new TGNumberEntry(fFrame21,0,10,MXBINSIZE,TGNumberEntry::kNESRealThree);
   fXBinSize->SetState(kFALSE);
   fXBinSize->Associate(this);
   fFrame21->AddFrame(fXBinSize,0);

   fYMin= new TGBinEntry(fFrame21,dummy,2,10,MYMIN);
   fYMin->Associate(this);
   fFrame21->AddFrame(fYMin,0);
   fYMax= new TGBinEntry(fFrame21,dummy,2,10,MYMAX);
   fYMax->Associate(this);
   fFrame21->AddFrame(fYMax,0);
   fYBin= new TGBinEntry(fFrame21,dummy,2,10,MYBIN);
   fYBin->Associate(this);
   fFrame21->AddFrame(fYBin,0);
   fYBinSize= new TGNumberEntry(fFrame21,0,10,MYBINSIZE,TGNumberEntry::kNESRealThree);
   fFrame21->AddFrame(fYBinSize,0);
   fYBinSize->SetState(kFALSE);
   fYBinSize->Associate(this);

   fZMin= new TGBinEntry(fFrame21,dummy,2,10,MZMIN);
   fZMin->Associate(this);
   fFrame21->AddFrame(fZMin,0);
   fZMax= new TGBinEntry(fFrame21,dummy,2,10,MZMAX);
   fZMax->Associate(this);
   fFrame21->AddFrame(fZMax,0);
   fZBin= new TGBinEntry(fFrame21,dummy,2,10,MZBIN);
   fZBin->Associate(this);
   fFrame21->AddFrame(fZBin,0);
   fZBinSize= new TGNumberEntry(fFrame21,0,10,MZBINSIZE,TGNumberEntry::kNESRealThree);
   fFrame21->AddFrame(fZBinSize,fL9);
   fZBinSize->SetState(kFALSE);
   fZBinSize->Associate(this);

   fXMin->GetNumberEntry()->Connect("ReturnPressed()","FlukaMainFrame",this,"entered()");
   fXMin->GetNumberEntry()->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fXMin->GetNumberEntry()->Connect("HandleFocusChange(Event_t*)","FlukaMainFrame",this,"FocusChangeSlot(Event_t*)");
   fXMax->GetNumberEntry()->Connect("ReturnPressed()","FlukaMainFrame",this,"entered()");
   fXMax->GetNumberEntry()->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fXMax->GetNumberEntry()->Connect("HandleFocusChange(Event_t*)","FlukaMainFrame",this,"FocusChangeSlot(Event_t*)");
   fYMin->GetNumberEntry()->Connect("ReturnPressed()","FlukaMainFrame",this,"entered()");
   fYMin->GetNumberEntry()->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fYMin->GetNumberEntry()->Connect("HandleFocusChange(Event_t*)","FlukaMainFrame",this,"FocusChangeSlot(Event_t*)");
   fYMax->GetNumberEntry()->Connect("ReturnPressed()","FlukaMainFrame",this,"entered()");
   fYMax->GetNumberEntry()->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fYMax->GetNumberEntry()->Connect("HandleFocusChange(Event_t*)","FlukaMainFrame",this,"FocusChangeSlot(Event_t*)");
   fZMin->GetNumberEntry()->Connect("ReturnPressed()","FlukaMainFrame",this,"entered()");
   fZMin->GetNumberEntry()->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fZMin->GetNumberEntry()->Connect("HandleFocusChange(Event_t*)","FlukaMainFrame",this,"FocusChangeSlot(Event_t*)");
   fZMax->GetNumberEntry()->Connect("ReturnPressed()","FlukaMainFrame",this,"entered()");
   fZMax->GetNumberEntry()->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fZMax->GetNumberEntry()->Connect("HandleFocusChange(Event_t*)","FlukaMainFrame",this,"FocusChangeSlot(Event_t*)");

   fXBin->GetNumberEntry()->Connect("ReturnPressed()","FlukaMainFrame",this,"UpdateHistogram()");
   fYBin->GetNumberEntry()->Connect("ReturnPressed()","FlukaMainFrame",this,"UpdateHistogram()");
   fZBin->GetNumberEntry()->Connect("ReturnPressed()","FlukaMainFrame",this,"UpdateHistogram()");
   fXBin->GetNumberEntry()->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fYBin->GetNumberEntry()->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fZBin->GetNumberEntry()->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fXBin->GetNumberEntry()->Connect("HandleFocusChange(Event_t*)","FlukaMainFrame",this,"FocusChangeSlot(Event_t*)");
   fYBin->GetNumberEntry()->Connect("HandleFocusChange(Event_t*)","FlukaMainFrame",this,"FocusChangeSlot(Event_t*)");
   fZBin->GetNumberEntry()->Connect("HandleFocusChange(Event_t*)","FlukaMainFrame",this,"FocusChangeSlot(Event_t*)");

   fFrame200->AddFrame(fFrame21,0);
   fFrame2->AddFrame(fFrame200,fL2);


   fFrameDecor7= new TGHorizontalFrame(fFrame2,0,_sepheight,_sepshape);
   fFrameDecor7->SetBackgroundColor(matt->GetPixel());
   fFrame2->AddFrame(fFrameDecor7, fL3);

// --- other small stuff

   fFrame22= new TGHorizontalFrame(fFrame2,0,0);
   fHistoIt2= new TGTextButton(fFrame22, "Update Hist", MHISTOIT2);
   fHistoIt2->Connect("Released()", "FlukaMainFrame", this, "FakeSlot()");
   fFrame22->AddFrame(fHistoIt2,fL2);
   fReset=  new TGTextButton(fFrame22,"Reset Histogram", MRESET);
   fReset->Connect("Clicked()","FlukaMainFrame",this,"ResetHist()");
   fFrame22->AddFrame(fReset,fL2);
   fFrame2->AddFrame(fFrame22,fL3);


   fFrameDecor10= new TGHorizontalFrame(fFrame2,0,_sepheight,_sepshape);
   fFrameDecor10->SetBackgroundColor(matt->GetPixel());
   fFrame2->AddFrame(fFrameDecor10,fL3);

   fFrame23= new TGHorizontalFrame(fFrame2,0,0);

   fSliceBG= new TGVButtonGroup(fFrame23,"Chose Type");
   fSlice= new TGRadioButton(fSliceBG,"Slice",MSLICE);
   fSlice->Connect("Pressed()","FlukaMainFrame",this,"SliceSlot()");
   fSlice->SetToolTipText("Click to Select a Slice");
   fProjection= new TGRadioButton(fSliceBG,"Projection",MPROJECTION);
   fProjection->SetToolTipText("Click to Select Projection");
   fProjection->Connect("Pressed()","FlukaMainFrame",this,"ProjectionSlot()");
   fSliceBG->Show();

   fFrame23->AddFrame(fSliceBG,fL3);

   fViewBG= new TGVButtonGroup(fFrame23,"Chose Direction");
   fXProj= new TGRadioButton(fViewBG,"Vertical",MXPROJ);
   fXProj->Associate(this);
   fXProj->SetToolTipText("Select to Get Vertical Projection");
   fYProj= new TGRadioButton(fViewBG,"Horizontal",MYPROJ);
   fYProj->Associate(this);
   fYProj->SetToolTipText("Select to Get Horizontal Projection");
   fViewBG->Show();
   fFrame23->AddFrame(fViewBG,fL3);

   fFrame2->AddFrame(fFrame23,fL2);

   fFrame24= new TGHorizontalFrame(fFrame2,0,0);
//---------------------------------------------------
   fProjectIt= new TGTextButton(fFrame24,"dynamic slices",MPROJECTIT);
   fProjectIt->Connect("Clicked()","FlukaMainFrame",this,"CreateProjection()");
   fProjectIt->SetToolTipText("pop open a second canvas with either a projection or dynamical slices of the histogram");
   fFrame24->AddFrame(fProjectIt,fL3);
//---------------------------------------------------
   fFrame25= new TGHorizontalFrame(fFrame24,0,0);

   fProjLabel1= new TGLabel(fFrame25, "Integration Min: ");
   fFrame25->AddFrame(fProjLabel1,fL5);
   fProjMin= new TGBinEntry(fFrame25,dummy,2,7,MPROJMIN);
   fProjMin->GetNumberEntry()->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fProjMin->Associate(this);
   fFrame25->AddFrame(fProjMin);

   fProjLabel2= new TGLabel(fFrame25, " Max: ");
   fFrame25->AddFrame(fProjLabel2,fL5);
   fProjMax= new TGBinEntry(fFrame25,dummy,2,7,MPROJMAX);
   fProjMax->GetNumberEntry()->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fProjMax->Associate(this);
   fFrame25->AddFrame(fProjMax);

   fFrame24->AddFrame(fFrame25,fLL2);
//---------------------------------------------------
   fFrame2->AddFrame(fFrame24,fL3);

   fXProj->SetOn();
   fSlice->SetOn();
   fFrame24->HideFrame(fFrame25);

}
