
//
//    (feb'07 19-02:07) - version v.07a
//                                                                                 the FLEUR project
// -------------------------------------------------------------------------------------------------
//                                                                                anton.empl@cern.ch
//                                                                                  Matt LeBourgeois
// --- FLUKA user back-end project -Fbe-
//     this is part of the main class - set up the GUI and make use of the Fbe classes
//

//
// --- sep'06 11-12:17
//     well, all these tabs should be their own classes or something, yet they were
//     started at a time where the root gui stuff lacked terribly in features, consistency
//     and a clear concept
//


#ifndef FlukaMainFrame_h
#include "FlukaMainFrame.h"
#endif


void FlukaMainFrame::AddTab3(TGCompositeFrame *tab3)
{

   fFrame3 = tab3;

   fFrameDecor1 = new TGHorizontalFrame(fFrame3,0,_sepheight,_sepshape);
   fFrameDecor1->SetBackgroundColor(matt->GetPixel());
   fFrameDecor2 = new TGHorizontalFrame(fFrame3,0,_sepheight,_sepshape);
   fFrameDecor2->SetBackgroundColor(matt->GetPixel());
   fFrameDecor3 = new TGHorizontalFrame(fFrame3,0,_sepheight,_sepshape);
   fFrameDecor3->SetBackgroundColor(matt->GetPixel());

   fTitleFrame3= new TGCompositeFrame(fFrame3,0,0,0);
   fGraphIntro0= new TGLabel(fTitleFrame3, "flukaGui - dec'04/aug'07");
   fGraphIntro1= new TGLabel(fTitleFrame3, "");
   fGraphIntro2= new TGLabel(fTitleFrame3, "customize the Graph/Histogram parameters - if in doubt press");
   fGraphIntro3= new TGLabel(fTitleFrame3, "\"Histogram It\" to apply changes");
   fGraphIntro4= new TGLabel(fTitleFrame3, "");
   fGraphIntro5= new TGLabel(fTitleFrame3, "low/high");

   fTitleFrame3->AddFrame(fGraphIntro0,fL9);
   fTitleFrame3->AddFrame(fGraphIntro1,fL9);
   fTitleFrame3->AddFrame(fGraphIntro2,fL9);
   fTitleFrame3->AddFrame(fGraphIntro3,fL9);
   fTitleFrame3->AddFrame(fGraphIntro4,fL9);
   fTitleFrame3->AddFrame(fGraphIntro5,fL9);
   fFrame3->AddFrame(fTitleFrame3,fL0);

   fTitleFrame3->SetBackgroundColor(grey->GetPixel());
   fGraphIntro0->SetBackgroundColor(grey->GetPixel());
   fGraphIntro1->SetBackgroundColor(grey->GetPixel());
   fGraphIntro2->SetBackgroundColor(grey->GetPixel());
   fGraphIntro3->SetBackgroundColor(grey->GetPixel());
   fGraphIntro4->SetBackgroundColor(grey->GetPixel());
   fGraphIntro5->SetBackgroundColor(grey->GetPixel());

   fFrameDecor8= new TGHorizontalFrame(fFrame3,0,_sepheight,_sepshape);
   fFrameDecor8->SetBackgroundColor(matt->GetPixel());
   fFrame3->AddFrame(fFrameDecor8, fL3);

// ---

   fFrame32 = new TGHorizontalFrame(fFrame3,0,0);
   fGraphTitleWords = new TGLabel(fFrame32,"Graph Title:  ");
   fGraphTitle = new TGTextEntry(fFrame32, "histogram title", MGRAPHTITLE);
   fGraphTitle->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fGraphTitle->Associate(this);
   fFrame32->AddFrame(fGraphTitleWords,fL5);
   fFrame32->AddFrame(fGraphTitle, fL2);
   fFrame3->AddFrame(fFrame32, new TGLayoutHints(kLHintsCenterX|kLHintsExpandX, 2,2,1,1));

// --- mar'06 03-01:15

   fFrame33= new TGHorizontalFrame(fFrame3,0,0);
   fXTitleWords = new TGLabel(fFrame33,"X-Axis Title: ");
   fXTitle= new TGTextEntry(fFrame33, "x(cm)", MXTITLE);
   fXTitle->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fXTitle->Connect("ReturnPressed()","FlukaMainFrame",this,"entered()");
   fXTitle->Connect("HandleFocusChange(Event_t*)","FlukaMainFrame",this,"FocusChangeSlot(Event_t*)");
   fXTitle->Associate(this);
   fFrame33->AddFrame(fXTitleWords,fL5);
   fFrame33->AddFrame(fXTitle,fL2);
   fFrame3->AddFrame(fFrame33, new TGLayoutHints(kLHintsCenterX|kLHintsExpandX, 2,2,1,1));

   fFrame34= new TGHorizontalFrame(fFrame3,0,0);
   fYTitleWords = new TGLabel(fFrame34,"Y-Axis Title: ");
   fYTitle= new TGTextEntry(fFrame34, "y(cm)", MYTITLE);
   fYTitle->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fYTitle->Connect("ReturnPressed()","FlukaMainFrame",this,"entered()");
   fYTitle->Connect("HandleFocusChange(Event_t*)","FlukaMainFrame",this,"FocusChangeSlot(Event_t*)");
   fYTitle->Associate(this);
   fFrame34->AddFrame(fYTitleWords,fL5);
   fFrame34->AddFrame(fYTitle,fL2);
   fFrame3->AddFrame(fFrame34, new TGLayoutHints(kLHintsCenterX|kLHintsExpandX, 2,2,1,1));

// ---

   fFrame35 = new TGHorizontalFrame(fFrame3,0,0);
   fZTitleWords = new TGLabel(fFrame35, "Z-Axis Title: ");
   fZTitle = new TGTextEntry(fFrame35,"", MZTITLE);
   fZTitle->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fZTitle->Connect("ReturnPressed()","FlukaMainFrame",this,"entered()");
   fZTitle->Connect("HandleFocusChange(Event_t*)","FlukaMainFrame",this,"FocusChangeSlot(Event_t*)");
   fZTitle->Associate(this);
   fFrame35->AddFrame(fZTitleWords, fL5);
   fFrame35->AddFrame(fZTitle,fL2);
   fFrame3->AddFrame(fFrame35, new TGLayoutHints(kLHintsCenterX|kLHintsExpandX, 2,2,1,1));

   fFrame3->AddFrame(fFrameDecor2,fL3);


   fFrame31= new TGHorizontalFrame(fFrame3,0,0);
// ---
   fGeometry= new TGCheckButton(fFrame31, "request Geometry overlay", MGEOMETRY);
   fGeometry->Associate(this);
   fFrame31->AddFrame(fGeometry, new TGLayoutHints(kLHintsLeft|kLHintsCenterY, 4,10,0,0));
   fFrame3->AddFrame(fFrame31,fL3);


   fFrame39 = new TGHorizontalFrame(fFrame3,0,0);
   fFrame40 = new TGHorizontalFrame(fFrame39,0,0);

// --- swap axes ---
//
   fSwap= new TGCheckButton(fFrame39,"Swap Axes  ", MSWAP);
   fSwap->SetOn(kFALSE);
   fSwap->Connect("Clicked()","FlukaMainFrame",this,"swap()");
   fSwap->SetToolTipText("in case of static PLOTGEOM.STORE geometry input the geometry is not rotated (yet)");

   fFrame39->AddFrame(fSwap, new TGLayoutHints(kLHintsLeft|kLHintsCenterY, 4,10,0,0));
// ---
   fZNormalize = new TGRadioButton(fFrame40, " Normalize  - ", MZNORMALIZE);
   fZNormalize->Associate(this);
   fZNormalize->SetOn();
   fZScale= new TGRadioButton(fFrame40, "Scale by ", MZSCALE);
   fZScale->SetToolTipText("ie. multiply by");
   fZScale->Associate(this);
   fZScaleValue= new TGNumberEntry(fFrame40, .1,9,MZSCALEVALUE);
   fZScaleValue->Associate(this);
   fZScaleValue->GetNumberEntry()->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fZScaleValue->GetNumberEntry()->Connect("HandleFocusChange(Event_t*)","FlukaMainFrame",this,"FocusChangeSlot(Event_t*)");
   fZScaleValue->GetNumberEntry()->Connect("ReturnPressed()","FlukaMainFrame",this,"entered()");

   fFrame40->AddFrame(fZScaleValue,fLL6);
   fFrame40->AddFrame(fZScale,fLL6);
   fFrame40->AddFrame(fZNormalize,fLL6);

   fFrame39->AddFrame(fFrame40, new TGLayoutHints(kLHintsExpandX|kLHintsCenterY, 0,0,0,0));
   fFrame3->AddFrame(fFrame39,fL3);
//
// ---
//
   _aspectBG= new TGHButtonGroup(fFrame3,"aspect ratio");
   _preserve= new TGCheckButton(_aspectBG,"force 1:1   ",Mpreserve);
   _preserve->SetDown(kFALSE);
   _manually= new TGCheckButton(_aspectBG,"set manually x/y  ", Mmanually);
   _manually->SetDown(kFALSE);
   _aspectBG->Insert(_preserve,0);
   _aspectBG->SetLayoutHints(new TGLayoutHints(kLHintsLeft,0,0,2,-7), _preserve);
   _aspectBG->Insert(_manually,1);
   _aspectBG->SetLayoutHints(new TGLayoutHints(kLHintsLeft,0,0,2,-7), _manually);
   _aspectBG->Show();

   _ratio= new TGNumberEntry(_aspectBG,1,9,Mratio);
   _ratio->GetNumberEntry()->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   _ratio->GetNumberEntry()->Connect("ReturnPressed()","FlukaMainFrame",this,"UpdateHistogram()");
   _ratio->SetState(kFALSE);
   _ratio->Associate(this);
   _aspectBG->AddFrame(_ratio, new TGLayoutHints(kLHintsLeft,0,0,1,-7));

   _preserve->Associate(this);
   _manually->Associate(this);

   fFrame3->AddFrame(_aspectBG, new TGLayoutHints(kLHintsTop|kLHintsCenterX,2,2,0,5));
//
// ---
//
   fFrame3010 = new TGHorizontalFrame(fFrame3,0,0);

   fLogCheck = new TGCheckButton(fFrame3010,"Logarithmic", MLOGCHECK);
   fLogCheck->SetOn();
   fLogCheck->Associate(this);
// fLogCheck->SetToolTipText("not fully implemented yet");   --- why? sep'06 11-14:36
   fFrame3010->AddFrame(fLogCheck, new TGLayoutHints(kLHintsCenterY, 4,7,0,0));

   fEnableColor = new TGCheckButton(fFrame3010,"Enable Color Palette ", MENABLECOLOR);
   fEnableColor->SetOn();
   fEnableColor->Associate(this);
   fEnableColor->Connect("Clicked()","FlukaMainFrame",this,"UpdateHistogram()");

   fColorLabel = new TGLabel(fFrame3010, "  ColorsPerDecade ");
   fColorPerDec = new TGNumberEntry(fFrame3010,0,5,MCOLORPERDEC);
   fColorPerDec->GetNumberEntry()->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fColorPerDec->GetNumberEntry()->Connect("ReturnPressed()","FlukaMainFrame",this,"UpdateHistogram()");
   fColorPerDec->SetButtonToNum(kFALSE);
   fColorPerDec->Associate(this);
   fFrame3010->AddFrame(fColorPerDec,fLL6);
   fFrame3010->AddFrame(fColorLabel, new TGLayoutHints(kLHintsRight|kLHintsBottom, 2,0,0,2));
   fFrame3010->AddFrame(fEnableColor,fLL6);

   fFrame3->AddFrame(fFrame3010,fL3);


   fFrame3011 = new TGHorizontalFrame(fFrame3,0,0);

   fPrintOptCheck = new TGCheckButton(fFrame3011,"FLUKA Color Scheme", MPRINTOPTCHECK);
   fPrintOptCheck->SetOn();
   fPrintOptCheck->Associate(this);
   fPrintOptCheck->Connect("Clicked()","FlukaMainFrame",this,"UpdateHistogram()");
   fPrintOptCheck->SetToolTipText("Select Printer Optimized Color Palette Traditionally Used for FLUKA 2D Graphs");
   fFrame3011->AddFrame(fPrintOptCheck, new TGLayoutHints(kLHintsLeft, 4,10,0,0));

   _grey = new TGCheckButton(fFrame3011,"grey scale", Mgrey);
   _grey->Associate(this);
   _grey->SetOn(kFALSE);
   fFrame3011->AddFrame(_grey, new TGLayoutHints(kLHintsRight, 10,4,0,0));

   fFrame3->AddFrame(fFrame3011, new TGLayoutHints(kLHintsExpandX, 2,2,3,0));
//
// ---
//
   fFrame38 = new TGHorizontalFrame(fFrame3,0,0);
   fZRange = new TGLabel(fFrame38, "traditional FLUKA palette minimum");
   fZLower = new TGNumberEntry(fFrame38, .1,9,MZLOWER);
   fZLower->GetNumberEntry()->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   fZLower->GetNumberEntry()->Connect("ReturnPressed()","FlukaMainFrame",this,"UpdateHistogram()");
   fZLower->Associate(this);

   fFrame38->AddFrame(fZRange, new TGLayoutHints(kLHintsCenterY, 4,10,0,0));
   fFrame38->AddFrame(fZLower, new TGLayoutHints(kLHintsCenterY, 4,0,0,0));
   fFrame3->AddFrame(fFrame38, new TGLayoutHints(kLHintsExpandX, 2,2,0,0));
//
// ---
//
   fFrame3->AddFrame(fFrameDecor3,fL3);

   fHistoIt= new TGTextButton(fFrame3, "redraw histogram", MHISTOIT);
   fHistoIt->Connect("Released()", "FlukaMainFrame", this, "UpdateHistogram()");
   fFrame3->AddFrame(fHistoIt,fL3);

}
