
//
//    (feb'07 19-02:07) - version v.07a
//                                                                                 the FLEUR project
// -------------------------------------------------------------------------------------------------
//                                                                                anton.empl@cern.ch
//                                                                                  Matt LeBourgeois
// --- FLUKA user back-end project -Fbe-
//     this is part of the main class - set up the GUI and make use of the Fbe classes
//



#ifndef FlukaMainFrame_h
#include "FlukaMainFrame.h"
#endif


void FlukaMainFrame::AddTab4(TGCompositeFrame *tab4)
{

   fFrame7= tab4;

   fTitleFrame7 = new TGCompositeFrame(fFrame7,0,0,0);
   fTitle7Geo0 = new TGLabel(fTitleFrame7,"flukaGUI - dec'04/aug'07");
// fTitle7Geo1 = new TGLabel(fTitleFrame7,"");
   fTitle7Geo7 = new TGLabel(fTitleFrame7,"");
   fTitle7Geo2 = new TGLabel(fTitleFrame7,"geometry information available via FLUKA input file");
   fTitle7Geo3 = new TGLabel(fTitleFrame7,"views along axes are implemented (XY YZ ZX) - initial range");
   fTitle7Geo4 = new TGLabel(fTitleFrame7,"of +/- 50cm in every coordinate is selected");
   fTitle7Geo5 = new TGLabel(fTitleFrame7,"SLOW(?) - many geometry scans are performed");
   fTitleFrame7->AddFrame(fTitle7Geo0,fL9);
// fTitleFrame7->AddFrame(fTitle7Geo1,fL9);
   fTitleFrame7->AddFrame(fTitle7Geo7,fL9);
   fTitleFrame7->AddFrame(fTitle7Geo2,fL9);
   fTitleFrame7->AddFrame(fTitle7Geo3,fL9);
   fTitleFrame7->AddFrame(fTitle7Geo4,fL9);
   fTitleFrame7->AddFrame(fTitle7Geo5,fL9);
   fFrame7->AddFrame(fTitleFrame7,fL0);

   fTitleFrame7->SetBackgroundColor(grey->GetPixel());
   fTitle7Geo0->SetBackgroundColor(grey->GetPixel());
// fTitle7Geo1->SetBackgroundColor(grey->GetPixel());
   fTitle7Geo7->SetBackgroundColor(grey->GetPixel());
   fTitle7Geo2->SetBackgroundColor(grey->GetPixel());
   fTitle7Geo3->SetBackgroundColor(grey->GetPixel());
   fTitle7Geo4->SetBackgroundColor(grey->GetPixel());
   fTitle7Geo5->SetBackgroundColor(grey->GetPixel());

   fGeoDecor0 = new TGHorizontalFrame(fFrame7,0,_sepheight,_sepshape);
   fGeoDecor0->SetBackgroundColor(matt->GetPixel());
   fFrame7->AddFrame(fGeoDecor0, fL3);


   fFrame1G = new TGCompositeFrame(fFrame7,0,0,0);

   fFrame4G= new TGHorizontalFrame(fFrame1G,0,0,0);
   fGeoLabel24= new TGLabel(fFrame4G,"number of scan lines (granularity):   ");
   fFrame4G->AddFrame(fGeoLabel24, fL99);
   fGeoLines= new TGNumberEntry(fFrame4G, 500,5,MGEOLINES,TGNumberEntry::kNESInteger);
   fGeoLines->Associate(this);
   fFrame4G->AddFrame(fGeoLines, fL99);
   _lines= new TGCheckButton(fFrame4G,"set manually   ",GLINES);
   _lines->SetToolTipText(" select to change default which is the number of pixels in canvas ");
   _lines->Associate(this);
   fFrame4G->AddFrame(_lines, new TGLayoutHints(kLHintsRight, 0,0,2,0));
   fFrame1G->AddFrame(fFrame4G, new TGLayoutHints(kLHintsExpandX, 4,4,2,2));

   fFrame2G= new TGHorizontalFrame(fFrame1G,0,0,0);
   fGeoLabel20 = new TGLabel(fFrame2G,"");
   _mode= new TGCheckButton(fFrame2G,"only show boundaries between regions of different material",GMODE);
   _mode->Associate(this);
   fFrame2G->AddFrame(_mode, new TGLayoutHints(kLHintsLeft, 4,4,0,0));
   fFrame2G->AddFrame(fGeoLabel20, new TGLayoutHints(kLHintsLeft, 4,4,0,0));
   fFrame1G->AddFrame(fFrame2G, new TGLayoutHints(kLHintsExpandX, 0,0,2,2));

// --------------------------------------------------

   fFrame7->AddFrame(fFrame1G,fL2);

   fGeoDecor1= new TGHorizontalFrame(fFrame7,0,_sepheight,_sepshape);
   fGeoDecor1->SetBackgroundColor(matt->GetPixel());
   fFrame7->AddFrame(fGeoDecor1, fL3);

//
// --- feb'06 26-21:58
//     try and start a real geometry ONLY tab - first we need to enable input ranges for xyz

   _frame= new TGCompositeFrame(fFrame7,0,0,0);
   _h1box= new TGHorizontalFrame(_frame);

   _buttonGroup= new TGHButtonGroup(_h1box,"select view plane");
   _xyzB[0]= new TGRadioButton(_buttonGroup,"xy ", MGBXY);
   _xyzB[0]->Associate(this);
   _xyzB[1]= new TGRadioButton(_buttonGroup,"yz ", MGBYZ);
   _xyzB[1]->Associate(this);
   _xyzB[2]= new TGRadioButton(_buttonGroup,"zx ", MGBZX);
   _xyzB[2]->Associate(this);
   _buttonGroup->Show();
   _xyzB[0]->SetOn();

   _buttonGroup->SetExclusive(kTRUE);
   _buttonGroup->SetLayoutHints(new TGLayoutHints(kLHintsLeft,4,4,2,-7), _xyzB[0]);
   _buttonGroup->SetLayoutHints(new TGLayoutHints(kLHintsLeft,4,4,2,-7), _xyzB[1]);
   _buttonGroup->SetLayoutHints(new TGLayoutHints(kLHintsLeft,4,4,2,-7), _xyzB[2]);
   _h1box->AddFrame(_buttonGroup,new TGLayoutHints(kLHintsTop,2,2,4,4));

   _redraw= new TGTextButton(_h1box,"  redraw  ",Mredraw);
   _redraw->SetBackgroundColor(matt->GetPixel());
   _redraw->SetTextColor(grey->GetPixel());
   _redraw->Connect("Clicked()","FlukaMainFrame",this,"updateGeometry()");
   _redraw->SetToolTipText(" rescan and redraw the geometry ");
   _h1box->AddFrame(_redraw,new TGLayoutHints(kLHintsCenterX|kLHintsCenterY, 0,0,0,0));

   _frame->AddFrame(_h1box, new TGLayoutHints(kLHintsExpandX, 0,0,0,0));


   _hRanges= new TGHorizontalFrame(_frame,0,0);
   _vaf= new TGVerticalFrame(_hRanges,0,0);
//---
   _hMinLabel= new TGLabel(_vaf," min (cm)");
   _vaf->AddFrame(_hMinLabel, new TGLayoutHints(kLHintsLeft|kLHintsCenterY|kLHintsExpandY, 0,0,0,0));
   _hMaxLabel= new TGLabel(_vaf," max (cm)");
   _vaf->AddFrame(_hMaxLabel, new TGLayoutHints(kLHintsLeft|kLHintsCenterY|kLHintsExpandY, 0,0,0,0));
   _hRanges->AddFrame(_vaf, new TGLayoutHints(kLHintsLeft|kLHintsCenterY|kLHintsExpandY, 0,0,0,0));

   _vbf= new TGVerticalFrame(_hRanges,0,0);
//---
   _hMinFrame= new TGHorizontalFrame(_vbf,0,0);
   _xMinL= new TGLabel(_hMinFrame,"  X "); _hMinFrame->AddFrame(_xMinL,fL98);
   _gco[0]= new TGNumberEntry(_hMinFrame,0,10,MGXL); _hMinFrame->AddFrame(_gco[0],0); _gco[0]->Associate(this);
   _yMinL= new TGLabel(_hMinFrame,"  Y "); _hMinFrame->AddFrame(_yMinL,fL98);
   _gco[2]= new TGNumberEntry(_hMinFrame,0,10,MGYL); _hMinFrame->AddFrame(_gco[2],0); _gco[2]->Associate(this);
   _zMinL= new TGLabel(_hMinFrame,"  Z "); _hMinFrame->AddFrame(_zMinL,fL98);
   _gco[4]= new TGNumberEntry(_hMinFrame,0,10,MGZL); _hMinFrame->AddFrame(_gco[4],0); _gco[4]->Associate(this);
   _vbf->AddFrame(_hMinFrame,fL97);

   _hMaxFrame= new TGHorizontalFrame(_vbf,0,0);
   _xMaxL= new TGLabel(_hMaxFrame,"  X "); _hMaxFrame->AddFrame(_xMaxL,fL98);
   _gco[1]= new TGNumberEntry(_hMaxFrame, 0,10,MGXU); _hMaxFrame->AddFrame(_gco[1],0); _gco[1]->Associate(this);
   _yMaxL= new TGLabel(_hMaxFrame,"  Y "); _hMaxFrame->AddFrame(_yMaxL,fL98);
   _gco[3]= new TGNumberEntry(_hMaxFrame, 0,10,MGYU); _hMaxFrame->AddFrame(_gco[3],0); _gco[3]->Associate(this);
   _zMaxL= new TGLabel(_hMaxFrame,"  Z "); _hMaxFrame->AddFrame(_zMaxL,fL98);
   _gco[5]= new TGNumberEntry(_hMaxFrame, 0,10,MGZU); _hMaxFrame->AddFrame(_gco[5],0); _gco[5]->Associate(this);
   _vbf->AddFrame(_hMaxFrame,fL97);
//---
   _hRanges->AddFrame(_vbf,0);
   _frame->AddFrame(_hRanges, new TGLayoutHints(kLHintsNormal, 0,0,4,2));

   _vzframe= new TGHorizontalFrame(_frame,0,0);
   _zLabel= new TGLabel(_vzframe,"distance of cut plane from origin (cm)");
   _zd= new TGNumberEntry(_vzframe,30,10,MGZD);
   _zd->Associate(this);

   _vzframe->AddFrame(_zd, new TGLayoutHints(kLHintsRight, 4,4,0,0));
   _vzframe->AddFrame(_zLabel, new TGLayoutHints(kLHintsRight, 0,4,4,0));
   _frame->AddFrame(_vzframe, new TGLayoutHints(kLHintsCenterX, 4,4,4,4));

   fFrame7->AddFrame(_frame,fL2);

// ---

   fGeoDecor2 = new TGHorizontalFrame(fFrame7,0,_sepheight,_sepshape);
   fGeoDecor2->SetBackgroundColor(matt->GetPixel());
   fFrame7->AddFrame(fGeoDecor2, fL3);


   fFrame3G= new TGHorizontalFrame(fFrame7,0,0,0);
// --- show histogram ---
   _show= new TGCheckButton(fFrame3G," show histogram ", GSHOW);
   _show->SetOn(kFALSE);
   _show->Connect("Clicked()","FlukaMainFrame",this,"updateGeometry()");
   _show->SetToolTipText("indicate if histogram data should be superimposed");
   fFrame3G->AddFrame(_show, new TGLayoutHints(kLHintsLeft, 0,0,0,0));
// --- show materials ---
   fGeoRegions= new TGCheckButton(fFrame3G,"show FLUKA materials", MREGIONS);
   fGeoRegions->SetToolTipText("this option will create a colormap file (named after the input file) if it does not exist yet");
   fGeoRegions->Connect("Clicked()","FlukaMainFrame",this,"updateGeometry()");
   fGeoRegions->SetOn(kFALSE);
   fFrame3G->AddFrame(fGeoRegions, new TGLayoutHints(kLHintsNormal, 15,0,0,0));
// --- swap axes ---
   _swap= new TGCheckButton(fFrame3G," swap Axes", GSWAP);
   _swap->SetOn(kFALSE);
   _swap->Connect("Clicked()","FlukaMainFrame",this,"updateGeometry()");
   _swap->SetToolTipText("select to swop axes of graph");
   fFrame3G->AddFrame(_swap, new TGLayoutHints(kLHintsRight, 0,2,0,0));
// ---
   fFrame7->AddFrame(fFrame3G, new TGLayoutHints(kLHintsExpandX, 8,4,4,4));


   fFrame6G= new TGHorizontalFrame(fFrame7,0,0,0);

   fGeoButton1= new TGTextButton(fFrame6G,"import from histogram ", PICKUPRANGE);
   fGeoButton1->Connect("Clicked()","FlukaMainFrame",this,"pickRange(int)");
   fFrame6G->AddFrame(fGeoButton1,fL97);

   fGeoButton2= new TGTextButton(fFrame6G,"reset range", RESETRANGE);
   fGeoButton2->Connect("Clicked()","FlukaMainFrame",this,"pickRange(int)");
   fFrame6G->AddFrame(fGeoButton2,fL97);

   fGeoButton3= new TGTextButton(fFrame6G,"max range", MAXRANGE);
   fGeoButton3->Connect("Clicked()","FlukaMainFrame",this,"pickRange(int)");
   fFrame6G->AddFrame(fGeoButton3,fL97);


   const TGPicture *iPlus=openIcon("plus.xpm"),*iMinus=openIcon("minus.xpm");
   fFrame7G= new TGHorizontalFrame(fFrame6G,0,0,0);

   fGeoZoom= new TGLabel(fFrame7G," zoom ");
   fFrame7G->AddFrame(fGeoZoom, new TGLayoutHints(kLHintsLeft, 0,0,8,0));

   fGeoZplus= new TGPictureButton(fFrame7G,iPlus,MzoomP);
   fGeoZplus->Connect("Clicked()","FlukaMainFrame",this,"zoomed()");
   fGeoZplus->SetToolTipText("use left mouse button - zoom back in here if possible (--->,n)");
   fFrame7G->AddFrame(fGeoZplus, new TGLayoutHints(kLHintsLeft, 0,0,4,4));

   fGeoZminus= new TGPictureButton(fFrame7G,iMinus,MzoomM);
   fGeoZminus->Connect("Clicked()","FlukaMainFrame",this,"zoomed()");
   fGeoZminus->SetToolTipText("left mouse button - zoom out here if possible (<---,p)");
   fFrame7G->AddFrame(fGeoZminus, new TGLayoutHints(kLHintsLeft, 0,0,4,4));

   fFrame6G->AddFrame(fFrame7G, new TGLayoutHints(kLHintsRight, 4,4,0,0));
   fFrame7->AddFrame(fFrame6G, new TGLayoutHints(kLHintsCenterX|kLHintsExpandX, 4,4,0,4));

   fFrame9G= new TGHorizontalFrame(fFrame7,0,0,0);
   fGeoColors= new TGCheckButton(fFrame9G,"manual color map", MGCOLOR);
   fGeoColors->SetToolTipText("utilize manually set material colormap, see: InputFile.cmap");
   fGeoColors->SetOn(kFALSE);
   fGeoColors->Connect("Clicked()","FlukaMainFrame",this,"drawGeometry()");
   fFrame9G->AddFrame(fGeoColors, new TGLayoutHints(kLHintsLeft, 4,8,0,0));
   fFrame7->AddFrame(fFrame9G, new TGLayoutHints(kLHintsLeft, 4,4,-4,6));


   fFrameVG= new TGVerticalFrame(fFrame7,0,0,0);

   fFrame5G= new TGHorizontalFrame(fFrameVG,0,0,0);
   fEmpty2= new TGLabel(fFrame5G,"");
   fFrame5G->AddFrame(fEmpty2, new TGLayoutHints(kLHintsLeft, 0,0,0,0));

   fFrame5g= new TGHorizontalFrame(fFrame5G,0,0,0);
   fGeoLmr[0]= new TGLabel(fFrame5g," ");  fFrame5g->AddFrame(fGeoLmr[0], new TGLayoutHints(kLHintsExpandX, 0,0,2,2)); 
   fGeoLmr[1]= new TGLabel(fFrame5g," material ");                           fFrame5g->AddFrame(fGeoLmr[1],fL96);
   fGeoLmr[2]= new TGLabel(fFrame5g,"xxx",mGC(),mf->GetFontStruct());        fFrame5g->AddFrame(fGeoLmr[2],fL95);
   fGeoLmr[3]= new TGLabel(fFrame5g,"-MATERIAL ",mGC(),mf->GetFontStruct()); fFrame5g->AddFrame(fGeoLmr[3],fL95);
   fGeoLmr[4]= new TGLabel(fFrame5g,"    region ");                          fFrame5g->AddFrame(fGeoLmr[4],fL96);
   fGeoLmr[5]= new TGLabel(fFrame5g,"xxxx",mGC(),mf->GetFontStruct());       fFrame5g->AddFrame(fGeoLmr[5],fL95);
   fGeoLmr[6]= new TGLabel(fFrame5g,"-REGION  ",mGC(),mf->GetFontStruct());  fFrame5g->AddFrame(fGeoLmr[6],fL95);
   fGeoLmr[7]= new TGLabel(fFrame5g," ");  fFrame5g->AddFrame(fGeoLmr[7], new TGLayoutHints(kLHintsExpandX, 0,0,2,2)); 
   for (int i=0;i<8;i++) fGeoLmr[i]->SetBackgroundColor(grey->GetPixel());

   fGeoMaterials= new TGLabel(fFrame5g,"");
   fFrame5g->AddFrame(fGeoMaterials, new TGLayoutHints(kLHintsExpandX|kLHintsRight, 0,0,2,0));
   fGeoMaterials->SetBackgroundColor(grey->GetPixel());

   fFrame5g->SetBackgroundColor(grey->GetPixel());
   fFrame5G->AddFrame(fFrame5g, new TGLayoutHints(kLHintsExpandX|kLHintsLeft, 4,4,2,2));

   fFrameVG->AddFrame(fFrame5G, new TGLayoutHints(kLHintsExpandX, 4,4,0,0));


   fFrame8G= new TGHorizontalFrame(fFrameVG,0,0,0);
   fEmpty1= new TGLabel(fFrame8G,"");
   fFrame8G->AddFrame(fEmpty1, new TGLayoutHints(kLHintsLeft, 0,0,0,0));

   fFrame8g= new TGHorizontalFrame(fFrame8G,0,0,0);
   fGeoLco[0]= new TGLabel(fFrame8g," ");  fFrame8g->AddFrame(fGeoLco[0], new TGLayoutHints(kLHintsExpandX, 0,0,2,2));
   fGeoLco[1]= new TGLabel(fFrame8g," coordinates (cm)  X ");  fFrame8g->AddFrame(fGeoLco[1],fL96);
   fGeoLco[2]= new TGLabel(fFrame8g," xxxxxx.xxxxx ");         fFrame8g->AddFrame(fGeoLco[2],fL96);
   fGeoLco[3]= new TGLabel(fFrame8g," Y ");                    fFrame8g->AddFrame(fGeoLco[3],fL96);
   fGeoLco[4]= new TGLabel(fFrame8g," xxxxxx.xxxxx ");         fFrame8g->AddFrame(fGeoLco[4],fL96);
   fGeoLco[5]= new TGLabel(fFrame8g," ");  fFrame8g->AddFrame(fGeoLco[5], new TGLayoutHints(kLHintsExpandX, 0,0,2,2));
   for (int i=0;i<6;i++) fGeoLco[i]->SetBackgroundColor(grey->GetPixel());
   fFrame8g->SetBackgroundColor(grey->GetPixel());
   fFrame8G->AddFrame(fFrame8g, new TGLayoutHints(kLHintsExpandX|kLHintsLeft, 4,4,2,2));

   fFrameVG->AddFrame(fFrame8G, new TGLayoutHints(kLHintsExpandX, 4,4,0,0));

   fFrame7->AddFrame(fFrameVG, new TGLayoutHints(kLHintsLeft, 4,4,6,6));

// 
// ---
   fGeoDecor3 = new TGHorizontalFrame(fFrame7,0,_sepheight,_sepshape);
   fGeoDecor3->SetBackgroundColor(matt->GetPixel());
   fFrame7->AddFrame(fGeoDecor3, fL3);
// ---
// 
   _aspectBGg= new TGHButtonGroup(fFrame7,"aspect ratio");
   _preserveG= new TGCheckButton(_aspectBGg,"force 1:1   ",Gpreserve);
   _preserveG->SetDown(kFALSE);
   _manuallyG= new TGCheckButton(_aspectBGg,"set manually x/y  ", Gmanually);
   _manuallyG->SetDown(kFALSE);
   _aspectBGg->Insert(_preserveG,0);
   _aspectBGg->SetLayoutHints(new TGLayoutHints(kLHintsLeft,0,0,2,-7), _preserveG);
   _aspectBGg->Insert(_manuallyG,1);
   _aspectBGg->SetLayoutHints(new TGLayoutHints(kLHintsLeft,0,0,2,-7), _manuallyG);
   _aspectBGg->Show(); 
   
   _ratioG= new TGNumberEntry(_aspectBGg,1,9,Gratio);
   _ratioG->GetNumberEntry()->Connect("TabPressed()","FlukaMainFrame",this,"ChangeFocus()");
   _ratioG->GetNumberEntry()->Connect("ReturnPressed()","FlukaMainFrame",this,"updateGeometry()");
   _ratioG->SetState(kFALSE);
   _ratioG->Associate(this);
   _aspectBGg->AddFrame(_ratioG, new TGLayoutHints(kLHintsLeft,0,0,1,-7));
   
   _preserveG->Associate(this);
   _manuallyG->Associate(this);

   fFrame7->AddFrame(_aspectBGg, new TGLayoutHints(kLHintsTop|kLHintsCenterX,2,2,4,0));
// 
// ---
// 


}
