
//
//    (feb'07 19-02:07) - version v.07a
//                                                                                 the FLEUR project
// -------------------------------------------------------------------------------------------------
//                                                                                anton.empl@cern.ch
//                                                                   (Katey Covin, Matt LeBourgeois)
// --- FLUKA user back-end project -Fbe-
//     see header file (FbeHistPainter.h) for comments
//


#include <TPaletteAxis.h>
#include <TPad.h>
#include <TView.h>

#include "FbePaletteAxis.h"
#include "FbeHistPainter.h"

ClassImp(FbeHistPainter)


FbeHistPainter::FbeHistPainter()
{ 
} // FbeHistPainter


FbeHistPainter::~FbeHistPainter()
{//  printf(" -debug-> ~FbeHistPainter()\n");
} // ~FbeHistPainter



//    take from the root src tree
//______________________________________________________________________________
void FbeHistPainter::PaintPalette()
{
//    *-*-*-*-*-*Paint the color palette on the right side of the pad*-*-*-*-*
//               ====================================================

// printf(" -debug-> FbeHistPaint\n");

   TPaletteAxis *palette = (TPaletteAxis*)fFunctions->FindObject("palette");
   TView *view = gPad->GetView();
   if (palette) {
      if (view) {
         if (!palette->TestBit(TPaletteAxis::kHasView)) {
            delete palette; palette = 0;
         }
      } else {
         if (palette->TestBit(TPaletteAxis::kHasView)) {
            delete palette; palette = 0;
         }
      }
   }

   if (!palette) {
      Double_t xup  = gPad->GetUxmax();
      Double_t x2   = gPad->PadtoX(gPad->GetX2());
      Double_t ymin = gPad->PadtoY(gPad->GetUymin());
      Double_t ymax = gPad->PadtoY(gPad->GetUymax());
      Double_t xr   = 0.05*(gPad->GetX2() - gPad->GetX1());
      Double_t xmin = gPad->PadtoX(xup +0.1*xr);
      Double_t xmax = gPad->PadtoX(xup + xr);
      if (xmax > x2) xmax = gPad->PadtoX(gPad->GetX2()-0.01*xr);
//    palette = new TPaletteAxis(xmin,ymin,xmax,ymax,fH);
      palette = new FbePaletteAxis(xmin,ymin,xmax,ymax,fH);
      fFunctions->Add(palette);
      palette->Paint();
   }

} // - PaintPalette
