
//
//    (feb'07 19-02:07) - version v.07a
//                                                                                 the FLEUR project
// -------------------------------------------------------------------------------------------------
//                                                                        author: anton.empl@cern.ch
// --- FLUKA user back-end project -Fbe-
//     see header file (FbeIO.h) for comments
//


#include "FbeIO.h"


ClassImp(FbeIO)


FbeIO::FbeIO(const char *aName)
{
    DEBUG(printf(" -debug-> FbeIO()\n");)

    _status= 0;
    _usrDataType= FBE_notDefined;
    _endianess= FBE_littleEndian;

    if (aName) { strcpy(_filename,aName);
                 if (_fd>0) close(_fd); }

} // FbeIO



FbeIO::~FbeIO() {


DEBUG(printf(" -debug-> ~FbeIO()\n");)

} // ~FbeIO



void
FbeIO::identify(void) {

    int bytesRead,bytes;
    char buf[256];


//    here we simply check to see if we are dealing with a usrbin file written in ASCII
//    we rely on the fact that there's 5 stars in the second line of the ascii information
//    also block if the file can't be opened
// ---------------------------------------------------------------------------------------------------

    FILE *fp= fopen(_filename,"r");
    DEBUG(printf(" -debug-> FbeIO  _%s_\n",_filename);)
    if (fp) { fgets(buf,8,fp);
              fgets(buf,8,fp);
              fclose(fp);

              if (!strcmp(buf," ***** ")) { DEBUG(printf(" -debug-> ASCII file \n");)
                                            _status= 2; _endianess= FBE_ascii; }
                else {
                       _fd= open(_filename,O_RDONLY);
                       bytesRead= read(_fd,&bytes,4);

                       if (bytes==NR_OF_BYTES_4_1ST_LINE_IN_FILE) _endianess= FBE_littleEndian;
                         else {
                                bytes= swab32(bytes);
                                if (bytes==NR_OF_BYTES_4_1ST_LINE_IN_FILE) _endianess= FBE_bigEndian;
                                  else { _status= 3; _endianess= FBE_somethingElse; } //not implemented yet?
                              }

                       if (_status==0) {
                                         bytesRead= read(_fd,buf,bytes);
                                         bytesRead= read(_fd,&bytes,4);
                                         bytesRead= read(_fd,&bytes,4);
                                         DEBUG(printf(" -debug-> FbeIO nr of bytes to read next %4i\n",bytes);)

                                         switch (bytes) {
                                           case FBE_usrbinCurrent: _usrDataType= FBE_usrbinCurrent; break;

                                           default: _usrDataType= FBE_notDefined;
                                           }

                                       }

                       close(_fd);
                     }
            }

      else { DEBUG(printf(" -debug-> file could not be opened\n");)
             _status= 1; }


    DEBUG(printf(" -debug-> FbeIO _status %i _endianess %i _usrDataType %i\n",_status,_endianess,_usrDataType);)
// -----------------------------------------
    if (_fd) close(_fd);

}


