 
//
//    (feb'07 19-02:07) - version v.07a
//                                                                                 the FLEUR project
// -------------------------------------------------------------------------------------------------
//                                                                                anton.empl@cern.ch
//                                                                   (Katey Covin, Matt LeBourgeois)
// --- FLUKA user back-end project -Fbe-
//     this is main() - set up the GUI and make use of the Fbe classes
//

//
// --- feb'06 25-05:03
//     removed most of swap() related code since we moved functionality into THistPainter
//     will offer 'swap' feature to root guys, otherwise we'll just patch them
//     if one carefully picks a 32bit root binary version for a 64bit system all works
//       all about -m32/-m64
//


#include "config.h"
#include "FlukaMainFrame.h"

//#include "close.xpm"


int SelectedDataFileType= 0;
const char *dataFileTypes[] = { "all files", "*", 
                                "traditional naming", "*fort.*", 
                                "data files", "*.bnn", 
                                "data files", "*.dat", 
                                 0, 0 };
int SelectedGeometryFileType= 2;
const char *geometryFileTypes[] = { "all files", "*", 
                                    "traditional extension", "*.STORE", 
                                     0, 0 };
int SelectedInputFileType= 0;
const char *inputFileTypes[] = { "traditional extension", "*.inp", 
                                 "all files", "*",
                                  0, 0 };
int SelectedScriptFileType= 0;
const char *scriptFileTypes[] = { "gui/root script file", "*.C", 
                                  "all files", "*",
                                   0, 0 };
int SelectedGraphFileType= 0;
const char *plotFileTypes[] = { "all file types", "*", 
                                "postscript", "*.ps",
                                "encapsulated postscript", "*.eps",
                                "pdf", "*.pdf",
                                "gif", "*.gif",
                                "jpg", "*.jpg",
                                "png", "*.png",
                                0, 0 };

// ---
#define MXXMDF 711

pgmaxS *_pXYZ;
int *M=NULL,*mate=NULL,*rate=NULL,nMate,*rots=NULL, NMAT,NREGS;
int _rotID=-1,readIt=0;
char names[256][9];
TColor *gMatCol[100];

double saveTheMin,saveTheMax;
double zero= 1e-130;
int previousBinning=-1;

double zoom[3][4];

int NX,NY;

TString _pwd(gSystem->WorkingDirectory());
TString _plotfile("graph.ps");
double _top,_bottom,_left,_right;

Bool_t ourFixedAspect=kFALSE;
FontStruct_t fsm;
TGCompositeFrame *pvf1;
TRootEmbeddedCanvas *pc1;
double screenfactor=1;
TGDimension dealWithAspectRation();


// --- static FLUKA information about 'binnings' and 'particle types'
//     (fluka2006.1 mannual)

const char *mapTypes[]= {"xyz","rpz","regions","xyz x/2","xyz y/2",
                         "xyz z/2","xyz quadrant","rpz z/2","special"," ",
                         "xyz","rpz","regions","xyz x/2","xyz y/2",
                         "xyz z/2","xyz quadrant","rpz z/2","special"," "};

const char *scores2[]= {"","","","","","","OptPhoton",
                        "","Proton","Anti Proton","Electron","Positron",
                        "Neutrino e","Anti Neutrino e","Photon","Neutron",
                        "Anti Neutron","Muon+","Muon-","Kaon Long","Pion+",
                        "Pion-","Kaon+","Kaon-","Lambda","Anti Lambda",
                        "Kaon Short","Sigma-", "Sigma+","Sigma Zero","Pion Zero",
                        "Kaon Zero","Anti Kaon Zero",
                                                 "26","27","28","29","30",
                        "31","32","33","34","35","36","37","38","39","40",
                        "41","42","43","44","45","46","47","48","49","50",
                        "51","52","53","54","55","56","57","58","59","60",
                        "61","62","63","64","65","66","67","68","69","70",
                        "71","72","73","74","75","76","77","78","79","80",
                        "81","82","83","84","85","86","87","88","89","90",
                        "91","92","93","94","95","96","97","98","99","100",
                        "101","102","103","104","105","106","107","108","109","110",
                        "111","112","113","114","115","116","117","118","119","120",
                        "121","122","123","124","125","126","127","128","129","130",
                        "131","132","133","134","135","136","137","138","139","140",
                        "141","142","143","144","145","146","147","148","149","150",
                        "151","152","153","154","155","156","157","158","159","160",
                        "161","162","163","164","165","166","167","168","169","170",
                        "171","172","173","174","175","176","177","178","179","180",
                        "181","182","183","184","185","186","187","188","189","190",
                        "191","192","193","194","195","196","197","198","199","200",
                        "transportable Particles","Charged Particles","Neutral Particles",
                        "Negative Particles","Positive Particles","Proton & Neutron",
                        "p/n/pi+/pi-","Energy","Charged Pion","Primary Particle","el.mag. energy",
                        "Muon", "Electron & Positron","anti proton + anti neutron","kaon",
                        "strange particles","charged kaon","charged hadron","fision",
                        "high energy fission","low energy fission","neutron balance",
                        "neutral hadrons","neutral kaons","charmed mesons","charmed (anti)baryons",
                        "charmed hadrons", "228","unbiased energy","unbiased el.mag. energy",
                        "momentum transfer, X", "momentum transfer, Y","momentum transfer, Z",
                        "activity per unit volume","activity per unit mass"};

//
// --- sep'06 18-17:51
//     try to deal with a FLUKA forked process that does not exits anymore
//     to have access to our main frame we use a global pointer to it
//

FlukaMainFrame *ap2us;

int FLUKA_OK;
void sigusr1_handler(int val) { FLUKA_OK= 0;
                                ap2us->fCloseIB->Clicked();
                                ap2us->getMainTab()->SetTab(0);

                                DEBUG(printf(" --------------------> sigchld/sigpip here\n");)

                                new aMessageBox(gClient->GetRoot(),ap2us,
                                                "forked() Fluka process just died - this happened not at the time "
                                                "of initialization, rather while accessing geometry information - "
                                                "(unknown region for material assinment?) maybe retry\n",
                                                ap2us->openIcon("FLUKA-Icon.xpm")); }

//     jun'04
//     jan'05 22-04:31
//
// --- FlukaMainFrame is the main class that Fluka's GUI is derived from.
//     In it all of the frames and widgets needed to control the GUI are created. It is supported
//     by the FbeClasses which process the actual data and actually create the histograms that are
//     displayed. For complete help, please see the README file accompanying the source
//     or click on help directly from the main window of the GUI.
//    ------------------------------------------------------------------------------------------------

ClassImp(FlukaMainFrame)

FbeUsrbin *theBinning;
FbeHist *theHistogram=NULL;
fRemS *fRem=NULL;
int XYview=0,RPhiView=2,geometryTab=kFALSE;

// ---------------------------- left over trouble
   static int _rebinned=0;


//
// --- main constructor.  changes the Histogram Painter, creates Layout Hints, and calls
//     the AddTab functions which create the content for each tab
//    ------------------------------------------------------------------------------------------------
//

FlukaMainFrame::FlukaMainFrame(int ur, const TGWindow *p, UInt_t w, UInt_t h)
       :TGMainFrame(p,w,h), fImportFlukaFile(0), fImportInput(0), fImportGeom(0), fImportData(0), fImportScan(0)
{

   _userRoutines= ur;
   TVirtualHistPainter *yeah = new THistPainter();
   yeah->SetPainter("FbeHistPainter");
   delete yeah;
   fGoingUp= fXYZID= fIsSlice= 0;
   fImportFlukaFile= fImportInput= fImportGeom= fImportData= fImportBinning= fImportFbeGeom= fImportScan= kFALSE;
   fmyUsrBins= NULL;
   fmyGeometry= NULL;
   fmyGxyz[0]= fmyGxyz[1]= fmyGxyz[2]= NULL;

   c1= NULL;

// ----------------------------------------------------------------------------------------------- init ---
//
// --- these are options for the LayoutHints

   fL00= new TGLayoutHints(kLHintsCenterX | kLHintsExpandX, 0,0,0,0);
   fL0= new TGLayoutHints(kLHintsCenterX | kLHintsExpandX, 4,4,14,4);
   fL9= new TGLayoutHints(kLHintsLeft, 4,4,0,0);
   fL99= new TGLayoutHints(kLHintsLeft, 0,0,2,2);
   fL98= new TGLayoutHints(kLHintsNormal|kLHintsCenterY, 0,0,0,0);
   fL97= new TGLayoutHints(kLHintsLeft, 4,4,2,2);
   fL96= new TGLayoutHints(kLHintsCenterY, 0,0,0,0);
   fL95= new TGLayoutHints(kLHintsCenterY, 0,0,4,0);
   fL1= new TGLayoutHints(kLHintsCenterY | kLHintsExpandX, 0, 0, 0, 0);
   fL2= new TGLayoutHints(kLHintsCenterX | kLHintsExpandX, 4, 4, 0, 0);

   _sepheight= 4;
   _sepshape= kRaisedFrame|kFixedHeight;
   fL3= new TGLayoutHints(kLHintsCenterX | kLHintsExpandX, 2, 2, 4, 4);

   fL4= new TGLayoutHints(kLHintsTop | kLHintsLeft | kLHintsExpandY,4,2,4,2);   // main tab in main frame
   fL5= new TGLayoutHints(kLHintsLeft | kLHintsCenterY, 0,0,0,0);
   fL6= new TGLayoutHints(kLHintsCenterX, 0, 0, 0, 0);
   fL7= new TGLayoutHints(kLHintsCenterX | kLHintsExpandX, 0, 0, 1, 1);
   fLL= new TGLayoutHints(kLHintsNormal,20,0,4,0);
   fLL14= new TGLayoutHints(kLHintsExpandX | kLHintsCenterY,0,0,4,4);
   fL8= new TGLayoutHints(kLHintsRight,2,2,0,0);
   fLL2= new TGLayoutHints(kLHintsRight,4,4,4,4);
   fLL9= new TGLayoutHints(kLHintsExpandX | kLHintsCenterY,4,0,4,4);
   fLL3= new TGLayoutHints(kLHintsExpandX,2,2,0,0);
   fLL4= new TGLayoutHints(kLHintsExpandX | kLHintsCenterY,0,0,0,0);
   fLL14= new TGLayoutHints(kLHintsExpandX | kLHintsRight | kLHintsCenterY,0,0,0,0);
   fLL8= new TGLayoutHints(kLHintsExpandX | kLHintsLeft  | kLHintsCenterY,0,0,0,0);
   fLL5= new TGLayoutHints(kLHintsExpandX | kLHintsCenterY,2,0,0,0);
   fLL6= new TGLayoutHints(kLHintsCenterY|kLHintsRight, 2,0,0,0);
   fLL7= new TGLayoutHints(kLHintsExpandY|kLHintsExpandX|kLHintsTop|kLHintsRight,0,2,4,2);    // c1 in main frame


// --- deal with our colors

   {
     float r,g,b;

     sscanf(gEnv->GetValue("Gui.BackGround",".269,.364,.580")," %f %f %f ",&r,&g,&b);
     matt= new TColor(1001, r,g,b, "matt",1.);
     matt->SetRGB(r,g,b);
//   matt= gROOT->GetColor(200);   matt->SetRGB(r,g,b);       // ??? mar'07

     sscanf(gEnv->GetValue("Gui.ForeGround",".790,.780,.670")," %f %f %f ",&r,&g,&b);
     dark= new TColor(1002, r,g,b, "dark",1.);

     sscanf(gEnv->GetValue("Gui.Buttons",".790,.780,.670")," %f %f %f ",&r,&g,&b);
     light= new TColor(1003, r,g,b, "light",1.);

     sscanf(gEnv->GetValue("Gui.TextArea",".930,.960,.910")," %f %f %f ",&r,&g,&b);
     grey= new TColor(1004, r,g,b, "grey",1.);

     sscanf(gEnv->GetValue("Gui.ExtraColor",".740,.370,.370")," %f %f %f ",&r,&g,&b);
     red= new TColor(1005, r,g,b, "red",1.);

     sscanf(gEnv->GetValue("Gui.DefaultCanvasSize","600")," %i ",&_six00);

     for (int i=0;i<100;i++) gMatCol[i]= new TColor(1006+i, .0,.0,.0 ,"");
   }


//
// --- font stuff
//     tab4 bold/fixed
//
   mGC= *gClient->GetResourcePool()->GetFrameGC();
   if (_six00>550) mf= gClient->GetFont("-adobe-courier-bold-r-*-*-12-*-*-*-*-*-iso8859-1");
     else mf= gClient->GetFont("-adobe-courier-bold-r-*-*-8-*-*-*-*-*-iso8859-1");
   if (mf) mGC.SetFont(mf->GetFontHandle());

// --

   fsm= gClient->GetResourcePool()->GetMenuFont()->GetFontStruct();
   int ma,md;
   char fname[256];
   gVirtualX->GetFontProperties(fsm,ma,md);
   sprintf(fname,"-adobe-symbol-medium-r-*-*-%i-*-*-*-*-*-*-*",ma);

   myFont= gClient->GetFont(gClient->GetResourcePool()->GetMenuHiliteFont());
   if (myFont) myGC.SetFont(myFont->GetFontHandle());
     else printf(" -/-> trouble with bold font\n");

   greekFont= gClient->GetFont(fname);
   if (greekFont) greekGC.SetFont(greekFont->GetFontHandle());
     else printf(" -/-> trouble with font: %s\n",fname);
//
// -------------------------------------

   MakeMenuBarFrame();

   fMainFrame= new TGHorizontalFrame(this,30,50,kRaisedFrame|kHorizontalFrame);

   fMainTab=new TGTab(fMainFrame, 30,50);
   fMainTab->SetBackgroundColor(matt->GetPixel());
// ---
   AddTab1(fMainTab->AddTab("File Selection"), flukaVersion,rootVersion,nrOfUserRoutines,listOfUserRoutines,theirDates);
   AddTab2(fMainTab->AddTab("USRBIN"));
   fMainTab->GetTabTab(1)->SetEnabled(kFALSE);
   AddTab3(fMainTab->AddTab("Histogram Options"));
   fMainTab->GetTabTab(2)->SetEnabled(kFALSE);
// ---
   AddTab4(fMainTab->AddTab("Geometry"));
   fMainTab->GetTabTab(3)->SetEnabled(kFALSE);
   fMainTab->Connect("Selected(Int_t)","FlukaMainFrame",this,"doTabs(Int_t)");

   fMainFrame->AddFrame(fMainTab, new TGLayoutHints(kLHintsTop|kLHintsLeft|kLHintsExpandY, 2,1,4,0));
   fMainFrame->SetBackgroundColor(matt->GetPixel());
   AddFrame(fMainFrame, new TGLayoutHints(kLHintsExpandY|kLHintsExpandX, 0,0,0,0));

// --- set up some arrays of pointers to TGBinNumberEntry/TGNumberEntry fields
//     messy, just added another fMin/fMax mapping next to fMix
//
   fMin[0]= fMix[0]= fXMin; fMax[0]= fMix[3]= fXMax; fBin[0]= fXBin; fSize[0]= fXBinSize;
   fMin[1]= fMix[1]= fYMin; fMax[1]= fMix[4]= fYMax; fBin[1]= fYBin; fSize[1]= fYBinSize;
   fMin[2]= fMix[2]= fZMin; fMax[2]= fMix[5]= fZMax; fBin[2]= fZBin; fSize[2]= fZBinSize;
// --------------------------------------------------------------------------------------
   for (int i=0;i<6;i++) fMix[i]->SetButtonToNum(kFALSE);
   for (int i=0;i<3;i++) { fBin[i]->SetButtonToNum(kFALSE); fBin[i]->SetState(kFALSE); }
//
// ---

   _vf1= new TGVerticalFrame(fMainFrame);
   fMainFrame->AddFrame(_vf1, new TGLayoutHints(kLHintsExpandX|kLHintsExpandY|kLHintsRight, 1,0,0,0));
   _vf1->SetBackgroundColor(matt->GetPixel());
   _hf1= new TGHorizontalFrame(_vf1); 
   _hf1->SetBackgroundColor(matt->GetPixel());

   _resize= new TGTextButton(_hf1,new TGHotString("&Reset Canvas Size"),Mresize);
   _resize->SetToolTipText("reset  size of canvas, default size may be changed in .rootrc");
   _resize->Connect("Clicked()","FlukaMainFrame",this,"resizeCanvas()");
   _hf1->AddFrame(_resize, new TGLayoutHints(kLHintsRight|kLHintsCenterY, 1,1,0,0));

   _ffixed= new TGCheckButton(_hf1,new TGHotString(""),Mffixed);
   _ffixed->SetBackgroundColor(matt->GetPixel());
   _ffixed->Associate(this);
   _hf1->AddFrame(_ffixed, new TGLayoutHints(kLHintsRight, 0,0,4,0));
   _fixed= new TGTextButton(_hf1,new TGHotString("&Fixed Aspect Ratio"),Mfixed);
   _fixed->SetToolTipText("force canvas to be square (in terms of screen pixels)");
   _fixed->Connect("Clicked()","FlukaMainFrame",this,"resizeCanvas()");
   _hf1->AddFrame(_fixed, new TGLayoutHints(kLHintsRight, 0,1,2,0));

   _vf1->AddFrame(_hf1, new TGLayoutHints(kLHintsTop|kLHintsExpandX, 0,0,0,0));

   _holdCanvas= new TGHorizontalFrame(_vf1);
   c1= new TRootEmbeddedCanvas("FlukaGUI canvas",_holdCanvas,_six00,_six00, kRaisedFrame|kDoubleBorder);
   _holdCanvas->AddFrame(c1, new TGLayoutHints(kLHintsBottom|kLHintsRight,0,0,0,0));
   _vf1->AddFrame(_holdCanvas, new TGLayoutHints(kLHintsExpandY|kLHintsExpandX|kLHintsTop|kLHintsRight, 0,0,1,0));

   fMainFrame->Resize();
   if (fMainFrame->GetHeight() >= GetHeight() || fMainFrame->GetWidth() >= GetWidth()) Resize();

   pvf1= _holdCanvas;
   pc1= c1;

   SetWindowName("Fluka Graphical Interface");
   MapSubwindows();
   Layout();
   MapWindow();
   Resize();

   fFrame1->HideFrame(fFrame4);
   fFrame1->HideFrame(fFrame5);
   fFrame1->HideFrame(fFrame6);
// ---
   fTextData->SelectAll();

   fGeometry->SetOn(kFALSE);
   char str[256];
   this->SetIconPixmap( strcat(strcat(strcpy(str,_here),"/"),"FLUKA-Icon.xpm") );

// ------------------- just some root style quirks

   gROOT->Reset();
   gStyle->SetOptStat(0);
   gStyle->SetLabelOffset(0.02,"x");
   gStyle->SetLabelSize(0.033,"x");
   gStyle->SetTickLength(-0.02,"x");
   gStyle->SetTitleSize(0.04,"x");    // -ae-           .05  (mar'06)
   gStyle->SetTitleOffset(1.5,"x");   // -ae- remember  1.3  (feb'06)
   gStyle->SetLabelOffset(0.02,"y");
   gStyle->SetLabelSize(0.033,"y");
   gStyle->SetTickLength(-0.02,"y");
   gStyle->SetTitleOffset(1.5,"y");
   gStyle->SetTitleSize(0.04,"y");

   gStyle->SetTitleSize(0.03,"z");

   gStyle->SetTitleFillColor(0);
   gStyle->SetTitleBorderSize(0);

   gStyle->SetLineColor(17);
   gStyle->SetLineWidth(0);

   c1->GetCanvas()->cd();
   c1->GetCanvas()->Clear();
   c1->GetCanvas()->SetBorderSize(1);
   c1->GetCanvas()->SetTopMargin(0.19);
   c1->GetCanvas()->SetBottomMargin(0.17);
   c1->GetCanvas()->SetRightMargin(0.19);
   c1->GetCanvas()->SetLeftMargin(0.17);
   c1->GetCanvas()->SetBorderMode(0);
   c1->GetCanvas()->Draw();
   c1->GetCanvas()->SetLogz();

   c1->GetCanvas()->SetBit(kNoContextMenu);        // ---> found by means of guitest.C (mar'06 14-11:23)

   _top= .19; _bottom= .17; _right= .19; _left= .17;

   TPad *kp= (TPad*)c1->GetCanvas();
   kp->SetFillColor(0);
   kp->SetBorderMode(0);
   kp->SetFrameBorderMode(0);
   kp->SetFrameLineColor(0);

   gVirtualX->SetCursor(GetId(),gVirtualX->CreateCursor(kPointer));


// --- mar'06 07-10:54
//     let's get a little splash information up on our canvas about the project
//     it goes as soon as one starts working naturally

   setCanvasAspect(c1->GetCanvas());
   splash(c1->GetCanvas());

   _pwd+= "/";
   _plotfile= _pwd+_plotfile;


// --- sep'06 18-17:24
//     try and have communication back from scanGeometry/FLUKA
//     need to implement checking on FLUKA_OK in several places

   ap2us= this;
   signal(SIGUSR1,sigusr1_handler);

// --- sep'06 21 10:27
//     --X11--
//     do not understand how root actually linkes against X11, so be careful to make sure
//     make scheme find X11 related stuff

#ifndef FOUND_XLIB
   screenfactor= 1;
   printf(" ---> Xlib not in standard place\n      ignore physical dimensions of screen\n");
#else
   Display *xdsp= XOpenDisplay("");
   int screen= DefaultScreen(xdsp),
       xp=DisplayWidth(xdsp,screen),yp=DisplayHeight(xdsp,screen),
       xmm=DisplayWidthMM(xdsp,screen),ymm=DisplayHeightMM(xdsp,screen);
   screenfactor= (1.*xp/xmm)/(1.*yp/ymm);
   XCloseDisplay(xdsp);
   DEBUG(printf(" ---> canvas %f\n",screenfactor);)

#endif

   Resize();

// --- mar'07 09-22:13
//     here we make our triplet of geometry classes, we'll hold on to them
//
   for (int i=0;i<3;i++) fmyGxyz[i]= new FbePlotgeom(c1->GetCanvas());
//
// ---

} // FlukaMainFrame



//
// --- process most of the callback action in the old root GUI style - rather messy approach
//     which we will slowly turn as much as needed into the new philosophy   signal/slot
//    ------------------------------------------------------------------------------------------------
//

Bool_t FlukaMainFrame::ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2)
{

   int ib,ix,io,iz, reverse= 3-parm2;
   TCanvas *k = ((TCanvas*)gROOT->GetListOfCanvases()->FindObject("Projection"));

   switch(GET_MSG(msg)) {

    case kC_COMMAND: switch(GET_SUBMSG(msg)) {


// --- mar'07 09-18:20  possible fix/kludge to the ListBox dilemma
//                      real mess, slot just doesn't want to cooperate so we go back to old style
//
       case kCM_COMBOBOX: doListBox();
       break;


//    ------------------------------------------------------------------------------------------------
// --- this section of code deals with the little buttons placed next to the input fields for the
//     histogram limits - at this point we always redraw the histogram regardless of actual success
//     in trying to manipulate the limits
//     parm2:   1(add) 2(subtract)
//
//     array approach requires the respective 6/3 enums to be in order
//     ib runs from 0-5 and indicates either min(0-2) or max(3-5) entry fields - io gives min to match
//     max and vice-versa - ix gives basically the coordinate (x/y/z) - iz should indicate the not
//     visible coordinate, ie we integrate over it  -> THE LOGIC FOR ib/io/ix/iz WORKS, remember
//
       case kCM_BUTTON: switch(parm1) {
          case Mquit: CloseWindow(); break;

          case MXMAX:
          case MYMAX:
          case MZMAX:
          case MXMIN:
          case MYMIN:
          case MZMIN: ib= parm1-MXMIN; ix= ib%3; io= ib+((ib>2)?-3:3); iz= (fXYZID+2)%3;
                      fMix[ib]->ChangeIndex(parm2);
                      if (fMix[ib]->GetIndex()==fMix[io]->GetIndex()) fMix[ib]->ChangeIndex(reverse);

                      if (ix!=iz) { fBin[ix]->SetArray(CreateModdedArray(fMix[ix]->GetIndex(),fMix[ix+3]->GetIndex()));
                                    fBin[ix]->SetIndex(10000000); }
                        else fSize[ix]->SetNumber((fMix[ix+3]->GetNumber()-fMix[ix]->GetNumber())/fBin[ix]->GetNumber());
                      break;
       // ---------------------- min/max ---

          case MXBIN:
          case MYBIN:
          case MZBIN: ix= parm1-MXBIN;
                      fBin[ix]->ChangeIndex(parm2);
                      fSize[ix]->SetNumber((fMix[ix+3]->GetNumber()-fMix[ix]->GetNumber())/fBin[ix]->GetNumber());
                      break;
       // ---------------------- number of bins ---


          case MCOLORPERDEC: fColorPerDec->SetNumber(fColorPerDec->GetNumber()+((parm2>0)?-1:1));
                             break;
       // ----------------------------- a first number entry
       }


       UpdateHistogram();
       break;
//
//    ------------------------------------------------------------------------------------------------
//
       case kCM_CHECKBUTTON: switch(parm1) {

          case GLINES: return 0;
          case GMODE: updateGeometry(); return 0;

          case MGEOMETRY: if(!fGeometry->GetState()) c1->GetCanvas()->Clear();
                          DEBUG(printf(" -debug- MGEOMETRY:\n");)
                          UpdateHistogram();
                          break;
          case MLOGCHECK: if (fLogCheck->GetState()) c1->GetCanvas()->SetLogz(kTRUE);
                          else c1->GetCanvas()->SetLogz(kFALSE);
                          break;
// ---
          case Mpreserve: if (_preserve->IsDown()) { _ratio->SetState(kFALSE); _manually->SetDown(kFALSE); }
                            else { if (_manually->IsDown()) _manually->SetDown(kFALSE); else _ratio->SetState(kFALSE); }
                          UpdateHistogram();
                          break;
          case Mmanually: if (_manually->IsDown()) { _ratio->SetState(kTRUE); _preserve->SetDown(kFALSE); }
                            else { if (_preserve->IsDown()) _preserve->SetDown(kFALSE); else _ratio->SetState(kFALSE); }
                          UpdateHistogram();
                          break;
// ---
          case Gpreserve: if (_preserveG->IsDown()) { _ratioG->SetState(kFALSE); _manuallyG->SetDown(kFALSE); }
                            else { if (_manuallyG->IsDown()) _manuallyG->SetDown(kFALSE); else _ratioG->SetState(kFALSE); }
                          updateGeometry();
                          break;
          case Gmanually: if (_manuallyG->IsDown()) { _ratioG->SetState(kTRUE); _preserveG->SetDown(kFALSE); }
                            else { if (_preserveG->IsDown()) _preserveG->SetDown(kFALSE); else _ratioG->SetState(kFALSE); }
                          updateGeometry();
                          break;

          case Mgrey:     c1->GetCanvas()->SetGrayscale(_grey->GetState());
                          UpdateHistogram();
                          break;

          case Mffixed:   _ffixed->SetDown(ourFixedAspect);
       }
       break;
//
//    ------------------------------------------------------------------------------------------------
//
       case kCM_RADIOBUTTON: switch(parm1) {

          case MZNORMALIZE: fZScale->SetOn(kFALSE); Scale(); break;
          case MZSCALE: fZNormalize->SetOn(kFALSE); Scale(); break;
          case MXPROJ: fYProj->SetOn(kFALSE);
                       if (k) k->Close();
                       if (c1) CloseHistSlot();
                       SetProjArrays(0);
                       break;
          case MYPROJ: fXProj->SetOn(kFALSE);
                       if (k) k->Close();
                       if (c1) CloseHistSlot();
                       SetProjArrays(1);
                       break;

          case MGBXY: _gview= 0; updateGeometry(1); break;
          case MGBYZ: _gview= 1; updateGeometry(1); break;
          case MGBZX: _gview= 2; updateGeometry(1); break;

          case MXY: ChangePlane(0); break;
          case MYZ: ChangePlane(1); break;
          case MZX: ChangePlane(2); break;
       }
       DEBUG(printf(" ---> kCM_RADIOBUTTON %i\n",(int)parm1);)
       break;
//
//    ------------------------------------------------------------------------------------------------
//
       case kCM_MENU:

          switch(parm1) {
            case MFileOpen: ReadScript(); break;
            case MFileSave: WriteScript(); break;

//          case MHELPLICENSE: break;

            case MHELPABOUT: new aMessageBox(gClient->GetRoot(),this,
                                             "Fluka Graphical User Interface (version .07, beta release) \n"
                                             "created for FLUKA in context of the FLEUR project \n"
                                             "related websites: www.fluka.org - fleur.cern.ch \n"
                                             "authors: Anton Empl, Matthew LeBourgeois and Katye Covin \n"
                                             "contact: anton.empl@cern.ch \n"
                                             "University of Houston, dec'04/aug'07",
                                             openIcon("FLUKA-Icon.xpm"));
                             break;
            default: break; }

           if (parm1==MSAVEAS) {
             char *exten[6]={".ps",".eps",".pdf",".gif",".jpg",".png"};

             TGFileInfo *tgfi= new TGFileInfo();
             tgfi->fFileTypes= plotFileTypes;
             tgfi->fIniDir= StrDup("./");
             tgfi->fFilename= StrDup(_plotfile.ReplaceAll(_pwd,""));
             tgfi->fOverwrite= 0;

             new TGFileDialog(fClient->GetRoot(), this, kFDSave, tgfi);

             if (tgfi->fFilename) { TString f("nix"); f= tgfi->fFilename;
                                    f.ReplaceAll(_pwd,"");
                                    _plotfile= f.Data();
                                    int i; for (i=0;i<6;i++) if (f.EndsWith(exten[i])) break;

               fMenuFile->DeleteEntry(fMenuFile->GetEntry(MSAVE));
               fMenuFile->AddEntry(Form("&Save Graph   %s", f.Data()),MSAVE, 0,0, fMenuFile->GetEntry("Save Graph As"));
               c1->GetCanvas()->SaveAs(f); }
             }

           if (parm1==MSAVE) c1->GetCanvas()->SaveAs(_plotfile);
    }
    break;   // --- end of kC_COMMAND GET_SUBMSG
//
//  ------------------------------------------------------------------------------------------------
//  feb'06 22-05:29


    case kC_TEXTENTRY: switch(parm1) {

       case MDATAFILE: switch(GET_SUBMSG(msg)) {
          case kTE_ENTER: fImportBinning= kFALSE;
                          fImportData= try2openDataFile(fTextData->GetText());
                          break;
          case kTE_TAB: break;
          case kTE_TEXTCHANGED: break; }
          break;

       case MINPUTFILE: switch(GET_SUBMSG(msg)) {
          case kTE_ENTER: fImportScan= kFALSE;
                          fImportInput= try2openInputFile(fTextInput->GetText());
//                        if (fImportInput) fGeometry->SetOn(kTRUE);
                          break;
          case kTE_TAB: break;
          case kTE_TEXTCHANGED: break; }
          break;

       case MGEOMFILE: switch(GET_SUBMSG(msg)) {
          case kTE_ENTER:
                          fImportGeom= try2openStoreFile(fTextGeom->GetText());
//                        if (fImportGeom) fGeometry->SetOn(kTRUE);
                          break;
          case kTE_TAB: break;
          case kTE_TEXTCHANGED: break; }
          break;

//
// --- mar'06 01-09:13
//     geometry Tab related stuff
//
       case MGEOLINES: _nr[_gview]= (int)fGeoLines->GetNumber()+1;
                       if (_nr[_gview]<33) _nr[_gview]=33;

       case MGZD: _z[_gview]= _zd->GetNumber();

       case MGXL:
       case MGXU:
       case MGYL:
       case MGYU:
       case MGZL:
       case MGZU:
                  if (GET_SUBMSG(msg)==kTE_ENTER) updateGeometry();
                  if (GET_SUBMSG(msg)==kTE_TAB) focusChangeGeometry(parm1);
//
// ---


    } // --- end of kC_TEXTENTRY

    break;

   }

   return 0;
} // ProcessMessage



//
// --- default destructor, (I dont think it is ever called??? MLML)
//    ------------------------------------------------------------------------------------------------
//

FlukaMainFrame::~FlukaMainFrame()
{
// 	cout << "FlukaMainFrame Destructor" << endl; //MLML

} // ~FlukaMainFrame



//
// --- closes the GUI, used by X and called when File->Exit is pressed
//     since we connected to here (feb'05 01-20:11)
//     try and cleanup a few of the stray fluka produced geometry related files
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::CloseWindow()
{
   shutFlukaDown();

   unlink("fort.4");
   unlink("pgmdrv.out");
   gApplication->Terminate(0);

}



//
// --- Function that makes the menu bar for the GUI
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::MakeMenuBarFrame()
{

   fMenuBarLayout= new TGLayoutHints(kLHintsTop|kLHintsLeft|kLHintsExpandX, 0,0,0,0);

   fTopBar= new TGHorizontalFrame(this,0,0);
   fTopBar->SetBackgroundColor(dark->GetPixel());

   fMenuBar= new TGMenuBar(fTopBar, 1, 1, kHorizontalFrame|kRaisedFrame);
   fMenuBar->SetBackgroundColor(light->GetPixel());

   fMenuFile= new TGPopupMenu(gClient->GetRoot());
   fMenuFile->AddEntry("Open", MFileOpen);
   fMenuFile->AddEntry("Save Script", MFileSave);
   fMenuFile->DisableEntry(MFileSave);

   fMenuFile->AddEntry(Form("Save Graph   %s",_plotfile.Data()),MSAVE);
   fMenuFile->AddEntry("&Save Graph As",MSAVEAS);

   fMenuFile->AddSeparator();
   fMenuFile->AddEntry("&Quit", MFileExit);
   fMenuFile->Associate(this);
   fMenuFile->Connect("Activated(Int_t)","FlukaMainFrame",this,"extraCloseWindow(Int_t)");
// ---
   fMenuBar->AddPopup("&File",fMenuFile, new TGLayoutHints(kLHintsTop|kLHintsLeft, 6,0,0,0));



// --- mar'06 08-17:13
//----------------------------------------------------- needs to be adapted first before using again
// fMenuView= new TGPopupMenu(gClient->GetRoot());
// fMenuView->AddEntry("&Toolbar", MViewToolBar);
// fMenuView->Associate(this);
// fMenuView->CheckEntry(MViewToolBar);
//-----------------------------------------------------


   fMenuHelp= new TGPopupMenu(gClient->GetRoot());
// fMenuHelp->AddEntry("&Physics", 1000);
// fMenuHelp->AddEntry("&Simulation", 1010);
// fMenuHelp->AddSeparator();
   fMenuHelp->AddEntry("&License...", MHELPLICENSE);
   fMenuHelp->AddEntry("&About...", MHELPABOUT);
   fMenuHelp->Associate(this);
// ---
   fMenuBar->AddPopup("&Help",fMenuHelp, new TGLayoutHints(kLHintsTop|kLHintsLeft, 6,6,0,0));

   fTopBar->AddFrame(fMenuBar, new TGLayoutHints(kLHintsTop|kLHintsLeft, 6,0,0,0));


   fQuit= new TGTextButton(fTopBar,new TGHotString("&Quit"),Mquit);
   fQuit->Associate(this);
   fTopBar->AddFrame(fQuit, new TGLayoutHints(kLHintsTop|kLHintsRight, 0,4,1,0));

   fNext= new TGTextButton(fTopBar,new TGHotString("&Next Tab"),Mnext);
   fNext->Connect("Clicked()","FlukaMainFrame",this,"switchTab()");
   fNext->SetToolTipText("use this button (or alt n) to select next Tab");
   fTopBar->AddFrame(fNext, new TGLayoutHints(kLHintsTop|kLHintsRight, 0,1,1,0));

   fPrev= new TGTextButton(fTopBar,new TGHotString("&Previous Tab"),Mprev);
   fPrev->Connect("Clicked()","FlukaMainFrame",this,"switchTab()");
   fPrev->SetToolTipText("use this button (or alt p) to select previous Tab");
   fTopBar->AddFrame(fPrev, new TGLayoutHints(kLHintsTop|kLHintsRight, 0,1,1,0));

   _alabel= new TGLabel(fTopBar," ! rotated coordinate system ", myGC(),myFont->GetFontStruct());
   _alabel->SetTextColor(fTopBar->GetBackground());
   _alabel->SetBackgroundColor(fTopBar->GetBackground());
   fTopBar->AddFrame(_alabel, new TGLayoutHints(kLHintsCenterY|kLHintsRight, 0,50,0,0));
   fTopBar->HideFrame(_alabel);

   if (_userRoutines) {
     _blabel= new TGLabel(fTopBar," ! external FLUKA user routines ", myGC(),myFont->GetFontStruct());
     _blabel->SetTextColor(grey);
     _blabel->SetBackgroundColor(red->GetPixel());
     fTopBar->AddFrame(_blabel, new TGLayoutHints(kLHintsCenterY|kLHintsLeft, 50,0,0,0));
     }

   AddFrame(fTopBar,fMenuBarLayout);


} // MakeMenuBarFrame




// ---------------------------------------------------------------------------------------------------
// -ae-
//

//
// --- this routine implements the smarts to see if a data file exists and is of the correct
//     type - if so we open it and perform GUI actions to give the user feedback and
//     information - the two tasks could be separated out nicer I guess
//
//     the following 3 try2open... methods perform similarly for other file types
//    ------------------------------------------------------------------------------------------------
//

int FlukaMainFrame::try2openDataFile(const char *filename)
{
TGString *allFake;
DEBUG(printf(" -try2openDataFile- _%s_\n",filename);)

if (fmyUsrBins!=NULL) { _rebinned= 0;
                        fBinningFrame->RemoveEntries(1001,1000+fmyUsrBins->nrOfBinnings());
                        DEBUG(printf(" -remove-usrbin-stuff-\n");)
                        delete fmyUsrBins;
                      }
  else fBinningFrame->RemoveEntry(1000);

DEBUG(printf(" ---> closed fmyUsrBins (%p)\n",theHistogram);)

// ---
resetCanvas(0);
_alabel->SetBackgroundColor(fTopBar->GetBackground());
_alabel->SetTextColor(fTopBar->GetBackground());
_show->SetOn(kFALSE);

theBinning= NULL;
theHistogram= NULL;
// ---


fmyUsrBins= new FbeUsrbinFile(filename);

if (fmyUsrBins->status()) { DEBUG(printf(" -debug-> usrbin data hide \n");)
                            if (strcmp(filename,"close data file")) {
                              char emsg[256];
                              sprintf(emsg, "either not a FLUKA USRBIN output file or "
                                            "somehow we have a problem with it's format (%1i)",fmyUsrBins->status());
                              new aMessageBox(gClient->GetRoot(),this,emsg,openIcon("FLUKA-Icon.xpm")); }
                            fTextData->SetText("No Data File Selected...");
                            delete fmyUsrBins; fmyUsrBins= NULL;
                            fFrame1->HideFrame(fFrame5);

                            allFake= new TGString("USRBIN");
                            fMainTab->GetTabTab(1)->SetEnabled(kFALSE); fMainTab->GetTabTab(1)->SetText(allFake);
                            allFake= new TGString("Histogram Options");
                            fMainTab->GetTabTab(2)->SetEnabled(kFALSE); fMainTab->GetTabTab(2)->SetText(allFake);

                            return 0;
                          }

TString a(fmyUsrBins->title()); DEBUG(printf(" title length %i %i\n",strlen(fmyUsrBins->title()),strlen(a));)
TString title("Title: "); title+= a; fTitleUsr2->SetText(title);

char tmp0[256]; strcpy(tmp0,"");
sprintf(tmp0,"Events: %i - weight of primaries %g ",fmyUsrBins->nrOfEvents(),fmyUsrBins->weightOfPrimary() );
fTitleUsr3->SetText(new TGString(tmp0));

strcpy(tmp0,""); sprintf(tmp0,"Binnings: %i",fmyUsrBins->nrOfBinnings());
fTitleUsr4->SetText(new TGString(tmp0));

if (fmyUsrBins->WithStats()) fTitleUsr5->SetText(" > multiple runs ");
  else {
         TString tmp1("Date: ");
         char *cp= strstr(fmyUsrBins->date(),":"); cp++;
         TString date(cp,9); tmp1+= date;
         tmp1+= " (";
         cp= strstr(cp,":"); cp++; TString time(cp,6); tmp1+= time;
         tmp1+= " )";
         tmp1+= "     > single run ";
         fTitleUsr5->SetText(tmp1); }

fFrame1->ShowFrame(fFrame5);

allFake= new TGString("USRBIN");
fMainTab->GetTabTab(1)->SetEnabled(kTRUE); fMainTab->GetTabTab(1)->SetText(allFake);
allFake= new TGString("Histogram Options");
fMainTab->GetTabTab(2)->SetEnabled(kTRUE); fMainTab->GetTabTab(2)->SetText(allFake);
return 1;

} // try2openDataFile


// ---

int FlukaMainFrame::try2openStoreFile(const char *filename)
{
int j;
char *xy[3]={"X","Y","Z"};
double x0,y0,z0,x1,y1,z1;

if (fmyGeometry) { delete fmyGeometry; fmyGeometry= NULL; }

DEBUG(printf(" ---> closed fmyGeometry\n");)
resetCanvas(2);

fmyGeometry = new FbePlotgeom(filename); 

if (fmyGeometry->status()) { DEBUG(printf(" -debug-> plotgeom.store hide \n");)
                             if (strcmp(filename,"close plotgeom file")) {
                               char emsg[256];
                               sprintf(emsg, "either not a PLOTGEOM.STORE file or "
                                             "somehow we have a problem with it's format (%1i)",fmyGeometry->status());
                               new aMessageBox(gClient->GetRoot(),this,emsg,openIcon("FLUKA-Icon.xpm")); }

                             fTextGeom->SetText("No Geometry File Selected...");
                             delete fmyGeometry; fmyGeometry= NULL;

                             fFrame1->HideFrame(fFrame4);
                             return 0;
                           }

DEBUG(printf(" -debug-> geometry show \n");)

TString a(fmyGeometry->getTitle()); DEBUG(printf(" title length %i %i\n",strlen(fmyGeometry->getTitle()),strlen(a));)
TString title("Title: "); title+= a; fTitleGeo2->SetText(title.Data());
TString date("Date: "); date+= " -not available-";
fTitleGeo3->SetText(date.Data());

TString orient("Orientation: (");
int x= fmyGeometry->getX(),y= fmyGeometry->getY();
if (x>=0 && x<3 && y>=0 && y<3) { orient+= xy[x]; orient+= xy[y]; orient+= ") "; }
  else orient+= "not aligned to xyz coordinates)";
fTitleGeo4->SetText(orient.Data());

TString limits("Limits: ");
fmyGeometry->get3D(&x0,&y0,&z0,&x1,&y1,&z1);
fmyGeometry->get2D(&x0,&y0,&x1,&y1);
char d2xyz[256]; sprintf(d2xyz," X %g/%g  Y %g/%g (cm)",x0,x1,y0,y1);
limits+= d2xyz;
char zz[32]; sprintf(zz,"      Z %g (cm)", _zd->GetNumber() );
limits+= zz;
fTitleGeo5->SetText(limits.Data());

DEBUG(printf(" --reset Scan-1- %i %i\n",fImportInput,fImportScan);)
fImportInput= kFALSE;
fImportScan= kFALSE;
for (j=0;j<3;j++) if (fmyGxyz[j]) fmyGxyz[j]->reset();  // -07-
fFrame1->HideFrame(fFrame6);
fTextInput->SetText("FLUKA input file");

fMainTab->GetTabTab(3)->SetEnabled(kFALSE);
TGString *allFake= new TGString("Geometry");
fMainTab->GetTabTab(3)->SetText(allFake);

fFrame1->ShowFrame(fFrame4);
return 1;

} // try2openStoreFile


// ---

int FlukaMainFrame::try2openInputFile(const char *filename)
{
   int j;
   char file[256]; strcpy(file,fTextInput->GetText());
   TGString *allFake;
   DEBUG(printf(" -well- input file  _%s_\n",file);)

   shutFlukaDown();
   for (j=0;j<3;j++) if (fmyGxyz[j]) fmyGxyz[j]->reset();  // -07-

   if (fmyGeometry) { DEBUG(printf(" -danger- delete fmyGeometry\n");)
                      delete fmyGeometry; fmyGeometry= NULL; }

// --- sep'06 19-06:29
//     reset all stuff concerning our geometry tab

   resetCanvas(1);

   for (int i=0;i<3;i++) { _nr[i]= 500;
                           _xyz[2*i]= -50; _gco[2*i]->SetNumber(_xyz[2*i]);
                           _xyz[2*i+1]= 50; _gco[2*i+1]->SetNumber(_xyz[2*i+1]);
                           _z[i]= 0;
                           _xyzB[i]->SetOn(0); }
   _gview= 0;
   _lines->SetDown(kFALSE);
   _xyzB[0]->SetOn(1);
   _show->SetOn(kFALSE);
   fGeoRegions->SetOn(kFALSE);
   _swap->SetOn(kFALSE);
   fGeoColors->SetOn(kFALSE);
   _preserveG->SetDown(kFALSE);
   _manuallyG->SetDown(kFALSE);
   _ratioG->SetNumber(1);

   cutZturnedOn= 0;
   fGeometry->SetOn(kFALSE);
//
// ---

   FLUKA_OK= 1;

   _pXYZ= attach2geometry(file);                  // <--- open/read FLUKA input file

   if (_pXYZ==NULL ||
       _pXYZ->voidType<1) { DEBUG(printf(" -debug-> input file hide \n");)
                            if (strcmp(filename,"close input file")) {
                              new aMessageBox(gClient->GetRoot(),this,"forked() FLUKA process died during initialization "
                                              "- please try and see if the input file actually would work with FLUKA of "
                                              "the same version\n" "in case it does, please notify anton.empl@cern.ch\n"
                                              "thank you", openIcon("FLUKA-Icon.xpm"));
                              resetCanvas(1); }

                            fTextInput->SetText("No FLUKA Input File Selected...");
                            fFrame1->HideFrame(fFrame6);

                            fMainTab->GetTabTab(3)->SetEnabled(kFALSE);
                            allFake= new TGString("Geometry");
                            fMainTab->GetTabTab(3)->SetText(allFake);
                            return 0;
                          }
   unlink("stderr");

   TString a(_pXYZ->title);
   TString title("geometry title: "); title+= a; fTitleInp2->SetText(title);

   TString b0(getGeoDate());
   if (b0!="") { TString geoDate("geometry file from: "); geoDate+= b0; fTitleInp3->SetText(geoDate);
                 TString b1("    "); b1+= getGeoFileName(); fTitleInp3n->SetText(b1);
               }
     else { fTitleInp3->SetText(" ");
            fTitleInp3n->SetText(" "); }

   TString c(getInpDate());
   TString inpDate("FLUKA input file from: "); inpDate+= c; fTitleInp4->SetText(inpDate);

   TString d(_pXYZ->runtit);
   TString runtit("    "); runtit+= d; fTitleInp6->SetText(runtit);

// fGeometry->SetOn(kTRUE);

   fFrame1->HideFrame(fFrame4);
   fTextGeom->SetText("pre-processed FLUKA geometry file");

   fMainTab->GetTabTab(3)->SetEnabled(kTRUE);
   allFake= new TGString("Geometry");
   fMainTab->GetTabTab(3)->SetText(allFake);

   fFrame1->ShowFrame(fFrame6);
   return 1;
}


// ---

int FlukaMainFrame::try2openScriptFile(const char *filename)
{
char file[256], emsg[256]; strcpy(file,filename);

DEBUG(printf(" -well- script file  _%s_\n",file);)

FILE *fp= fopen(filename,"r");
if (fp) {
          fgets(file,255,fp);
          if (strstr(file,"automatically")!=NULL) fclose(fp);
            else { 
                   sprintf(emsg," a file with the specified name does exist, however the format is "
                                " different than that of flukaGUI scripts; please try again");
                   new aMessageBox(gClient->GetRoot(),this,emsg,openIcon("FLUKA-Icon.xpm"));
                   return 0; }
        }
         else {
                sprintf(emsg," a file with the specified name does not exist "
                             " please try again with a different filename");
                new aMessageBox(gClient->GetRoot(),this,emsg,openIcon("FLUKA-Icon.xpm"));
                return 0;
              }
return 1;

} // try2openScriptFile

//
// -ae-
// ---------------------------------------------------------------------------------------------------




//_________________________________________________________________________________________________________
void FlukaMainFrame::OpenFile()
{
//  OpenFile is a slot connected to by pressing any of the buttons
//  in the first tab.  It creates a TGFileDialog depending on which
//  type of file the user is looking to import.


   TGFileInfo *fFileInfo = new TGFileInfo();
   int i=0,cancel=0;

   if (gTQSender==fData) {

     static TString ddir(".");
     static TString dfile("garNix"),keepDfile("examples/hello.dat");
     if (!strcmp(dfile.Data(),"garNix")) dfile= keepDfile;

     fImportData= kFALSE;
     fImportBinning= kFALSE;

     fFileInfo->fFileTypes = dataFileTypes;
     fFileInfo->fIniDir= StrDup(ddir.Data());
     fFileInfo->fFilename= StrDup(dfile.Data());
     fFileInfo->fFileTypeIdx= SelectedDataFileType;

     new TGFileDialog(fClient->GetRoot(), this, kFDOpen, fFileInfo);
     setOurCursor(kWatch);

     if (fFileInfo->fFilename) { dfile= fFileInfo->fFilename;
                                 if (dfile.BeginsWith(_pwd)) dfile.ReplaceAll(_pwd,"");
                                 fTextData->SetText(dfile);

                                 ddir= fFileInfo->fIniDir;
                                 if (ddir.BeginsWith(_pwd)) ddir.ReplaceAll(_pwd,"");
                                 if (dfile.BeginsWith(ddir)) dfile.ReplaceAll(ddir+"/","");

                                 SelectedDataFileType= fFileInfo->fFileTypeIdx;

                                 fImportData= try2openDataFile(fTextData->GetText());
                               }
       else cancel= 1;

     if (!cancel) if (!fImportData) { dfile= keepDfile;
                                      fTextData->SetText("No Data File Selected..."); }
     }


   if (gTQSender==fGeom) {

     static TString gdir(".");
     static TString gfile("garNix"),keepGfile("examples/PLOTGEOM.STORE");
     if (!strcmp(gfile.Data(),"garNix")) gfile= keepGfile;
     i= 1;

//   fImportGeom= kFALSE;
     fImportFbeGeom= kFALSE;

     fFileInfo->fFileTypes = geometryFileTypes;
     fFileInfo->fIniDir= StrDup(gdir.Data());
     fFileInfo->fFilename= StrDup(gfile.Data());
     fFileInfo->fFileTypeIdx= SelectedGeometryFileType;

     new TGFileDialog(fClient->GetRoot(), this, kFDOpen, fFileInfo);
     setOurCursor(kWatch);

     if (fFileInfo->fFilename) { gfile= fFileInfo->fFilename;
                                 if (gfile.BeginsWith(_pwd)) gfile.ReplaceAll(_pwd,"");
                                 fTextGeom->SetText(gfile);

                                 gdir= fFileInfo->fIniDir;
                                 if (gdir.BeginsWith(_pwd)) gdir.ReplaceAll(_pwd,"");
                                 if (gfile.BeginsWith(gdir)) gfile.ReplaceAll(gdir+"/","");

                                 SelectedGeometryFileType= fFileInfo->fFileTypeIdx;

                                 fImportGeom= try2openStoreFile(fTextGeom->GetText());
                               }
       else cancel= 1;

     if (!cancel) { if (!fImportGeom) { gfile= keepGfile;
                                        fTextGeom->SetText("No Geometry File Selected..."); }
                      else { // fGeometry->SetOn(kTRUE);
                             DEBUG(printf(" --reset Scan-2- %i %i\n",fImportInput,fImportScan);)
                             fImportInput= kFALSE; fImportScan= kFALSE; }}
     }


   if (gTQSender==fInput) {

     disconnectFile(MIclose);

     static TString idir(".");
     static TString ifile("garNix"),keepIfile("examples/hello.inp");
     if (!strcmp(ifile.Data(),"garNix")) ifile= keepIfile;
     i= 2;

     DEBUG(printf(" --reset Scan-3- %i %i\n",fImportInput,fImportScan);)
     fImportInput= kFALSE;
     fImportScan= kFALSE;

     fFileInfo->fFileTypes= inputFileTypes;
     fFileInfo->fIniDir= StrDup(idir.Data());
     fFileInfo->fFilename= StrDup(ifile.Data());
     fFileInfo->fFileTypeIdx= SelectedInputFileType;

     new TGFileDialog(fClient->GetRoot(), this, kFDOpen, fFileInfo);
     setOurCursor(kWatch);

     if (fFileInfo->fFilename) { ifile= fFileInfo->fFilename;
                                 if (ifile.BeginsWith(_pwd)) ifile.ReplaceAll(_pwd,"");
                                 fTextInput->SetText(ifile);

                                 idir= fFileInfo->fIniDir;
                                 if (idir.BeginsWith(_pwd)) idir.ReplaceAll(_pwd,"");
                                 if (ifile.BeginsWith(idir)) ifile.ReplaceAll(idir+"/","");

                                 SelectedInputFileType= fFileInfo->fFileTypeIdx;

                                 fImportInput= try2openInputFile(fTextInput->GetText());
                               }
       else cancel= 1;

     if (!cancel) { if (!fImportInput) { ifile= keepIfile;
                                         fTextInput->SetText("No FLUKA Input File Selected..."); }
                      else { // fGeometry->SetOn(kTRUE);
                             fImportGeom= kFALSE; fImportFbeGeom= kFALSE; }}
     }


   if (gTQSender==fGetFlukaFile) { i= 3; }

   delete fFileInfo;
   setOurCursor(kPointer);
}



//
// --- cut this out so that we can update the matrix of values without trying to get a new binning
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::SetBinMatrix()
{
for (int i=0;i<3;i++) { fBin[i]->SetArray(CreateModdedArray(fMix[i]->GetIndex(),fMix[i+3]->GetIndex()));
                        fBin[i]->SetIndex(1000000000); }
}



//
//     redefine arrays for the TGBinEntry widgets in the second tab - MLML
//     corresponding to the bin edges for the histogram
//
//     jan'05 04-16:43
// --- here is where we select a binning and if needed we actually read the data from file
//     *theBinning is global
//     we will hold on to the pointer and only let go here in case we replace it with a new one
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::UpdateBinMatrix()
{
   for (int ix=0;ix<3;ix++) {
      double *dummy = new Double_t[theBinning->bins()[ix]+1];
      for (int i=0;i<theBinning->bins()[ix]+1;++i)
         dummy[i]= theBinning->limits()[ix*3]+(i*theBinning->limits()[ix*3+2]);

      fMix[ix]->SetArray(dummy,theBinning->bins()[ix]+1);
      fMix[ix+3]->SetArray(dummy,theBinning->bins()[ix]+1);
      fMix[ix]->SetIndex(0);
      fMix[ix+3]->SetIndex(theBinning->bins()[ix]);
      fSize[ix]->SetNumber(theBinning->limits()[ix*3+2]);

      delete [] dummy;
      }

   if (theBinning->rphi()) { _xyLx->SetText("R"); _xyLy->SetText("F"); _xyLy->SetTextFont(greekFont); _xyLy->Layout();
                             _yzLy->SetText("F"); _yzLy->SetTextFont(greekFont); _yzLy->Layout();
                             fZXButton->SetText("ZR ");
                             fPlane1->SetText("R");
                             fPlane2->SetText(""); fPlane2g->SetText("F"); fPlane2g->Layout(); }
     else { _xyLx->SetText("X"); _xyLy->SetText("Y"); _xyLy->SetTextFont(fsm); _xyLy->Layout();
            _yzLy->SetText("Y"); _yzLy->SetTextFont(fsm); _yzLy->Layout();
            fZXButton->SetText("ZX ");
            fPlane1->SetText("X");
            fPlane2g->SetText(""); fPlane2->SetText("Y"); fPlane2->Layout(); }

   SetBinMatrix();
   SetProjArrays(fXProj->GetState());
}



//_________________________________________________________________________________________________________
void FlukaMainFrame::SetPlane(int view)
{
// Changes the proper TGBinEntry widgets depending on view plane
// XY: i=0, YZ: i=1, ZX: i=2

   int iz= (view+2)%3;
   fBin[iz]->SetNumber(1);
   fSize[iz]->SetNumber(fMix[iz+3]->GetNumber()-fMix[iz]->GetNumber());

   theHistogram= theBinning->GetHist(view);
   fSwap->SetOn(theHistogram->swap());

   UpdateHistogram();
}



//
// --- create the actual histogram
//     as a first we also scan the FLUKA geometry if it's attached and asked for
//     only do this once per view
//    ------------------------------------------------------------------------------------------------
//
// --- mar'06 06-10:37
//     try to modify such that we do create the histogram and frame but do NOT paint/draw it
//     at this point so that we can adapt the geometry range and just overlay the histogram
//     onto those dimensions - should permit to show a 'small' region of histogram in a larger
//     geometry scan - requires to always first make tha frame to hold the graphics
//

void FlukaMainFrame::UpdateHistogram(int skip)
{

   static int notyet=1;
   int binID,reDoIt;
   char h2options[64],options[64];
   setOurCursor(kWatch);

   if (fImportBinning) {

// --- turn off pointer-range-change for r/phi graph since here the actual ranges are fake and superimposed

     if (theBinning->rphi()) { c1->GetCanvas()->Disconnect("RangeChanged()",this,"ReflectRanges()"); }
       else { c1->GetCanvas()->Connect("RangeChanged()","FlukaMainFrame",this,"ReflectRanges()"); }

     c1->GetCanvas()->SetEditable(kTRUE);
     c1->GetCanvas()->SetLogz(fRem->Logarithmic[fXYZID]);  // --- trouble with empty histogram

//  ------check------
     if (!theBinning->supported()) { if (notyet) { notyet= 0;
       new aMessageBox(gClient->GetRoot(),this,"this binning type is not supported yet - "
                       "at this point we are restricted to types 0 (10) and 1 (11)",openIcon("FLUKA-Icon.xpm"));
       c1->GetCanvas()->Update();
       notyet= 1; }
       return; }

     FbeHist *h= theHistogram;

//  ------check------
     if (h->GetMaximum()<zero) {
//     system("sleep 1");
//       if (notyet) { // notyet= 0;
//       new aMessageBox(gClient->GetRoot(),this,"there seems to be no data for this histogram - "
//                                               "please try another binning",openIcon("FLUKA-Icon.xpm"));
//       c1->GetCanvas()->Update();
  //     printf(" notyet\n"); }
  //     else printf(" yet\n");
  //   return;

     fLogCheck->SetOn(kFALSE);
     c1->GetCanvas()->SetLogz(kFALSE);
     }

// --- compound --- 0/1 - 2/3 --- color Z stuff
//
     int doColor= fEnableColor->GetState() + fPrintOptCheck->GetState()*2;
     DEBUG(printf(" --doColor-- %i %i - %i\n",fEnableColor->GetState(),fPrintOptCheck->GetState(),doColor);)
     double cpd= fColorPerDec->GetNumber();

     double fac= fZScaleValue->GetNumber();
     if (fac<zero) { fac= fScaling; fZScaleValue->SetNumber(fac); return; }
// ----
     DEBUG(printf(" --scale-a- %f %f %f\n",fZScaleValue->GetNumber(),fac,fScaling);)
     double scale= (!fZNormalize->GetState()) ? fac:1/fac;

     int ix=fXYZID, iy=(ix+1)%3, iz=(iy+1)%3;
     double xl,xh,yl,yh,zl,zh;
//   ---------------------------------------------------------
     xl= fMix[ix]->GetNumber(); xh= fMix[ix+3]->GetNumber();
     yl= fMix[iy]->GetNumber(); yh= fMix[iy+3]->GetNumber();
     zl= fMix[iz]->GetNumber(); zh= fMix[iz+3]->GetNumber();


// --- sep'06 11-23:19
//
     double aspect= 1;
     if (_preserve->IsDown()) aspect= (yh-yl)/(xh-xl);
       else if (_manually->IsDown()) aspect= _ratio->GetNumber();

     setCanvasAspect(c1->GetCanvas(),aspect,fSwap->GetState());
// ---

     DEBUG(printf(" ---> UpdateHistogram \n");)
     DEBUG(printf(" zl %g cpd %g do %i scale %g\n", fZLower->GetNumber(),cpd,doColor,scale);)

     if (fZLower->GetNumber()<zero) fZLower->SetNumber(0); // --trouble--
                                                           // should be restricted in TGNumberEntry, can't get enum to work

     h= theBinning-> hist(fXYZID, xl,xh,yl,yh,zl,zh, GetCompression(0),GetCompression(1));
     ChangeRange();

     if (fZLower->GetNumber()>h->GetMaximum()) fZLower->SetNumber(0); // --trouble--
                                                                      // limit above max value, it's the low point though

     h->GetPainter()->Paint();   // (MLML added to permit changing Z-Axis Title) -ae- moved
                                 // since this forces a ReflectRanges() when called (jan'05 27-0:32)
     OurStyle(h);

     double ncpd= h->preparePalette(fZLower->GetNumber(), cpd,doColor, scale);
     if (ncpd<0) { static char emsg[256];
                   sprintf(emsg, "the requested number of 'colors per decade' would result in a total \n"
                                 "number of required color cells larger than 100 which is the current \n"
                                 "limit - the number of 'colors per decade' was reset");
                   new aMessageBox(gClient->GetRoot(),this,emsg,openIcon("FLUKA-Icon.xpm"));
                   ncpd= h->preparePalette(fZLower->GetNumber(), 0,doColor, scale);
                 }
     if (fabs(ncpd-cpd)>zero) fColorPerDec->SetNumber(ncpd);

     strcpy(h2options,"col");
     if (doColor==1||doColor==3) strcat(h2options,",z");
     if (theHistogram->swap()) strcat(h2options,",swap");

     remSet(fXYZID);
     if (skip) return;

     h->Draw(h2options);

//  makes use of (now in root) tailored THistPainter
//  trouble comes in since the actual histogram/ranges do not coincide with the visual
//  information generated - best/easiest solution we could come up with was to Draw() an
//  empty histogram to get the correct range/view and then Draw() our special version
//  ontop - slight interference with 'dynamic pointer actions', disabled 4now
//                                                                               plenty of trouble
//                                                                               nov'04 28-01:30
// ----------------------------------------------------------------------------- r/phi ------
//  we still need checking on Z stuff like the palette, min/max
//
//  feb'06 25-06:31
//  with new THistPainter patch we swap() there but in case of our r/phi graph
//  we now need to swap the axes Titles by hand
//

     if (theBinning->rphi()) 

     if (fXYZID==0) { TH2 *h2= theHistogram;

                      TH2 *c= (TH2*)gROOT->FindObject("th"); if (c) c->Delete();
                      TH2 *th= new TH2F("th","th",10,-xh,xh,10,-xh,xh);
                      OurStyle(th);

                      th->SetBinContent(1,1,.1);   // <--- well ?
                      strcpy(options,"0");
                      if (theHistogram->swap()) strcat(options,",swap");
                      th->Draw(options);

                      strcpy(options,"same,pol,col");
                      if (doColor==1||doColor==3) strcat(options,"z");
                      if (theHistogram->swap()) strcat(options,",swap");
                  // -----------------------
                      h2->Draw(options);
                    }

     char low[32]; sprintf(low,"%g",theHistogram->getmin());
     char high[32]; sprintf(high,"%g",theHistogram->getmax());
     TString tmp0("low: "); tmp0+= low; tmp0+= " high: "; tmp0+= high;
     fGraphIntro5->SetText(tmp0);
     fTitleFrame3->Layout();  // <--- important ---
     }

// --- mar'06 17-04:00
//     this to be clever about ROT-DEFI/ROTPRBIN stuff
//
     binID= -1;
     if (theBinning) binID= theBinning->getFlukaID();

     reDoIt= (binID!=previousBinning);
     previousBinning= binID;
// ---

// --- no data file loaded if we did not get into the above code section, no histogram
// ====================================================================================

     if (!theHistogram) { printf(" -trouble- return, no histogram\n"); return; }


// --- deal with geometry overlay here
//
     if (fGeometry->GetState()) {

       c1->GetCanvas()->SetEditable(kTRUE);
//     c1->GetCanvas()->SetBit(TGraph::kClipFrame,true);    // <-- broken in 5.12.00
//    ---- even though it does not crsah anymore, it still does not clip correctly in case of r/phi graph

       if (fImportFbeGeom) fmyGeometry->overlay(theHistogram->swap());
         else if (fImportScan) {
                                 if (reDoIt) {

                                   _pXYZ->X0= fXMin->GetNumber(); _pXYZ->X1= fXMax->GetNumber();
                                   _pXYZ->Y0= fYMin->GetNumber(); _pXYZ->Y1= fYMax->GetNumber();
                                   _pXYZ->Z0= fZMin->GetNumber(); _pXYZ->Z1= fZMax->GetNumber();

                                   switch(fXYZID) {
                                     case 0: _pXYZ->TXX= 1.; _pXYZ->TXY= 0.; _pXYZ->TXZ= 0.;
                                             _pXYZ->TYX= 0.; _pXYZ->TYY= 1.; _pXYZ->TYZ= 0.;
                                             if (cutZturnedOn) _pXYZ->Z0= _pXYZ->Z1= _zd->GetNumber();
                                               else { _pXYZ->Z0= _pXYZ->Z1= .5*(_pXYZ->Z0+_pXYZ->Z1); }
                                             break;

                                     case 1: _pXYZ->TXX= 0.; _pXYZ->TXY= 1.; _pXYZ->TXZ= 0.;
                                             _pXYZ->TYX= 0.; _pXYZ->TYY= 0.; _pXYZ->TYZ= 1.;
                                             if (cutZturnedOn) _pXYZ->X0= _pXYZ->X1= _zd->GetNumber();
                                               else { _pXYZ->X0= _pXYZ->X1= .5*(_pXYZ->X0+_pXYZ->X1); }
                                             break;

                                     case 2: _pXYZ->TXX= 0.; _pXYZ->TXY= 0.; _pXYZ->TXZ= 1.;
                                             _pXYZ->TYX= 1.; _pXYZ->TYY= 0.; _pXYZ->TYZ= 0.;
                                             if (cutZturnedOn) _pXYZ->Y0= _pXYZ->Y1= _zd->GetNumber();
                                               else { _pXYZ->Y0= _pXYZ->Y1= .5*(_pXYZ->Y0+_pXYZ->Y1); }
                                             break;
                                     }

                                   _pXYZ->EXPANX= _pXYZ->EXPANY= 1.;
                                   _pXYZ->lwmhol= _nr[fXYZID];
                                   if (FLUKA_OK) fmyGxyz[fXYZID]->doPlotgeom( _pXYZ,_mode->GetState(),binID ); }

                                 if (FLUKA_OK) fmyGxyz[fXYZID]->overlay(theHistogram->swap());
                               }

    // --- sep'06 18-23:23
    //     give a warning if coordinate system got rotated
    //     of course only if we live scan - ie no PLOTGEOM.STORE business (oct'06 05-18:57)
    //
       if (fImportScan) {
         if (rotprbin(&binID)>0) { _alabel->SetBackgroundColor(red->GetPixel()); _alabel->SetTextColor(grey); }
           else { _alabel->SetBackgroundColor(fTopBar->GetBackground()); _alabel->SetTextColor(fTopBar->GetBackground()); }
         }
       }
//
// ---

   c1->GetCanvas()->Update();

   setOurCursor(kPointer);
}



//
// --- Function to change the range without having to rebin the histogram,
//     Note, only the axes in the current plane/view will use this function
//     if the range changes for the third axis then the Histogram will be
//     rebinned.  There is a potential here for major amounts of time being
//     wasted... please be patient.
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::ChangeRange()
{
   int sID= theBinning->indexof(), ix=fXYZID,iy=(ix+1)%3;
   double xl=0,xh=0,yl=0,yh=0, dx,dy;

   dx= fMids[sID*3+ix]; dy= fMids[sID*3+iy];
   xl= fMix[ix]->GetNumber(); xh= fMix[ix+3]->GetNumber();
   yl= fMix[iy]->GetNumber(); yh= fMix[iy+3]->GetNumber(); 

   xl+= dx; xh-= dx; yl+= dy; yh-= dy;
   theHistogram->setRange(xl,xh,yl,yh);

   DEBUG(printf(" -change-range- %3i %3i - %3i %3i - %f %f %f %f\n",sID,fXYZID,ix,iy,xl,xh,yl,yh);)
}



//
// --- this is a slot for when the range changes on the Histogram so that the changes will be
//     reflected in the TGBinEntries fields - freeze dynamic changing if rebin is selected (missing!)
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::ReflectRanges()
{

   if (fAllowReBin->IsOn()) return;

   int *temp=theHistogram->getRange(), ix=fXYZID,iy=(ix+1)%3, one=GetCompression(0),two=GetCompression(1);

   fMix[ix]->SetIndex(temp[0]*one); fMix[ix+3]->SetIndex(temp[1]*one);
   fMix[iy]->SetIndex(temp[2]*two); fMix[iy+3]->SetIndex(temp[3]*two);

   fBin[ix]->SetArray(CreateModdedArray(fMix[ix]->GetIndex(),fMix[ix+3]->GetIndex()));
   fBin[ix]->SetIndex(1000000000);
   fBin[iy]->SetArray(CreateModdedArray(fMix[iy]->GetIndex(),fMix[iy+3]->GetIndex()));
   fBin[iy]->SetIndex(1000000000);

   delete temp;

   DEBUG(printf(" -reflect-range- %3i ix %3i iy %3i\n",fXYZID,ix,iy);)
}




//
// ---

Bool_t FlukaMainFrame::HandleKey(Event_t *event)
{

   char tmp[10];
   UInt_t keysym;
   gVirtualX->LookupString(event, tmp, sizeof(tmp), keysym);

   if (event->fType==kGKeyPress) {
     switch (keysym) {
       case 'd': case 'D': fData->Clicked(); return kFALSE; break;
       case 'i': case 'I': fInput->Clicked(); return kFALSE; break;
       case 'n': case 'N': fNext->Clicked(); return kFALSE; break;
       case 'p': case 'P': fPrev->Clicked(); return kFALSE; break;
       case 'q': case 'Q': CloseWindow();
       case 'r': case 'R': _resize->Clicked(); return kFALSE; break;
       }
     }

   return TGMainFrame::HandleKey(event);
}


void FlukaMainFrame::resizeCanvas()
{
    if (gTQSender==_resize) c1->Resize(_six00,_six00);

    if (gTQSender==_fixed) { ourFixedAspect= !ourFixedAspect; _ffixed->SetDown(ourFixedAspect);
                             if (ourFixedAspect) {
                               TGDimension xy= dealWithAspectRation();
                               c1->Resize(xy.fWidth,xy.fHeight); }}
    this->Resize();

    _redraw->Emit("Clicked()");   // --- mar'07 11-23:00
                                  //     ASImage() just doesn't get it
}


void FlukaMainFrame::switchTab()
{
   int dTab= ((TGButton*)gTQSender==fNext) ? 1:-1;
   fMainTab->SetTab((fMainTab->GetCurrent()==0 && dTab<0)? 3:(fMainTab->GetCurrent()+dTab)%4);
}

// ---
//



//
// --- slot for many widgets so that when tab is pressed, a new field is focused on and all text
//     is selected for ease of use - slight change of policy: tab jumps in closed loop through
//     min/max fields and separately within projection min/max
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::ChangeFocus()
{
  int ix,ib,next,parm1=((TGTextEntry*)gTQSender)->WidgetId();

  switch (parm1) {

     case MXMIN:
     case MYMIN:
     case MZMIN:
     case MXMAX:
     case MYMAX:
     case MZMAX: ib= parm1-MXMIN;
                 next= (ib<3) ? ib+3:(ib+1)%3;
                 pushTGBEtext(ib);
                 fMix[next]->GetNumberEntry()->SetFocus();
                 fMix[next]->GetNumberEntry()->SelectAll();
                 break;

     case MXBIN:
     case MYBIN:
     case MZBIN: ix= parm1-MXBIN;
                 next= (fXYZID==ix) ? (ix+1)%3:(ix+2)%3;

                 fBin[ix]->GetNumberEntry()->SetNumber();
                 fSize[ix]->SetNumber((fMix[ix+3]->GetNumber()-fMix[ix]->GetNumber())/fBin[ix]->GetNumber() );

                 fBin[next]->GetNumberEntry()->SetFocus();
                 fBin[next]->GetNumberEntry()->SelectAll(); 
                 break;

     case MPROJMIN: fProjMax->GetNumberEntry()->SetFocus(); fProjMax->GetNumberEntry()->SelectAll(); break;
     case MPROJMAX: fProjMin->GetNumberEntry()->SetFocus(); fProjMin->GetNumberEntry()->SelectAll(); break;

     case MDATAFILE: fTextInput->SetFocus(); fTextInput->SelectAll(); break;
     case MINPUTFILE: fTextGeom->SetFocus(); fTextGeom->SelectAll(); break;
     case MGEOMFILE: fTextData->SetFocus(); fTextData->SelectAll(); break;

     case MGRAPHTITLE: fXTitle->SetFocus(); fXTitle->SelectAll(); entered(); break;
     case MXTITLE: fYTitle->SetFocus(); fYTitle->SelectAll(); entered(); break;
     case MYTITLE: fZTitle->SetFocus(); fZTitle->SelectAll(); entered(); break;
     case MZTITLE: fZScaleValue->GetNumberEntry()->SetFocus(); fZScaleValue->GetNumberEntry()->SelectAll(); entered(); break;

     case MZSCALEVALUE: fZLower->GetNumberEntry()->SetFocus(); fZLower->GetNumberEntry()->SelectAll(); entered(); break;
     case MZLOWER: fColorPerDec->GetNumberEntry()->SetFocus(); fColorPerDec->GetNumberEntry()->SelectAll(); entered(); break;
     case MCOLORPERDEC: UpdateHistogram(); fGraphTitle->SetFocus(); fGraphTitle->SelectAll(); entered(); break;

     default: printf(" ---> ChangeFocus - default - %i\n",parm1);
     }
}



//
// --- called when enter is pressed in the TGBinEntry fields
//     we recycle the logic also for cases where the focus is changed/lost as was implemented
//     before - needs some re-thinking later though - see method just below
//     if mode then we gained focus
//    ------------------------------------------------------------------------------------------------
//     mar'06 05-04:32
//     use this approach also for the axis labels
//

void FlukaMainFrame::entered(int mode)
{
  int parm1= ((TGTextEntry*)gTQSender)->WidgetId();

  if (mode) return;

  switch (parm1) {

    case MXMIN:
    case MYMIN:
    case MZMIN:
    case MXMAX:
    case MYMAX:
    case MZMAX: pushTGBEtext(parm1-MXMIN);
                SetPlane(fXYZID);
                break;

    case MXBIN:
    case MYBIN:
    case MZBIN: fBin[parm1-MXBIN]->GetNumberEntry()->SetNumber();
                SetPlane(fXYZID);
                break;

// --- labels

    case MGRAPHTITLE:
    case MXTITLE:
    case MYTITLE:
    case MZTITLE:
    case MZSCALEVALUE: Scale();
    case MZLOWER:

         remSet(fXYZID);
         UpdateHistogram();
         
         break;

    }
}



//
// --- slot to scale (or normalize) the histogram
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::Scale()
{
   fScaling= fRem->appliedScale[fXYZID];

   DEBUG(printf(" --scale-- %f %f\n",fZScaleValue->GetNumber(),fScaling);)

   if (fZScaleValue->GetNumber()<=zero) fZScaleValue->SetNumber(1);

   Double_t now= 0;
   now= (!fZNormalize->GetState()) ? fZScaleValue->GetNumber():1/(double)fZScaleValue->GetNumber();
   theHistogram->Scale(now/fScaling);
   fRem->appliedScale[fXYZID]= fScaling= now;
   UpdateHistogram();
}




//
// === following methods all deal with  dynamic slice  or  projection  of our information ===
// ========================================================================================= xxoxx ===


// --- Function Sets the integration TGBinEntry Widgets for deciding what value
//     to integrate over for the projection canvas
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::SetProjArrays(int i)
{
   int ix=fXYZID,iy=(ix+1)%3;

   if (!i) { fProjMin->SetArray(fMix[ix]->GetArray()); fProjMax->SetArray(fMix[ix]->GetArray()); }
     else { fProjMin->SetArray(fMix[iy]->GetArray()); fProjMax->SetArray(fMix[iy]->GetArray()); }

	fProjMin->SetIndex(0); fProjMax->SetIndex(fProjMax->GetArray().GetSize());
}


//
// --- Slot for the Slice Radio button that set everything up waiting for
//     user to push the Dynamic Slice Button
//     Closes canvas if it exists
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::SliceSlot()
{
   TCanvas *k= ((TCanvas*)gROOT->GetListOfCanvases()->FindObject("Projection"));
   if (k) k->Close();

   if (c1) CloseHistSlot();
   fFrame24->HideFrame(fFrame25);
   fIsSlice= 1;

   fProjectIt->SetText("dynamic slice");
}


//
// --- Slot for the Projection Radio Button that sets everything up for
//     user to push the Project It Button
//     Closes Canvas if it exists, and shows the integration variables
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::ProjectionSlot()
{
// cout << "ProjectionSlot()" << endl; //MLML
   TCanvas *k= ((TCanvas*)gROOT->GetListOfCanvases()->FindObject("Projection"));
   if (k) k->Close();

   if (c1) CloseHistSlot();
   fFrame24->ShowFrame(fFrame25);
   fIsSlice= 0;

   fProjectIt->SetText("create projection");
}


//
// --- Create a 1D Histogram as a projection in either x or y
//     Decide whether to make slot or projection
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::CreateProjection()
{
// cout << "CreateProjection" << endl;//MLML
   if (fIsSlice) {
     if (fGoingUp) { ((TCanvas*)gROOT->GetListOfCanvases()->FindObject("Projection"))->Close();
                     fProjectIt->SetState(kButtonUp);
                     fGoingUp=0;
                     c1->GetCanvas()->DeleteExec("1");
                   }
       else { fProjectIt->SetState(kButtonDown);
              fGoingUp=1;
//  -ae-?      c2->Connect("Clicked(TGFrame*,Int_t)","FlukaMainFrame",this,"HistClicked(TGFrame*,Int_t)");
//  -ae-?      c1->Connect("SelectAll()","FlukaMainFrame",this,"HistClicked()");
              if (fSlice->GetState())
                c1->GetCanvas()->AddExec("1",fXProj->GetState()? "FlukaMainFrame::MyVExec()":"FlukaMainFrame::MyHExec()");
              fProjCanvas= new TCanvas("Projection","Projection",_six00,_six00);
              setCanvasAspect(fProjCanvas,1,0);
              fProjCanvas->Connect("Closed()","FlukaMainFrame",this,"CloseHistSlot()");
              fProjCanvas->Update();
              fProjCanvas->SetLogy();
              fProjCanvas->SetGrid();
              fProjCanvas->ToggleEventStatus();
              fProjCanvas->SetCrosshair();
            }
     }
     else { fProjCanvas = new TCanvas("Projection","Projection",_six00,_six00);
            setCanvasAspect(fProjCanvas,1,0);
            c1->GetCanvas()->DeleteExec("2");
            c1->GetCanvas()->AddExec("2","FlukaMainFrame::MySimpleExec()");
            fProjCanvas->Connect("Closed()","FlukaMainFrame",this,"CloseHistSlot()");
            fProjCanvas->cd();
            fProjCanvas->Update();
            fProjCanvas->SetLogy();
            fProjCanvas->SetGrid();
            fProjCanvas->ToggleEventStatus();
            fProjCanvas->SetCrosshair();
            FbeHist *h= theHistogram;
            TH1 *h1= (TH1*)gDirectory->GetList()->FindObject("Proj");
            if (h1) delete h1;
            char title[256]="";
            if (fXProj->GetState()) {
              sprintf(title,"Vertical Projection from %g to %g",fProjMin->GetNumber(),fProjMax->GetNumber());
              h1= h->ProjectionY("Proj",fProjMin->GetIndex()+1,fProjMax->GetIndex(),"e"); }
              else {
                     sprintf(title,"Horizontal Projection from %g to %g",fProjMin->GetNumber(), fProjMax->GetNumber());
                     h1= h->ProjectionX("Proj",fProjMin->GetIndex()+1,fProjMax->GetIndex(),"e"); }

            h1->SetFillColor(38);
            h1->Draw("hist,y");
            if(!strcmp(h->GetName(),"S")) h1->Draw("same,e");
            gPad->SetFillColor(0); gPad->SetFrameBorderMode(0);
            fProjCanvas->Update();
            c1->GetCanvas()->cd();
          }
}


//
//     mar'06 09-16:48
// --- copied/modified from root distribution
//     (originally by Matt)
//     exec that does the horizontal(vertical) dynamic slice stuff
//

void FlukaMainFrame::MyVExec() { MyHExec(1); }

void FlukaMainFrame::MyHExec(int vh)
{

   char title[256];
   static int oldx=0,oldy=0,toni=1;

   TObject *select= gPad->GetSelected();
   if (!select || !select->InheritsFrom("TH2")) return;
   TH2 *h= (TH2*)select;
   gPad->GetCanvas()->FeedbackMode(kTRUE);
   gPad->SetFillColor(0);
   gPad->SetFrameBorderMode(0);

   int px= gPad->GetEventX();
   int py= gPad->GetEventY();
   float uxmin= gPad->GetUxmin();
   float uxmax= gPad->GetUxmax();
   int pxmin= gPad->XtoAbsPixel(uxmin);
   int pxmax= gPad->XtoAbsPixel(uxmax);
   float uymin= gPad->GetUymin();
   float uymax= gPad->GetUymax();
   int pymin= gPad->YtoAbsPixel(uymin);
   int pymax= gPad->YtoAbsPixel(uymax);

   float upy=(vh)?gPad->AbsPixeltoX(px):gPad->AbsPixeltoY(py);
   float y=(vh)?gPad->PadtoX(upy):gPad->PadtoY(upy);

   if (!toni) { toni= 1;
                if (vh) gVirtualX->DrawLine(oldx,pymin,oldx,pymax); else gVirtualX->DrawLine(pxmin,oldy,pxmax,oldy); }

   if (px==oldx && py==oldy) { oldx=oldy=0; toni = 0; }

   if (pymin>py && py>pymax && pxmin<px && px<pxmax) {
     if (oldy) { if (vh) gVirtualX->DrawLine(oldx,pymin,oldx,pymax); else gVirtualX->DrawLine(pxmin,oldy,pxmax,oldy); }
     if (vh) gVirtualX->DrawLine(px,pymin,px,pymax); else gVirtualX->DrawLine(pxmin,py,pxmax,py);
     oldy= py;
     oldx= px;
     }

   TVirtualPad *oPad= gPad;
   TCanvas *c2= (TCanvas*)gROOT->GetListOfCanvases()->FindObject("Projection");
   if (c2) delete c2->GetPrimitive("Projection");
   c2->cd();

   Int_t bin= (vh)? h->GetXaxis()->FindBin(y):h->GetYaxis()->FindBin(y);

   TH1D *c= (TH1D*)gROOT->FindObject("hp"); if (c) c->Delete();
   TH1D *hp= (vh)? h->ProjectionY("Proj",bin,bin,"e"):h->ProjectionX("Proj",bin,bin,"e");
   hp->SetFillColor(38);
   sprintf(title,"Projection of biny=%d",bin);
   hp->SetName("Projection");
   hp->SetTitle(title);

   if (hp->GetEntries()) { hp->Draw("hist"); 
                           if (!strcmp(h->GetName(),"S")) hp->Draw("same,e"); }
   gPad->SetFillColor(0);
   gPad->SetFrameBorderMode(0);

   c2->Update();
   oPad->cd();
}



//____________________________________________________________________________________
void FlukaMainFrame::MySimpleExec()
{
//Simple Exec needed for Projection Histogram

   //cout << "MySimpleExec()" << endl;//MLML
   TCanvas *c2= (TCanvas*)gROOT->GetListOfCanvases()->FindObject("Projection");
   if(!c2) return;
   TVirtualPad *oPad= gPad;
   c2->cd();
   c2->Update();
   oPad->cd();
}


//____________________________________________________________________________________
void FlukaMainFrame::CloseHistSlot()
{
// Slot that is called when histogram is closed

// cout << "CloseHistSlot()" << endl;//MLML
// c1->Disconnect("TGCanvas","Clicked(TGFrame*,Int_t)",this,"HistClicked(TGFrame*,Int_t)");
   c1->GetCanvas()->DeleteExec("1");
   c1->GetCanvas()->DeleteExec("2");
   fGoingUp=0;
   fProjectIt->SetState(kButtonUp);
}


void FlukaMainFrame::HistClicked(TGFrame *,Int_t)
{
// cout << "HistClicked()" << endl;
}


// ========================================================================================= xxoxx ===
// === above methods all deal with  dynamic slice  or  projection  of our information ===
//



//
// --- 
//    ------------------------------------------------------------------------------------------------
//

int FlukaMainFrame::GetCompression(int i)
{
   int ix=(!i)?fXYZID:(fXYZID+1)%3;
   return (fMix[ix+3]->GetIndex()-fMix[ix]->GetIndex())/(int)fBin[ix]->GetNumber();
}



//
// --- here we react to user requested rebinning
//     trouble for switching to new binning while in rebin mode - works right now, only because
//     we redraw the histogram befor moving onto next binning
//     set rebin mode, but also revert to original binning when we lose 'focus' for a binning
//    ------------------------------------------------------------------------------------------------
//     may'06 22-14:47
//     moved static int _rebinned to global/top, causes trouble of we have a rebinnerd histogram
//     and just open another file at that time --- not clean, fix later
//

void FlukaMainFrame::AllowReBinSlot()
{
	DEBUG(printf(" -AllowReBinSlot- %3i - %3i \n",_rebinned,fXYZID);)

	if (_rebinned) {

     c1->GetCanvas()->SetEditable(kTRUE);
     fAllowReBin->SetText("       Bins      ");
     _rebinned = 0;
     fAllowReBin->SetOn(kFALSE);

     for (int ix=0;ix<3;ix++) {

        fMix[ix]->SetState(kTRUE); fMix[ix+3]->SetState(kTRUE);

        fBin[ix]->SetState(kFALSE);
        fBin[ix]->SetArray(CreateModdedArray(fMix[ix]->GetIndex(),fMix[ix+3]->GetIndex()));
        fBin[ix]->SetIndex(1000000000);

        fSize[ix]->SetNumber((fMix[ix+3]->GetNumber()-fMix[ix]->GetNumber())/fBin[ix]->GetNumber());
      }

     int iz= (fXYZID+2)%3;
     fBin[iz]->SetNumber(1); fSize[iz]->SetNumber(fMix[iz+3]->GetNumber()-fMix[iz]->GetNumber());

     theBinning->setRebin(0);
     if (theBinning->indexof()!=fBinningFrame->GetSelected()%1000-1) { DEBUG(printf(" -well-\n");)
                                                                       theBinning->setWasRebinned(); }
     UpdateHistogram();
    }

	else {

     c1->GetCanvas()->SetEditable(kTRUE);
     fAllowReBin->SetText("     ReBinning     ");
     _rebinned= 1;
     fAllowReBin->SetOn(kTRUE);

     theBinning->setRebin(1);

     for (int ix= 0;ix<3;ix++) { int iy= (ix+1)%3;
                                 fMix[ix]->SetState(kFALSE);
                                 fMix[ix+3]->SetState(kFALSE);
                                 fBin[ix]->SetState(fXYZID==iy?kFALSE:kTRUE);
                               }
      UpdateHistogram();
      c1->GetCanvas()->SetEditable(kFALSE);
	}
}


// --- sep'06 21-01:40
//     try and cleanup our left over logic here
//     problem: with the super slots() root calls into ButtonGroup really funny
//              even if exclusive - so drop that and use old way
//              see also RADIOBUTTON stuff up there
//

void FlukaMainFrame::ChangePlane(int view)
{
   DEBUG(printf(" ---> change plane %i -> %i\n",fXYZID,view);)

   remPush(view);
   fXYZID= fRem->selected;

   if (fAllowReBin->IsOn()) AllowReBinSlot();
   UpdateBinMatrix();
   SetPlane(fXYZID);
}



void FlukaMainFrame::ResetHist()
{
   DEBUG(printf(" ---> reset got called here for view %i\n",fXYZID);)

   remReset(fXYZID);
   remPush(fXYZID);

   UpdateBinMatrix();
   if (fAllowReBin->IsOn()) AllowReBinSlot();
   SetPlane(fXYZID);
}




//
// --- When File -> Save is pressed, WriteScript will generate a .C file in which
//     the current configuration of the histogram will be saved.  This file is a root
//     macro that can be run in root and will recreate just the histogram.
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::WriteScript()
{
   TGFileInfo *fFileInfo = new TGFileInfo();
   const char *temp[] = {"ROOT Macros", "*.C", 0, 0};
   fFileInfo->fFileTypes = temp;
   char fp[256],value1[256] = "script1.C";
   fFileInfo->fFilename = value1;
   new TGFileDialog(fClient->GetRoot(), this, kFDSave, fFileInfo);

   if (!fFileInfo->fFilename) { cout << "Invalid File Name, Try Again" << endl; return; }
   strcpy(fp,fFileInfo->fFilename);

   DEBUG(printf(" ---> WriteScript()\n");)
// --- this needs work, not safe and not intuitive (feb'06)
//
   if (fp[strlen(fp)-1] !='C' && fp[strlen(fp)-2] !='.') strcat(fp,".C");

   int doColor= fEnableColor->GetState() + fPrintOptCheck->GetState()*2;

   ofstream out(fp,ios::out);

   out << "// This \"ROOT Macro\" has been automatically generated by the flukaGUI." << endl
       << "// Please do not modify the following comments as they are needed" << endl << endl
       << "// " << _pwd << endl
       << "// " << fTextData->GetText() << endl;
	
   if (fImportFbeGeom && !fImportScan)
      out << "// " << 1 << " " << fGeometry->GetState() << " " << fTextGeom->GetText() << endl;
     else if (!fImportFbeGeom && fImportScan)
            out << "// " << 2 << " " << fGeometry->GetState() << " " << fTextInput->GetText() << endl;
            else
                  out << "// " << 0 << " " << fGeometry->GetState() << endl;

   out << "// " << fBinningFrame->GetSelected()%1000-1 << " " << fXYZID << "  Binning and Plane" << endl
       << "// " << theBinning->isRebinned() << " " << GetCompression(0) << " " << GetCompression(1) << "  rebin" << endl
       << "// " << fXMin->GetNumber() << " " << fXMax->GetNumber() << "   X Limits " << endl
       << "// " << fYMin->GetNumber() << " " << fYMax->GetNumber() << "   Y Limits " << endl
       << "// " << fZMin->GetNumber() << " " << fZMax->GetNumber() << "   Z Limits " << endl
       << "// " << fGraphTitle->GetText() << endl
       << "// " << fXTitle->GetText() << endl
       << "// " << fYTitle->GetText() << endl
       << "// " << fZTitle->GetText() << endl
       << "// " << fZLower->GetNumber() << " " << (int) fColorPerDec->GetNumber() << " "
       << doColor << " " << endl
       << "// " << fSwap->GetState() << endl
       << "// " << fRem->Aspect[fXYZID] << " " << fRem->AspectRatio[fXYZID] << endl << endl;

   TString temp2(fp);
   while (temp2.Index("/",1)!=kNPOS) temp2.Remove(0,temp2.Index("/",1));
   temp2.Remove(0,1);
   temp2.Remove(temp2.Length()-2,temp2.Length());
   TVirtualHistPainter *yeah = new THistPainter();
   yeah->SetPainter("FbeHistPainter");
   delete yeah;

   int bin = fBinningFrame->GetSelected()%1000-1;

   char pwd[256]; strcat(strcpy(pwd,_here),"/");

   out << "int " << temp2 << "()" << endl << "{" << endl
       << "   " << "gSystem->Load(\"" << pwd << "libFbe\");" << endl
       << "   " << "gSystem->Load(\"" << pwd << "libFluka\");" << endl
       << "   " << "TVirtualHistPainter *Fake = new THistPainter();" << endl
       << "   " << "Fake->SetPainter(\"FbeHistPainter\");" << endl
       << "   " << "delete Fake;" << endl
       << "\n   " << "gROOT->Reset();" << endl
       << "   " << "gStyle->SetOptStat(0);" << endl
       << "   " << "gStyle->SetLabelOffset(0.02,\"x\");" << endl
       << "   " << "gStyle->SetLabelSize(0.035,\"x\");" << endl
       << "   " << "gStyle->SetTickLength(-0.02,\"x\");" << endl
       << "   " << "gStyle->SetLabelOffset(0.02,\"y\");" << endl
       << "   " << "gStyle->SetLabelSize(0.035,\"y\");" << endl
       << "   " << "gStyle->SetTickLength(-0.02,\"y\");" << endl
       << "   " << "gStyle->SetTitleOffset(1.4,\"x\");" << endl
       << "   " << "gStyle->SetTitleOffset(1.4,\"y\");" << endl
       << "   " << "gStyle->SetTitleSize(0.05,\"x\");" << endl
       << "   " << "gStyle->SetTitleSize(0.05,\"y\");" << endl
       << "   " << "gStyle->SetTitleFillColor(0);" << endl
       << "   " << "gStyle->SetTitleBorderSize(0);" << endl

       << "\n   " << temp2 << " = new TCanvas(\"" << temp2 << "\",\"" << temp2 << "\"," << _six00 << "," << _six00 <<");" << endl
       << "   " << temp2 << "->SetBorderMode(0);" << endl
       << "   " << temp2 << "->cd();" << endl
       << "   " << temp2 << "->SetLogz();" << endl
       << "   " << temp2 << "->SetBorderSize(1);" << endl
       << "   " << temp2 << "->SetTopMargin(" << c1->GetCanvas()->GetTopMargin() << ");" << endl
       << "   " << temp2 << "->SetBottomMargin(" << c1->GetCanvas()->GetBottomMargin() << ");" << endl
       << "   " << temp2 << "->SetRightMargin(" << c1->GetCanvas()->GetRightMargin() << ");" << endl
       << "   " << temp2 << "->SetLeftMargin(" << c1->GetCanvas()->GetLeftMargin() << ");" << endl;

   out << "\n   " << "usrbin = new FbeUsrbinFile(\"" << _pwd << fTextData->GetText() << "\");" << endl;
   out << "   " << "FbeUsrbin *theBinning= usrbin->getABinning(" << bin << ");" << endl;
   out << "   " << "                       usrbin->readData(theBinning);" << endl;

   out << "   " << "FbeHist *theHistogram= theBinning->GetHist(" << fXYZID << ");" << endl;
   out << "   " << "theBinning->setRebin(" << theBinning->isRebinned() << ");" << endl;

   out << "   " << "theHistogram= theBinning->hist(" << fXYZID << ",";
   switch(fXYZID) {
      case 0: out << fXMin->GetNumber()<< "," << fXMax->GetNumber() << "," << fYMin->GetNumber() << ","
                  << fYMax->GetNumber() << "," << fZMin->GetNumber() << "," << fZMax->GetNumber();
              break;
      case 1: out << fYMin->GetNumber()<< "," << fYMax->GetNumber() << "," << fZMin->GetNumber() << ","
                  << fZMax->GetNumber() << "," << fXMin->GetNumber() << "," << fXMax->GetNumber();
              break;
      case 2: out << fXMin->GetNumber()<< "," << fXMax->GetNumber() << "," << fYMin->GetNumber() << ","
                  << fYMax->GetNumber() << "," << fZMin->GetNumber() << "," << fZMax->GetNumber();
              break;
      }

   out <<  ", " << GetCompression(0) << "," << GetCompression(1) << ");" << endl;
   out << "\n   " << temp2 << "->GetCanvas()->SetFillColor(0);" << endl;
   out << "   " << temp2 << "->GetCanvas()->SetFrameBorderMode(0);" << endl;
   out << "   " << temp2 << "->Clear();" << endl;

   out << "\n   " << "theHistogram->SetTitle(\"" << fGraphTitle->GetText() << "\");" << endl
       << "   " << "theHistogram->GetXaxis()->SetTitle(\"" << fXTitle->GetText() << "\");" << endl
       << "   " << "theHistogram->GetXaxis()->CenterTitle(kTRUE);" << endl
       << "   " << "theHistogram->GetYaxis()->SetTitle(\"" << fYTitle->GetText() << "\");" << endl
       << "   " << "theHistogram->GetYaxis()->CenterTitle(kTRUE);" << endl
       << "   " << "theHistogram->GetZaxis()->SetTitle(\"" << fZTitle->GetText() << "\");" << endl
       << "   " << "theHistogram->GetZaxis()->SetTitleOffset(0.23);" << endl;

   out << "\n   " << "theHistogram->"
       <<"preparePalette(" << fZLower->GetNumber() << "," << (int)fColorPerDec->GetNumber() << ","
       << doColor << "," << fZScaleValue->GetNumber() << ");" << endl;
   out << "   " << "theHistogram->Draw(\"" << "colz" << "\");" << endl;
   out << "\n   " << temp2 << "->Update();" << endl << "   return 0;" << endl;
   out << "}" << endl << endl;

   out.close();
}



//
//     jan'05 19-21:13
// --- ReadScript() is the opposite of WriteScript(). It reads back in  a root macro (*.C)
//     that was created with WriteScript into the GUI for quick and easy modification
//     No need to start from scratch
//     we actually only read the // comments from the top of the script - the script itself
//     can be used from within an interactive root session to re-create the graph which had been saved
//
//     problem: need to make all paths absolute so that if root is run somewhere else but
//              here all works as expected
//              still required checking in geometry/input file processing
//              reading NO filename for geometry/input if first number ==0   (jan'05 22-04:58)
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::ReadScript()
{
   TGFileInfo *fFileInfo= new TGFileInfo();

   int cancel=0,gotAScript= 0;
   static TString sdir(".");
   static TString sfile("garNix"),keepSfile("script1.C");
   if (!strcmp(sfile.Data(),"garNix")) sfile= keepSfile;

   fFileInfo->fFileTypes = scriptFileTypes;
   fFileInfo->fIniDir= StrDup(sdir.Data());
   fFileInfo->fFilename= StrDup(sfile.Data());
   fFileInfo->fFileTypeIdx= SelectedScriptFileType;

   new TGFileDialog(fClient->GetRoot(), this, kFDOpen, fFileInfo);

   if (fFileInfo->fFilename) { sfile= fFileInfo->fFilename;
                               if (sfile.BeginsWith(_pwd)) sfile.ReplaceAll(_pwd,"");

                               sdir= fFileInfo->fIniDir;
                               if (sdir.BeginsWith(_pwd)) sdir.ReplaceAll(_pwd,"");

                               SelectedScriptFileType= fFileInfo->fFileTypeIdx;
                               gotAScript= try2openScriptFile(sfile);
                             }
     else cancel= 1;

   if (!cancel) { if (!gotAScript) { sfile= keepSfile; return; }}
     else return;


   disconnectFile(MDclose);
   disconnectFile(MIclose);
   disconnectFile(MGclose);

// ----
//
   char Buffer[256],DataFile[256],GeomFile[256],PWD[256];
   int g;
   ifstream in(fFileInfo->fFilename,ios::in);

   in.getline(Buffer,255,'\n');
   in.getline(Buffer,255,'\n');
   in.getline(Buffer,255,'\n');

   in.get(); in.get(); in.get(); in.getline(PWD,255,'\n');
   if (!strcmp(_pwd.Data(),PWD)) strcpy(PWD,"");
   in.get(); in.get(); in.get(); in.getline(Buffer,255,'\n');

   strcpy(DataFile,PWD); strcat(DataFile,Buffer);

   DEBUG(printf(" ---> _%s_\n",DataFile);)
   fTextData->SetText(DataFile);

   int I;
   in.get(); in.get(); in.get(); in >> g; in >> I; in.get();
   if (g>0) { in.getline(GeomFile,255,'\n');
              if (g==1) fTextGeom->SetText(GeomFile);
                else if (g==2) fTextInput->SetText(GeomFile);
            }

   int binning,ivalue, rebin,xcomp,ycomp;
   double value;
   char Titles[256];

   fImportData= kFALSE;
   fMainTab->Selected(1);

   in.get(); in.get(); in >> binning;

   fBinningFrame->Select(1001+binning);
   fBinningFrame->GetListBox()->Selected(1001+binning);

   in >> fXYZID;

   fXYZButtonGroup->SetButton(MXY+fXYZID);
   ChangePlane(fXYZID);

   in.getline(Buffer,255,'\n'); in.get(); in.get(); in.get();
   in >> rebin >> xcomp >> ycomp;

   if (fAllowReBin->IsOn()) AllowReBinSlot();
   UpdateBinMatrix();
   SetPlane(fXYZID);

   in.getline(Buffer,255,'\n'); in.get(); in.get();
   in >> value; fXMin->SetNumber(value);
   in >> value; fXMax->SetNumber(value);

   in.getline(Buffer,255,'\n'); in.get(); in.get();
   in >> value; fYMin->SetNumber(value);
   in >> value; fYMax->SetNumber(value);

   in.getline(Buffer,255,'\n'); in.get(); in.get();
   in >> value; fZMin->SetNumber(value);
   in >> value; fZMax->SetNumber(value);

   SetBinMatrix();

   in.getline(Buffer,255,'\n'); in.get(); in.get(); in.get(); in.getline(Titles,255,'\n');
   fGraphTitle->SetText(Titles);

   in.get(); in.get(); in.get(); in.getline(Titles,255,'\n');
   fXTitle->SetText(Titles);

   in.get(); in.get(); in.get(); in.getline(Titles,255,'\n');
   fYTitle->SetText(Titles);

   in.get(); in.get(); in.get(); in.getline(Titles,255,'\n');
   fZTitle->SetText(Titles);

   in.get(); in.get();
   in >> value; fZLower->SetNumber(value);
   in >> ivalue; fColorPerDec->SetNumber(ivalue);
   in >> ivalue;  if (ivalue<2) fPrintOptCheck->SetOn(kFALSE); else fPrintOptCheck->SetOn(kTRUE);
                  if (ivalue%2) fEnableColor->SetOn(kTRUE); else fEnableColor->SetOn(kFALSE);

   in.getline(Buffer,255,'\n');
   in.get(); in.get(); in >> ivalue; if (ivalue) fSwap->SetOn(kTRUE);
   theHistogram->swap(ivalue);

   in.getline(Buffer,255,'\n');
   in.get(); in.get(); in >> ivalue;
                      switch(ivalue) { case 1: _preserve->SetDown(); break;
                                       case 2: _manually->SetDown(); break; }
                       in >> value; _ratio->SetNumber(value);
   in.close();


//
// --- needs still to be looked at
//     if we had the same histogram from a script with geometry we wont lose that geometry
//     when we load a script without - don't know why yet


   if (g>0) {

     fMainTab->GetTabTab(3)->SetEnabled(kTRUE);

     if (g==1) { fImportGeom= try2openStoreFile(fTextGeom->GetText());
                 if (fImportGeom) { DEBUG(printf(" --reset Scan-4- %i %i\n",fImportInput,fImportScan);)
                                    fImportScan= fImportInput= kFALSE; }}

       else if (g==2) { fImportInput= try2openInputFile(fTextInput->GetText());
                        if (fImportInput) { // fGeometry->SetOn(kTRUE);
                                            fImportGeom= fImportFbeGeom= kFALSE; }}

       }
         else { fGeometry->SetOn(kFALSE);
                fImportGeom= fImportFbeGeom= fImportScan= fImportInput= kFALSE;
                fMainTab->GetTabTab(3)->SetEnabled(kFALSE); }


   if (!fImportGeom) fFrame1->HideFrame(fFrame4);
     else if (fImportData && !fImportFbeGeom) { fImportFbeGeom= kTRUE; fGeometry->SetOn(I==1); UpdateHistogram(); }
   if (!fImportInput) fFrame1->HideFrame(fFrame6);
     else if (fImportData &&!fImportScan) { fImportScan= kTRUE; fGeometry->SetOn(I==1); UpdateHistogram(); }

// ---
   ChangeRange();
   SetPlane(fXYZID);
   SliceSlot();
}



//
// --- get a common/reasonable histogram style implemented
//     the axis titles are swapped according the underlying main histogram
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::OurStyle(TH2 *h, int mode)
{
   if (mode==0) { if (fSwap->GetState()) { h->GetXaxis()->SetTitle(fYTitle->GetText());
                                           h->GetYaxis()->SetTitle(fXTitle->GetText()); }
                    else { h->GetXaxis()->SetTitle(fXTitle->GetText());
                           h->GetYaxis()->SetTitle(fYTitle->GetText()); }
                }
     else { h->GetXaxis()->SetTitle(_xtitle);
            h->GetYaxis()->SetTitle(_ytitle); }

   h->GetZaxis()->CenterTitle(kTRUE);

   if (mode==0) { h->SetTitle(fGraphTitle->GetText());
                  h->GetZaxis()->SetTitle(fZTitle->GetText());
                  h->GetZaxis()->SetTitleOffset(0.20);
                  h->GetZaxis()->SetTitle(fZTitle->GetText()); }
     else h->SetTitle("geometry scan");

   // ---> who implemented this one in root?   h->GetZaxis()->SetMoreLogLabels(kTRUE);
}



//
//     jan'05 18-09:49
// --- start to make things more modular using the new root GUI philosophy
//     a first, find code related to Tab selection here
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::doTabs(int n)
{
  DEBUG(printf(" ===> doTabs() %3i\n",n);)
  static int keepThis=kFALSE,andThat=kFALSE;
  int scoreType;

  if (keepThis) { keepThis= kFALSE; fImportBinning= andThat; }
  c1->GetCanvas()->Disconnect("ProcessedEvent(int,int,int,TObject*)",this,"zoomExec(int,int,int,TObject*)");

  if (!FLUKA_OK) { fCloseIB->Clicked(); doTabs(0); }


  switch(n) {

    case 0:        //-- Tab1 ------
            break;

    case 2:
            fTitleFrame3->Layout();
            if (fImportBinning) break;
    case 1:

            geometryTab= kFALSE;
            fMenuFile->EnableEntry(MFileSave);

            if (!fImportData) {
                                fImportData= try2openDataFile(fTextData->GetText());
                                fImportBinning= kFALSE; }

            if (!fImportData) fMainTab->SetTab(0);
              else
                   if (!fImportBinning) {
                     fImportBinning= kTRUE;

                     fMenuFile->EnableEntry(MFileSave);
                // ---------------------------------------------------------- setup info for Tab2 ---
                     fText2->SetText(new TGString(fTitleUsr2->GetText()));
                     fText5->SetText(new TGString(fmyUsrBins->filename()));
                // -----------------------
                     fText1->SetText(new TGString(fTitleUsr4->GetText()));
                     fText0->SetText(new TGString(fTitleUsr5->GetText()));

                // ---> see UpdateHistogram() fGraphIntro5->SetText(tmp0);
                // ---------------------------------------------------------
                     fTitleFrame2->Layout();  // <--- important ---

                     char temp[256];
                     fMids.Set(fmyUsrBins->nrOfBinnings()*3);
                     for (int i=0;i<fmyUsrBins->nrOfBinnings();++i)
                     {
                        strcpy(temp,"");
                        sprintf(temp,"%i.) ",i+1);
                        strcat(temp,fmyUsrBins->getABinning(i)->name());
                        strcat(temp , " - ");
                        strcat(temp,mapTypes[fmyUsrBins->getABinning(i)->type()]);
                        strcat(temp , " - ");
                        strcat(temp , scores2[fmyUsrBins->getABinning(i)->score()+7] );
                        scoreType= fmyUsrBins->getABinning(i)->score();
                        char n[4]; sprintf(n,"%i",scoreType);
                        strcat(temp ,"("); strcat(temp ,n); strcat(temp ,")");
                        fBinningFrame->AddEntry(temp,1001+i);
                        fMids[3*i+0] = fmyUsrBins->getABinning(i)->limits()[2] * 0.5;
                        fMids[3*i+1] = fmyUsrBins->getABinning(i)->limits()[5] * 0.5;
                        fMids[3*i+2] = fmyUsrBins->getABinning(i)->limits()[8] * 0.5;
                     }

                     fBinningFrame->Select(1001);
                     fBinningFrame->GetListBox()->Selected(1001);
                     doListBox();

                // --- this to have that listbox always have the correct size, needs testing with MANY binnings
                //
                     TGListBox *lb= fBinningFrame->GetListBox();
                     lb->MapSubwindows();
                     lb->Layout();
                     TGDimension fw= lb->GetContainer()->GetDefaultSize();
                     lb->Resize((fw.fWidth+10>300)?300:fw.fWidth+25,(fw.fHeight+10>202)?202:fw.fHeight+10);

                     SliceSlot();
                     if (fAllowReBin->IsOn()) AllowReBinSlot();
                    }

            if (!fImportGeom) fFrame1->HideFrame(fFrame4);
              else if (fImportData && !fImportFbeGeom) { fImportFbeGeom= kTRUE; UpdateHistogram(); }
            if (!fImportInput) fFrame1->HideFrame(fFrame6);
              else if (fImportData && !fImportScan) fImportScan= kTRUE; UpdateHistogram();

            break;


    case 3: DEBUG(printf(" -hey- our geometry Tab\n");)
            geometryTab= kTRUE;

            fMenuFile->DisableEntry(MFileSave);
            fGeoButton1->SetEnabled(theHistogram!=NULL);

// --- should only happen the first time for a new input file --- FIXME

          { int i,other=(_gview+2)%3;
            for (i=0;i<6;i++) { _gco[i]->SetState(kTRUE); _gco[i]->SetNumber(_xyz[i]); }
            _zd->SetNumber(_z[_gview]);
            _gco[2*other]->SetState(kFALSE);
            _gco[2*other+1]->SetState(kFALSE);
          }

            updateGeometry(); 
    }
}



//
//     jan'05 24-06:32
// --- shift TGListBox signal over to new method since we do not get a signal when
//     we change our selection by calling rather than pushing actual buttons
//     in fact we actually trigger the signal sent by root ourselves
//    ------------------------------------------------------------------------------------------------
//     mar'07 09-14:42
// --- since root insists on leaving the ListBox open until we get out of here - need
//     to revert to old-style ProcessMessage(), we just call ourselves at init once
//     since above remark still holds
//

void FlukaMainFrame::doListBox()
{
   int id= fBinningFrame->GetSelected()%1000-1;
 
   setOurCursor(kWatch);
   gSystem->ProcessEvents();  // --- this is magic here ---

   if (fmyUsrBins->getABinning(id)->supported()) {
     if (fAllowReBin->IsOn()) AllowReBinSlot();

     theBinning= fmyUsrBins->getABinning(id);
     fRem= theBinning->getRem();

     if (theBinning->need2read()) { fmyUsrBins->readData(theBinning);
                                    for (int i=0;i<3;i++) { remReset(i); remPush(i); }
                                    fXYZID= (theBinning->rphiZ()) ? RPhiView:XYview;
                                    ChangePlane(fXYZID); }
       else ChangePlane(-1);

     switch (fXYZID) { case 0: fXYButton->SetOn(); break; case 1: fYZButton->SetOn(); break; case 2: fZXButton->SetOn(); }

     theHistogram= theBinning->GetHist(fXYZID);
     UpdateBinMatrix();
     SetPlane(fXYZID);

//   we don't know how to do any of this in case of rphi graphs (yet)
//   feb'05 02-02:15
//  --------------------------------------------------------- 
     if (theBinning->rphi()) { fFrame2->HideFrame(fFrame24); fFrame2->HideFrame(fFrame23); }
       else { fFrame2->ShowFrame(fFrame24); fFrame2->ShowFrame(fFrame23); }
     }

       else { DEBUG(printf(" -doListBox()- %i\n",theBinning->indexof());)
              fBinningFrame->Select(1001+theBinning->indexof());
              fmyUsrBins->getABinning(theBinning->indexof());
// -ae- somehow this locks the root application ---
//      ignore the user request simply for now
//
//            char emsg[256];
//            sprintf(emsg, "this type of Binning is not supported by the GUI at this point\n"
//                          "please select a different Binning (%i)\n",fBinningFrame->GetSelected()%1000-1);
//            new TGMsgBox(gClient->GetRoot(),this,"m",emsg,kMBIconAsterisk,kMBOk);
//            DEBUG(printf(" -doListBox()- %i\n",theBinning->indexof());)
// -ae- somehow this locks the root application ---
              fBinningFrame->Select(1001);
            }

   setOurCursor(kPointer);
}




//
//     jan'05 26-18:16
// --- try and really swap the whole thing
//     needs to be remembered so that we only do it once and then go back if swap is deselected
//    ------------------------------------------------------------------------------------------------
//     feb'06 23-13:17
//     removed all our own swap() related code except setting 'swap' for the histogram option
//     patched THistPainter to permit swapping of XY for 2D plots
//

void FlukaMainFrame::swap() { fXTitle->SetText(fRem->YLabels[fXYZID]);
                              fYTitle->SetText(fRem->XLabels[fXYZID]);

                              FbeHist *fbeH=theHistogram; fbeH->swap(1); UpdateHistogram();
                              fRem->Swap[fXYZID]= kTRUE; }




//
// --- mar'06 01-09:10
//     here deal with our geometry scan derived from the FLUKA input file
//     we are wasteful, we rescan the geometry even if we already have it from a
//     previous view - all too messy to fix right now
//

void FlukaMainFrame::updateGeometry(int changeView)
{
   if (!FLUKA_OK) return;

   setOurCursor(kWatch);

   static char  *t[3]={"x(cm)","y(cm)","z(cm)"};
   if (changeView==-1) changeView= 0;

   _xtitle= t[_gview];
   _ytitle= t[(_gview+1)%3];

   fmyGxyz[_gview]->reset();

//
// --- view changed, reload its _xyz info
//
   if (changeView) {
                     fGeoLines->SetNumber(_nr[_gview]);
                     for (int i=0;i<6;i++) _gco[i]->SetState(kTRUE);
                     int other=(_gview+2)%3; _gco[2*other]->SetState(kFALSE); _gco[2*other+1]->SetState(kFALSE);
                     _zd->SetNumber(_z[_gview]);
                   }
     else {
            for (int i=0;i<6;i++) _xyz[i]= _gco[i]->GetNumber();
            _z[_gview]= _zd->GetNumber();
          }
//
// --- request for extra info to plot, either histogram data or FLUKA materials
//
   if (gTQSender==_show) if (_show->IsDown()) {
                           if (theHistogram==NULL) { _show->SetState(kButtonUp); setOurCursor(kPointer); return; }
                             else fGeoRegions->SetState(kButtonUp); }

   if (gTQSender==fGeoRegions) if (fGeoRegions->IsDown()) _show->SetState(kButtonUp); 

   drawGeometry();

   previousBinning= -1;

   setOurCursor(kPointer);
}



//
//     jan'05 27-03:04
// --- wrapper to push a text entry from min/max fields into our variables
//     this is the place to implement policy about bad entry values
//     make sure we have at least 1 bin - find nearest sensful index
//    ------------------------------------------------------------------------------------------------
//

void FlukaMainFrame::pushTGBEtext(int ib)
{
  int ix=ib%3, minima=ib<3;
  fMix[ib]->GetNumberEntry()->SetNumber();

  if (fMix[ix]->GetIndex()>=fMix[ix+3]->GetIndex()) {
    if (minima) fMix[ix]->SetIndex( fMix[ix+3]->GetIndex()-1 );
      else fMix[ix+3]->SetIndex( fMix[ix]->GetIndex()+1 );
    }

  fBin[ix]->SetArray(CreateModdedArray(fMix[ix]->GetIndex(),fMix[ix+3]->GetIndex()));
  fBin[ix]->SetIndex(10000000);
}




// --- mar'06 05-13:23
//    ------------------------------------------------------------------------------------------------
//     hey, so what, we use a struct - should all be it's own class
//

void FlukaMainFrame::remReset(int i)
{
   static char *labels[3]={"x(cm)","y(cm)","z(cm)"}, *_ARG[3]= {"r(cm)","#Phi(rad)","z(cm)"};

   fRem->selected= (theBinning->rphiZ()) ? RPhiView:XYview;

   if (theBinning->score()>227) strcpy(fRem->Title[i],"special -> see manual");
     else {
            if (theBinning->score()==208 || theBinning->score()==211) strcpy(fRem->Title[i],"energy density (GeV/cm^{3}/primary)");
              else strcpy(fRem->Title[i],"fluence (cm/cm^{3}/primary)"); }

   int ix= i,iy=(i+1)%3,iz=(i+2)%3;
   strcpy(fRem->XLabels[i],labels[ix]);
   strcpy(fRem->YLabels[i],labels[iy]);
   strcpy(fRem->ZLabels[i],labels[iz]);
   if (i>0) { if (theBinning->rphi()) strcpy(fRem->YLabels[i],_ARG[iy]);
              if (theBinning->rphiZ()) strcpy(fRem->XLabels[i],_ARG[ix]); }
 
   fRem->Histogram[i]= kTRUE;
   fRem->Geometry[i]= fGeometry->GetState();

   strcpy(fRem->Scored[i],"");
   fRem->Swap[i]= kFALSE;
   fRem->Normalize[i]= kTRUE;
   fRem->Scale[i]= 1;
   fRem->appliedScale[i]= 1;
   fRem->Anchor[i]= 0;
   fRem->EnableColorPalette[i]= kTRUE;
   fRem->FLukaScheme[i]= kTRUE;
   fRem->Logarithmic[i]= kTRUE;
   fRem->CPD[i]= 0;
   fRem->AspectRatio[i]= 1; fRem->Aspect[i]= 0;
}


void FlukaMainFrame::remSet(int i)
{
   fRem->Geometry[i]= fGeometry->GetState();

   strcpy(fRem->Title[i],fGraphTitle->GetText());
   strcpy(fRem->XLabels[i],fXTitle->GetText());
   strcpy(fRem->YLabels[i],fYTitle->GetText());
   strcpy(fRem->Scored[i],fZTitle->GetText());

   fRem->Swap[i]= fSwap->GetState();
   fRem->Normalize[i]= fZNormalize->GetState();
   fRem->Scale[i]= fZScaleValue->GetNumber();
   fRem->Anchor[i]= fZLower->GetNumber();
   fRem->EnableColorPalette[i]= fEnableColor->GetState();
   fRem->FLukaScheme[i]= fPrintOptCheck->GetState();
   fRem->Logarithmic[i]= fLogCheck->GetState();
   fRem->CPD[i]= (int)fColorPerDec->GetNumber();

   fRem->AspectRatio[i]= _ratio->GetNumber();
   fRem->Aspect[i]= 0;
   if (_preserve->IsDown()) fRem->Aspect[i]= 1;
     else if (_manually->IsDown()) fRem->Aspect[i]= 2;
}


void FlukaMainFrame::remPush(int i)
{
   if (i<0) i= fRem->selected; else fRem->selected= i;

   fGeometry->SetOn(fRem->Geometry[i]);

   fGraphTitle->SetText(fRem->Title[i]);
   fXTitle->SetText(fRem->XLabels[i]);
   fYTitle->SetText(fRem->YLabels[i]);
   fZTitle->SetText(fRem->Scored[i]);

   fSwap->SetOn(fRem->Swap[i]);
   fZNormalize->SetOn(fRem->Normalize[i]);
   fZScaleValue->SetNumber(fRem->Scale[i]);
   fZLower->SetNumber(fRem->Anchor[i]);
   fEnableColor->SetOn(fRem->EnableColorPalette[i]);
   fPrintOptCheck->SetOn(fRem->FLukaScheme[i]);
   fLogCheck->SetOn(fRem->Logarithmic[i]);
   fColorPerDec->SetNumber(fRem->CPD[i]);

   _ratio->SetNumber(fRem->AspectRatio[i]);
   switch (fRem->Aspect[i]) { case 1: _preserve->SetDown(); break;
                              case 2: _manually->SetDown(); break; }
}





// --- mar'06 06-12:03
//    -------------------------------
//     the place where we try to scan through the FLUKA geometry in connection with our new
//     geometry tab functionality (leave old way for 'in histogram scan' under UpdateHistogram)
//     we should be able to pick up already created histgrams to 'underlay' here
//


void FlukaMainFrame::drawGeometry()
{
   int other,nxy,swap;
   double xl,xu,yl,yu;
   FbeHist *h2;

   setOurCursor(kWatch);

   other= (_gview+1)%3;
   xl= _gco[_gview*2]->GetNumber(); xu= _gco[_gview*2+1]->GetNumber();
   yl= _gco[other*2]->GetNumber(); yu= _gco[other*2+1]->GetNumber();

   if (xu-xl<.0000001 || yu-yl<.0000001) { setOurCursor(kPointer); return; }

   swap= _swap->GetState();

   c1->GetCanvas()->SetEditable(kTRUE);
// c1->GetCanvas()->SetBit(TGraph::kClipFrame,true);     // <-- broken for me since 5.12.00 --- see above
   c1->GetCanvas()->Disconnect("RangeChanged()",this,"ReflectRanges()");

   if (_show->IsDown()) {
     if (theHistogram) { FbeHist *c= (FbeHist*)gROOT->FindObject("h2"); if (c) c->Delete();
                         if (!theBinning->wasGraphed(_gview)) UpdateHistogram(1);
                         if (swap!=theBinning->GetHist(_gview)->swap()) { theBinning->GetHist(_gview)->swap(1);
                                                                          UpdateHistogram(1); }
                         h2= theBinning->GetHist(_gview); }}

// ------------------------------------------- keep this just to remember ---
//   { TIter next(gDirectory->GetList());
//     TObject *obj;
//     while ((obj=next())) {
//     if (obj->InheritsFrom("TH2F")) { printf(" -drawGeometry- found _%s_ (%p)\n",((TH2F*)obj)->GetName(),obj);  }}}
   
   TH2F *c= (TH2F*)gROOT->FindObject("tg"); if (c) c->Delete();
   TH2F *tg= new TH2F("tg","test",1,xl,xu,1,yl,yu);

// tg->SetTitle("PLOTGEOM geometry scan");
   OurStyle(tg,1);
   tg->SetBinContent(1,1,.1);
   if (swap) tg->Draw("0,col,swap"); else tg->Draw("0,col");

   if (_lines->GetState()) nxy= (int)fGeoLines->GetNumber();
     else { c1->GetCanvas()->Update();
            NX= gPad->XtoAbsPixel(gPad->GetUxmax())-gPad->XtoAbsPixel(gPad->GetUxmin());
            NY= gPad->YtoAbsPixel(gPad->GetUymin())-gPad->YtoAbsPixel(gPad->GetUymax());
            nxy= (NX>NY)?NX:NY;
            fGeoLines->SetNumber(nxy); _nr[_gview]= nxy +1; }   // -?- +1

   if (_show->IsDown())
     if (theHistogram) {
       c1->GetCanvas()->SetLogz( fLogCheck->GetState() );
       int i=_gview,doColor=fRem->EnableColorPalette[i]+fRem->FLukaScheme[i]*2;
       h2->preparePalette(fRem->Anchor[i],fRem->CPD[i],doColor,((fRem->Normalize[i])?1/fRem->Scale[i]:fRem->Scale[i]));

       char options[80];
       strcpy(options,"same,col");
       if (_gview==0 && theBinning->rphi()) strcat(options,",pol");
       if (doColor==1||doColor==3) strcat(options,",z");
       if (swap) strcat(options,",swap");

       h2->Draw(options); }

   _rotID= -1;
   if (theBinning) _rotID= theBinning->getFlukaID();


   if (fmyGxyz[_gview]->reDoit()) {

//
// --- check if inside the FLUKA world code segment
//
   { int i=_gview,j=(_gview+1)%3,type=_pXYZ->voidType;
     double *p=_pXYZ->limits;
     char emsg[256];

// --- sep'06 11-06:05
//     reduce our 50cm default range if FLUKA void is smaler
//     fragile since we don't really support limits for all available FLUKA shapes
//
     if (p[i]>_xyz[2*i] || p[i+3]<_xyz[2*i+1] || p[j]>_xyz[2*j] || p[j+3]<_xyz[2*j+1]) {
       _xyz[2*i]= p[i]*.9; _gco[2*i]->SetNumber(_xyz[2*i]);
       _xyz[2*i+1]= p[i+3]*.9; _gco[2*i+1]->SetNumber(_xyz[2*i+1]);
       _xyz[2*j]= p[j]*.9; _gco[2*j]->SetNumber(_xyz[2*j]);
       _xyz[2*j+1]= p[j+3]*.9; _gco[2*j+1]->SetNumber(_xyz[2*j+1]);

       DEBUG(printf(" ---> recursive!!\n");)
       drawGeometry();
       return;
       }
// ---

     if (type==9 || type==7 || type==2) {
       if (type==2) { double xo=p[i]+(p[i+3]-p[i])*.5,yo=p[j]+(p[j+3]-p[j])*.5,
                             r=fabs(p[i+3]-p[i])*.5*sqrt(3.);
                      if (_xyz[2*i]<p[i] || _xyz[2*i+1]>p[i+3] || _xyz[2*j]<p[j] || _xyz[2*j+1]>p[j+3]) {
                        sprintf(emsg,"requested view area includes points outside of the FLUKA world - "
                                "here the world is a SPH with origin (%f/%f) and radius %f\n"
                                "(naive check to be inside inscribed cube which will be slightly off)\n",xo,yo,r*sqrt(2.));
                        new aMessageBox(gClient->GetRoot(),this,emsg,openIcon("FLUKA-Icon.xpm"));
                        return; }
                    }
         else if (_xyz[2*i]<p[i] || _xyz[2*i+1]>p[i+3] || _xyz[2*j]<p[j] || _xyz[2*j+1]>p[j+3]) {
                sprintf(emsg,"requested view area includes points outside of the FLUKA world - "
                        "here the world is a RPP/BOX with\n min %f/%f and max %f/%f\n"
                        "(this is still a naive check which will be slightly off)\n", p[i],p[i+1],p[j],p[j+1]);
                new aMessageBox(gClient->GetRoot(),this,emsg,openIcon("FLUKA-Icon.xpm"));
                return; }
       }
//       else { sprintf(emsg,"trouble finding max FLUKA world parameters - "
//                      "strange/not yet implemented outer body type (%i)\n"
//                      "(this is still a naive check which will be slightly off)\n",type);
//              new aMessageBox(gClient->GetRoot(),this,emsg,openIcon("FLUKA-Icon.xpm"));
//              return; }
   }
//
// ---

     switch(_gview) {
                      case 0: _pXYZ->TXX= 1.; _pXYZ->TXY= 0.; _pXYZ->TXZ= 0.;
                              _pXYZ->TYX= 0.; _pXYZ->TYY= 1.; _pXYZ->TYZ= 0.;
                              _pXYZ->Z0= _pXYZ->Z1= _zd->GetNumber();
                              _pXYZ->X0= _gco[0]->GetNumber(); _pXYZ->X1= _gco[1]->GetNumber();
                              _pXYZ->Y0= _gco[2]->GetNumber(); _pXYZ->Y1= _gco[3]->GetNumber();
                              _pXYZ->XAXLEN= _pXYZ->X1-_pXYZ->X0; _pXYZ->YAXLEN= _pXYZ->Y1-_pXYZ->Y0;
                              break;

                      case 1: _pXYZ->TXX= 0.; _pXYZ->TXY= 1.; _pXYZ->TXZ= 0.;
                              _pXYZ->TYX= 0.; _pXYZ->TYY= 0.; _pXYZ->TYZ= 1.;
                              _pXYZ->X0= _pXYZ->X1= _zd->GetNumber();
                              _pXYZ->Y0= _gco[2]->GetNumber(); _pXYZ->Y1= _gco[3]->GetNumber();
                              _pXYZ->Z0= _gco[4]->GetNumber(); _pXYZ->Z1= _gco[5]->GetNumber();
                              _pXYZ->XAXLEN= _pXYZ->Y1-_pXYZ->Y0; _pXYZ->YAXLEN= _pXYZ->Z1-_pXYZ->Z0;
                              break;

                      case 2: _pXYZ->TXX= 0.; _pXYZ->TXY= 0.; _pXYZ->TXZ= 1.;
                              _pXYZ->TYX= 1.; _pXYZ->TYY= 0.; _pXYZ->TYZ= 0.;
                              _pXYZ->Y0= _pXYZ->Y1= _zd->GetNumber();
                              _pXYZ->Z0= _gco[4]->GetNumber(); _pXYZ->Z1= _gco[5]->GetNumber();
                              _pXYZ->X0= _gco[0]->GetNumber(); _pXYZ->X1= _gco[1]->GetNumber();
                              _pXYZ->XAXLEN= _pXYZ->Z1-_pXYZ->Z0; _pXYZ->YAXLEN= _pXYZ->X1-_pXYZ->X0;
                              break;
                  }

     _pXYZ->EXPANX= _pXYZ->EXPANY= 1.;
     _pXYZ->lwmhol= _nr[_gview];

     if (FLUKA_OK) fmyGxyz[_gview]->doPlotgeom( _pXYZ,_mode->GetState(),_rotID ); }

   if (FLUKA_OK) {
     if (fGeoRegions->IsDown()) { dealColors();
                                  // fmyGxyz[_gview]->paint(swap,NX,NY); }
                                  fmyGxyz[_gview]->plot(swap); }

    {
     int is41= (_requestBlack)?_requestBlack:41;
     int is15= (_requestBlack)?_requestBlack:15;    // ---> user request   may'07 07-03:14
 // -------
     fmyGxyz[_gview]->overlay(swap, (fGeoRegions->IsDown())?is41:is15);
     DEBUG(printf(" ---> after overlay in geometry\n");)
    }

     if (swap) tg->Draw("axis,swap,same"); else tg->Draw("axis,same"); }

// --- sep'06 16-14:36
//
   { int i=_gview,j=(_gview+1)%3;
     double aspect=1,xl=_xyz[2*i],xh=_xyz[2*i+1],yl=_xyz[2*j],yh=_xyz[2*j+1];
     if (_preserveG->IsDown()) aspect= (yh-yl)/(xh-xl);
       else if (_manuallyG->IsDown()) aspect= _ratioG->GetNumber();

     setCanvasAspect(c1->GetCanvas(),aspect,swap); }
// ---

   c1->GetCanvas()->Update();
   DEBUG(printf(" ---> after update\n");)
   c1->GetCanvas()->SetEditable(kFALSE);
   c1->GetCanvas()->Connect(c1->GetCanvas(),"ProcessedEvent(int,int,int,TObject*)",
                                 "FlukaMainFrame",this,"zoomExec(int,int,int,TObject*)");

   setOurCursor(kPointer);
}



void FlukaMainFrame::pickRange(int myself)
{
   int iz=(_gview+2)%3;

   if (!myself) { int parm1=((TGTextEntry*)gTQSender)->WidgetId();
     if (parm1==PICKUPRANGE) { _xyz[0]= fMin[0]->GetNumber();
                               _xyz[1]= fMax[0]->GetNumber();
                               _xyz[2]= fMin[1]->GetNumber();
                               _xyz[3]= fMax[1]->GetNumber();
                               _xyz[4]= fMin[2]->GetNumber();
                               _xyz[5]= fMax[2]->GetNumber();
                               _z[_gview]= .5*(fMin[iz]->GetNumber()+fMax[iz]->GetNumber());
                             }
       else {
               if (parm1==MAXRANGE) { _xyz[0]= _pXYZ->limits[0]*.9; _xyz[1]= _pXYZ->limits[3]*.9;
                                      _xyz[2]= _pXYZ->limits[1]*.9; _xyz[3]= _pXYZ->limits[4]*.9;
                                      _xyz[4]= _pXYZ->limits[2]*.9; _xyz[5]= _pXYZ->limits[5]*.9; }
                 else { _z[_gview]= 0;
                        _xyz[1]= _xyz[3]= _xyz[5]=  50;
                        _xyz[0]= _xyz[2]= _xyz[4]= -50; }
            }
     }

   for (int i=0;i<6;i++) _gco[i]->SetNumber(_xyz[i]);
   _zd->SetNumber(_z[_gview]);

   DEBUG(printf(" -pickRange(%i)\n",myself);)
   updateGeometry(-1);
}


void FlukaMainFrame::focusChangeGeometry(int which)
{
   TGNumberEntry *teBox;

   switch (which) {
      case MGEOLINES: teBox= _gco[(_gview==1)?2:0]; break;
      case MGXL: teBox= _gco[1]; break;
      case MGXU: teBox= _gco[(_gview==2)?4:2]; break;
      case MGYL: teBox= _gco[3]; break;
      case MGYU: teBox= (_gview==0)? _zd:_gco[4]; break;
      case MGZL: teBox= _gco[5]; break;
      case MGZU: teBox= _zd; break;
      case MGZD: teBox= fGeoLines; break;
      default: { printf(" -hey- geometry tab text entry problem\n"); return; }
      }
   teBox->GetNumberEntry()->SetFocus(); teBox->GetNumberEntry()->SelectAll();
}


// --- FIXME put logo back and try to close the ones I really want to
//           close and only those
//           the next 2 should really handle all close or reopen cases!

void FlukaMainFrame::resetCanvas(int mode)
{
   switch (mode) {
       case 0: DEBUG(printf(" ---resetCanvas--- (0)\n");)
               break;

       case 1: DEBUG(printf(" ---resetCanvas--- (1) \n");)
               c1->GetCanvas()->SetEditable(kTRUE);

             { TIter next(gDirectory->GetList()); 
               TObject *obj;
               while ((obj=next())) if (obj->InheritsFrom("TH2F") && !strcmp(obj->GetName(),"tg")) obj->Delete(); }
               break;

       case 2: DEBUG(printf(" ---resetCanvas--- (2) \n");)
               break;
       }

   c1->GetCanvas()->Clear();
   c1->GetCanvas()->Update();
}


void FlukaMainFrame::disconnectFile(int parm1)
{
   if (!parm1) parm1=((TGTextEntry*)gTQSender)->WidgetId();

   if (parm1==MDclose) { fTextData->SetText("close data file");
                         fImportData= kFALSE;
                         try2openDataFile(fTextData->GetText());
                         if (!fImportInput) splash(c1->GetCanvas());
                       }

   if (parm1==MIclose) { fTextInput->SetText("close input file");
                         fImportScan= fImportInput= kFALSE;
                         DEBUG(printf(" -X->>> -disconnect-try2openInputFile- %i\n",FLUKA_OK);)
                         try2openInputFile(fTextInput->GetText());
                         if (!fImportData) splash(c1->GetCanvas());
                       }

   if (parm1==MGclose) { fImportFbeGeom= kFALSE;
                         fGeometry->SetOn(kFALSE);
                         fTextGeom->SetText("close plotgeom file");
                         try2openStoreFile(fTextGeom->GetText());
                       }
}

//
// ---



//
// --- get px/py of a point on the canvas
//     intercept root mouse events in our canvas
//     for y coordinate flip lo/hi
//     trouble: if rubber band is extended out of Pad we lose control, XEvents slip by
//              but seem to be buffered and handed down later - messed up
//
//     mar'06 13-15:47
//     probably not the best of all implementations but ok for now
//     also see the method below this one, zoomed(), try to implement keeping track of zoom level
//

void FlukaMainFrame::zoomExec(int event,int px,int py,TObject *selected)
{
   static float uxlo,uxhi,uylo,uyhi;
   int tmp;
   static int pxlo,pxhi,pylo,pyhi, zoomVH, px0,py0,px1,py1, rubber=kFALSE;  //-?-,getMaterial=kFALSE;
   //-- DEBUG(printf(" ---> _%20s_ %3i\n",selected->IsA()->GetName(),event);)

   if (!FLUKA_OK) return;

   if (event==kKeyPress) { int key=px,keysym=py;
                           if (keysym==kKey_Backspace || keysym==kKey_Left || key=='p') zoomed();
                           if (keysym==kKey_Right || key=='n') zoomed(2); }

// --- give coordinates/material/region at tip

   double x,y, lx,ly,lz;
   if ((x=gPad->AbsPixeltoX(px))>gPad->GetUxmin() && x<gPad->GetUxmax())
     if ((y=gPad->AbsPixeltoY(py))>gPad->GetUymin() && y<gPad->GetUymax()) {
       char e[13];
       if (_swap->GetState()) { float tmp= x; x= y; y= tmp; }
       sprintf(e,"%12.5g",x); e[12]= '\0'; fGeoLco[2]->SetText(e);
       sprintf(e,"%12.5g",y); e[12]= '\0'; fGeoLco[4]->SetText(e);

       switch (_gview) { case 0: lx=x; ly=y; lz=_z[0]; break;
                         case 2: lx=y; ly=_z[2]; lz=x; break;
                         case 1: lx=_z[1]; ly=x; lz=y; break; }

       aptS *apt= aPoint(lx,ly,lz,_rotID);
       if (apt==NULL) return;

       char nm[4],nr[5],b[10],c[10];
       int nn= apt->nmat; sprintf(nm,"%3i",nn);
       sprintf(nr,"%4i",apt->nreg);
       sprintf(b,"-%s",apt->mname); b[9]= '\0';
       sprintf(c,"-%8s",apt->rname); c[9]= '\0';

       TString bb(b,9);
       TString cc(c,9);
       fGeoLmr[2]->SetText(nm); fGeoLmr[3]->SetText(bb); fGeoLmr[5]->SetText(nr); fGeoLmr[6]->SetText(cc);
       }

// --- get min/max for our pad only at start if mouse button is pushed

   if (event==kButton1Down || event==kButton3Down) {

     // --- this a good one
     //     get focus back here into our canvas after text entry (mar'06 17-18:13)

     gVirtualX->SetInputFocus( gVirtualX->GetWindowID( c1->GetCanvasWindowId() ));

     // ---

     uxlo= gPad->GetUxmin(); uxhi= gPad->GetUxmax(); uyhi= gPad->GetUymin(); uylo= gPad->GetUymax();
     pxlo= gPad->XtoAbsPixel(uxlo); pxhi= gPad->XtoAbsPixel(uxhi);
     pylo= gPad->YtoAbsPixel(uylo); pyhi= gPad->YtoAbsPixel(uyhi);

     zoomVH= 0;
     if (selected->IsA()==TAxis::Class() || selected->IsA()==TCanvas::Class()) {
       if (px<pxlo || px>pxhi) zoomVH--;
       if (py<pylo || py>pyhi) zoomVH++;
       }
     }

// --- draw rubber band to show zoom selection

   if (event==kButton1Down) { px1= px0= px; py1= py0= py;
     gVirtualX->DrawLine(px0,py0,px0,py1);
     gVirtualX->DrawLine(px0,py0,px1,py0);
     gVirtualX->DrawLine(px0,py1,px1,py1);
     gVirtualX->DrawLine(px1,py0,px1,py1);
     rubber= kTRUE; }

   if (rubber && event==kButton1Motion) {
     gVirtualX->DrawLine(px0,py0,px0,py1);
     gVirtualX->DrawLine(px0,py0,px1,py0);
     gVirtualX->DrawLine(px0,py1,px1,py1);
     gVirtualX->DrawLine(px1,py0,px1,py1);
     px1= (px<pxlo)?pxlo:(px>pxhi)?pxhi:px; py1= (py<pylo)?pylo:(py>pyhi)?pyhi:py;
     gVirtualX->DrawLine(px0,py0,px0,py1);
     gVirtualX->DrawLine(px0,py0,px1,py0);
     gVirtualX->DrawLine(px0,py1,px1,py1);
     gVirtualX->DrawLine(px1,py0,px1,py1); }

   if (event==kButton1Up) {
     gVirtualX->DrawLine(px0,py0,px0,py1);
     gVirtualX->DrawLine(px0,py0,px1,py0);
     gVirtualX->DrawLine(px0,py1,px1,py1);
     gVirtualX->DrawLine(px1,py0,px1,py1);

     if (px1<px0) { tmp= px1; px1= px0; px0= tmp; }
     if (py1<py0) { tmp= py1; py1= py0; py0= tmp; }
     if (px1-px0<1 || py1-py0<1) return;
// ---------------------------------------- little messy because of swap()
     double o[4],otmp;
     if (zoomVH<0) { o[0]= uxlo; o[1]= uxhi; } else { o[0]= gPad->AbsPixeltoX(px0); o[1]= gPad->AbsPixeltoX(px1); }
     if (zoomVH>0) { o[3]= uylo; o[2]= uyhi; } else { o[2]= gPad->AbsPixeltoY(py1); o[3]= gPad->AbsPixeltoY(py0); }
     if (_swap->GetState()) { otmp= o[0]; o[0]= o[2]; o[2]= otmp; otmp= o[1]; o[1]= o[3]; o[3]= otmp; }
     for (int i=0;i<4;i++) zoom[_gview][i]= o[i];
// ----------------------------------------------------
     rubber= kFALSE;
     zoomed(1);
     }
}



void FlukaMainFrame::zoomed(int mode)
{
   static int nzoom=0,mnzoom=0;
   static double keep[99][6];
   DEBUG(printf(" ---> zoomed(%i) %i\n",mode,nzoom);)
   int i;

   if (gTQSender==fGeoZplus) mode= 2;

   switch(mode) {
      case 0:
               if (nzoom<=0) return;
               nzoom--;
               for (i=0;i<6;i++) _xyz[i]= keep[nzoom][i];
               break;
      case -1:
               if (nzoom<=0) return;
               for (i=0;i<6;i++) _xyz[i]= keep[0][i];
               mnzoom= nzoom= -1;
               break;
      case 1:
               if (nzoom>98) return;
               for (i=0;i<6;i++) keep[nzoom][i]= _xyz[i];
               mnzoom= ++nzoom;

               i=(_gview+1)%3;
               keep[nzoom][2*_gview]= _xyz[2*_gview]= zoom[_gview][0];
               keep[nzoom][2*_gview+1]= _xyz[2*_gview+1]= zoom[_gview][1];
               keep[nzoom][2*i]= _xyz[2*i]= zoom[_gview][2];
               keep[nzoom][2*i+1]= _xyz[2*i+1]= zoom[_gview][3];
               i=(_gview+2)%3;
               keep[nzoom][2*i]= _xyz[2*i];
               keep[nzoom][2*i+1]= _xyz[2*i+1];
               break;
      case 2:
               if (nzoom>=mnzoom) return;
               nzoom++;
               for (i=0;i<6;i++) _xyz[i]= keep[nzoom][i];
               break;
      }

   pickRange(1);
}


//
// ---
//

void FlukaMainFrame::dealColors()
{

//     jul'06 05:11:22
//     updated/adapted to our new code in context of 2006.2
// --- check if we should read/write default color map for our materials
//
//     oct'06 06-13:22
//     introduce a cInfo to sort out a better cmap procedure
//      first set colors for all materials out of FLUKA over again
//      then read from cmap file and overwrite
//      write to file always if manual colors are requested
//      need write access for .cmap file  (just ignore all if no write access 4now)

   int nMedia;
   short *cmap= fmyGxyz[_gview]->getColors(&nMedia);

   typedef struct { short set; char name[9]; float r,g,b; } cmapS;
   cmapS *pcI,*cInfo= (cmapS*)calloc(MXXMDF,sizeof(cmapS));

   char dir[256],file[256],a[9];
   FILE *fp;
   strcpy(dir,gSystem->DirName(fTextInput->GetText()));
   strcpy(file,gSystem->BaseName(fTextInput->GetText()));
   char *p=strstr(file,".");
   if (!p) p= &file[strlen(file)];
   strcpy(p,".cmap"); p[strlen(p)]= '\0';
   strcat(dir,"/"); strcat(dir,file);

   int i;
   float r,g,b;
   char *mname= (char*)malloc(MXXMDF*9*sizeof(char));  // --- jul'06 28-16:22 - do pointers myself, see i*9

   if (!FLUKA_OK) return;

   for (i=0;i<MXXMDF;i++) if (cmap[i]>0) {
      r= g= b= .05;
      gROOT->GetColor(i%100)->GetRGB(r,g,b); gMatCol[i]->SetRGB(r,g,b);  // -ae- use only 100 color cells in root (206..)
                                                                         //   still not clean - needs indirection/mapping
      getMaterialName(&i,&mname[i*9]);
      pcI= &cInfo[i]; pcI->set= 1; strcpy(pcI->name,&mname[i*9]); pcI->r= r; pcI->g= g; pcI->b= b;
      }

   fp=fopen(dir,"r");
   if (fp) {
     while (EOF!=fscanf(fp," %i %8s %f %f %f\n",&i,a, &r,&g,&b)) {
          if (fGeoColors->GetState()) { strcpy(&mname[i*9],a); gMatCol[i%100]->SetRGB(r,g,b); }
          pcI= &cInfo[i]; pcI->set= 2; strcpy(pcI->name,a); pcI->r= r; pcI->g= g; pcI->b= b;
          }
     fclose(fp);
     }

   if (fGeoColors->GetState()) {
     fp=fopen(dir,"w");
     if (fp) { for (i=0;i<MXXMDF;i++)
                  if (cInfo[i].set) { pcI= &cInfo[i];
                                      fprintf(fp," %4i %8s   %8f %8f %8f\n",i,pcI->name,pcI->r,pcI->g,pcI->b); }
               fclose(fp);
             }}

   fmyGxyz[_gview]->mapColors(gMatCol);
}




const TGPicture *FlukaMainFrame::openIcon(char* name)
{
   const TGPicture *pic;
   char str[256];

   if (!(pic=fClient->GetPicture(name)))
     if (!(pic=fClient->GetPicture( strcat(strcat(strcpy(str,_here),"/"),name) )))
       if (!(pic=fClient->GetPicture( strcat(strcat(strcpy(str,_prefix),"/"),name) ))) return NULL;

   return pic;
}


//
// --- sep'06 11-19:23
//     aspect ratio stuff

void FlukaMainFrame::setCanvasAspect(TCanvas *c1,double f,int swap)
{
   double dw=0,dh=0;
   if (f>1) dw= ((1-_top-_bottom)*(1-1/f))*.5; else dh= ((1-_right-_left)*(1-f))*.5;
   if (swap) { double t= dw; dw= dh; dh= t; }
   c1->GetCanvas()->SetTopMargin(_top+dh); c1->GetCanvas()->SetBottomMargin(_bottom+dh);
   c1->GetCanvas()->SetLeftMargin(_left+dw); c1->GetCanvas()->SetRightMargin(_right+dw);
}


void FlukaMainFrame::splash(TCanvas *c1)
{
   TLatex l0,l1,l2,l3;

   c1->SetEditable(kTRUE);
   c1->Disconnect("RangeChanged()",this,"ReflectRanges()");
   c1->Range(.0,.0,1.,1.);
   c1->cd();

   l0.SetTextAlign(12); l0.SetTextSize(0.035); l0.DrawLatex(0.012,0.113,"  #color[1005]{FlukaGUI .07  (aug'07)}");
   l1.SetTextAlign(12); l1.SetTextSize(0.025); l1.DrawLatex(0.020,0.080,"  #color[1005]{the FLEUR project}");
   l3.SetTextAlign(12); l3.SetTextSize(0.025); l3.DrawLatex(0.020,0.057,"  #color[1005]{University of Houston, NASA/CERN}");
   l2.SetTextAlign(12); l2.SetTextSize(0.025); l2.DrawLatex(0.020,0.034,"  #color[1005]{contact: anton.empl@cern.ch}");

   c1->Update();
}




//
// ---  sep'06 20-16:23
//      one method taken straight out of root to get at resizing frame
//      we'll mess with it to get a fixed aspect ratio implemented, on request
//      also try to get physical mm/mm acknowledged
//      probably horrible in terms of C++
//
//      uses global variables out of our FlukaMainFrame class/file
//

TGDimension po,poc;

TGDimension dealWithAspectRation()
{
   TGDimension d= pvf1->GetSize(), dd=pc1->GetSize();
   int dx= d.fWidth-po.fWidth,dy= d.fHeight-po.fHeight;
   int x= poc.fWidth+dx,y= poc.fHeight+dy;

   if (ourFixedAspect) if (d.fWidth>d.fHeight) x= poc.fWidth+dy; else y= poc.fHeight+dx;
   x= (int)(x*screenfactor);

   DEBUG(printf(" --- %i %i --> %i %i -- %f\n",x,y, (int)(x*screenfactor),y, screenfactor);)

   TGDimension xy(x,y);
   return xy;
}


//
// --- root v05.13/02 ---
//

Bool_t TGFrame::HandleConfigureNotify(Event_t *event)
{
   // This event is generated when the frame is resized.

   static TGDimension o=pvf1->GetSize(),oc=pc1->GetSize();
   po= o; poc= oc;

   if ((event->fWidth != fWidth) || (event->fHeight != fHeight)) {
     fWidth= event->fWidth;
     fHeight= event->fHeight;
     Layout();

     TGDimension xy= dealWithAspectRation();
     pc1->Resize(xy.fWidth,xy.fHeight);
     pc1->DoRedraw();
     Layout();
   }

   return kFALSE;
}


//
// --- mar'07 09-31:20
//     since settig cursors is somewhat messy within the root frame work, let's have a small
//     utility helper here
//

void FlukaMainFrame::setOurCursor(ECursor kw) { gVirtualX->SetCursor(this->GetId(),gVirtualX->CreateCursor(kw));
                                                c1->GetCanvas()->SetCursor(kw); }

