
//
//    (feb'07 19-02:07) - version v.07a
//                                                                                 the FLEUR project
// -------------------------------------------------------------------------------------------------
//                                                                                anton.empl@cern.ch
// --- FLUKA user back-end project -Fbe-
//     our own message box, not much different but friendlier in use
//     adapted mar'06 19-00:06
//

//
// ------ september'18 2003
//        small utility to have a personal message box, user friendly
//        all in context of the FLUKA/FLEUR back-end gui effort
//        anton.empl@cern.ch
//
//        just a frame today - idea, make a list of labels in a vertical frame rather than
//                             finding a multiline window in the gui set
//                             both buttons will quit the dialog
//                             add maybe a one line text entry later (optional)


#include "aMessageBox.h"


aMessageBox::aMessageBox(const TGWindow *pw, const TGFrame *f, char* message, const TGPicture *icon)
//             : TGTransientFrame(pw, main, 10, 10)
{
   TGWindow *main= (TGWindow*)f;

   TColor  *matt= gROOT->GetColor(1001);
   TColor  *dark= gROOT->GetColor(1002);
   TColor *light= gROOT->GetColor(1003);
   TColor  *grey= gROOT->GetColor(1004);
   TColor  *redC= gROOT->GetColor(1005); redC->SetRGB(.8,.3,.4);

   fmain= new TGTransientFrame(pw,main,10,10);
   fmain->AddInput(kKeyPressMask|kKeyReleaseMask);
   fmain->Connect("ProcessedEvent(Event_t*)","aMessageBox",this,"ProcessMessage(Event_t*)");

   fHeadline= new TGLabel(fmain,"__________________________________ flukaGUI v.07 aug'07 _____");
   fmain->AddFrame(fHeadline, new TGLayoutHints(kLHintsExpandX, 1,1,1,1));
   fHeadline->ChangeBackground(matt->GetPixel());

   fThatsIt= new TGVerticalFrame(fmain,300,75);

   fRight= new TGHorizontalFrame(fThatsIt,10,10);
   fRight->ChangeBackground(dark->GetPixel());

   fIconFrame= new TGHorizontalFrame(fRight,60,20);
   fIcon= new TGIcon(fIconFrame,icon,icon->GetWidth(),icon->GetHeight());
   fIconFrame->AddFrame(fIcon);
   fRight->AddFrame(fIconFrame, new TGLayoutHints(kLHintsLeft, 1,0,4,4));

   fOK= new TGTextButton(fRight,"   ok   ",13);
   fOK->Connect("ProcessedEvent(Event_t*)","aMessageBox",this,"ProcessMessage(Event_t*)");

   fOK->ChangeBackground(light->GetPixel());
// int nfl= fOK->SetFlags(kWidgetWantFocus|kWidgetIsEnabled);
   fRight->AddFrame(fOK, new TGLayoutHints(kLHintsCenterX|kLHintsCenterY, 0,0,4,4));


   fLeft= new TGVerticalFrame(fThatsIt,10,10);

// --- not really brainy at all in the end, but we have a little processor here
//     which limits our lines to about 82 characters and honors line breaks

   char line[256];
   int m;
   char *r,*q,*p=message;
   _n= 0;

   while (p) { q= strstr(p,"\n"); m= (q)? (int)(q-p):strlen(p);
               if (m>82) { r= &p[82-5]; q= strstr(r," "); m= (q)? (int)(q-p):strlen(p); }

               strncpy(line,p,m); line[m]= '\0';
               fOneLine[_n]= new TGLabel(fLeft,line);
               fOneLine[_n]->ChangeBackground(grey->GetPixel());
               fLeft->AddFrame(fOneLine[_n++], new TGLayoutHints(kLHintsLeft, 4,4,0,0));

               p= q; if (q) p++; }

   fLeft->ChangeBackground(grey->GetPixel());

   fThatsIt->AddFrame(fLeft, new TGLayoutHints(kLHintsTop|kLHintsExpandX, 2,2,2,2));
   fThatsIt->AddFrame(fRight, new TGLayoutHints(kLHintsBottom|kLHintsExpandX, 0,0,0,0));

   fThatsIt->ChangeBackground(redC->GetPixel());

   fmain->AddFrame(fThatsIt, new TGLayoutHints(kLHintsExpandY|kLHintsExpandX, 4,4,4,0));
   fmain->ChangeBackground(dark->GetPixel());

   fmain->MapSubwindows();
   fmain->Resize(fmain->GetDefaultSize());

// -----------------------
   Window_t child;
   int x,y;
   unsigned int w,h;
   gVirtualX->GetWindowSize( main->GetId(), x,y,w,h);
   gVirtualX->TranslateCoordinates(f->GetId(),gClient->GetDefaultRoot()->GetId(),w,h, x,y, child);

   int fx=fmain->GetWidth()/2,fy=fmain->GetHeight()/2;
   fmain->Move(x-w/2-fx,y-h/2-fy);
   fmain->SetWMPosition(x-w/2-fx,y-h/2-fy);
// -----------------------

   fmain->SetWindowName("aMessageWindow");
   fmain->MapWindow();

   _once=1;
   fmain->RequestFocus();
   fOK->RequestFocus();
   gClient->WaitFor(fmain);
}


void aMessageBox::CloseWindow() { fmain->DeleteWindow(); }


//
// --- mar'06 20-12:42
//     pretty bad fight with having the OK button selected on entry so that a simply return
//     or enter will get us out of the box use signals for KeyPress==0 (KeyRelease==1 won't
//     work since root menu doesn't clean out the release event!) very IMPORTANT, we need
//     to only react _once here since otherwise root get us a second signal from a dying widget
//     and that will kill the application
//     avfter much searching, RequestFocus() is the answer to lots of trouble

Bool_t aMessageBox::ProcessMessage(Event_t *event)
{
   if (event->fType==0 && _once) { _once= 0; CloseWindow(); }
   if (event->fType==3) CloseWindow();
   return kTRUE;
}
