
//
//    (feb'07 19-02:07) - version v.07a
//                                                                                 the FLEUR project
// -------------------------------------------------------------------------------------------------
//                                                                                anton.empl@cern.ch
//                                                                                  Matt LeBourgeois
// --- FLUKA user back-end project -Fbe-
//     main for the flukaGUI
//

#include <stdio.h>
#include <stdlib.h>

#include "FlukaMainFrame.h"

extern "C" { int signalUserRoutines(); } 



int main(int argc, char **argv)
{

//
// --- here is where one needs to modify the TEnv in order to affect GUI parameters
//
   float r,g,b;
   char s[256];

   strcpy(s,gEnv->GetValue("Gui.ForeGround",".630 .620 .500"));
   gEnv->SetValue("Gui.ForeGround",s,kEnvChange);
   sscanf(s," %f %f %f ",&r,&g,&b);
   sprintf(s,"#%2x%2x%2x",(int)(255*r),(int)(255*g),(int)(255*b));
   gEnv->SetValue("Gui.BackgroundColor",s,kEnvChange);

   strcpy(s,gEnv->GetValue("Gui.BackGround",".430 .420 .300"));
   gEnv->SetValue("Gui.BackGround",s,kEnvChange);
   sscanf(s," %f %f %f ",&r,&g,&b);
   sprintf(s,"#%2x%2x%2x",(int)(255*r),(int)(255*g),(int)(255*b));
   gEnv->SetValue("Gui.SelectBackgroundColor",s,kEnvChange);

   strcpy(s,gEnv->GetValue("Gui.Buttons",".790 .780 .670"));
   gEnv->SetValue("Gui.Buttons",s,kEnvChange);

   strcpy(s,gEnv->GetValue("Gui.TextArea",".940 .970 .890"));
   gEnv->SetValue("Gui.TextArea",s,kEnvChange);
   sscanf(s," %f %f %f ",&r,&g,&b);
   sprintf(s,"#%2x%2x%2x",(int)(255*r),(int)(255*g),(int)(255*b));
   gEnv->SetValue("Gui.TooltipBackgroundColor",s,kEnvChange);

   strcpy(s,gEnv->GetValue("Gui.ExtraColor",".740 .370 .390"));
   gEnv->SetValue("Gui.ExtraColor",s,kEnvChange);

   strcpy(s,gEnv->GetValue("Gui.DefaultCanvasSize","600"));
   gEnv->SetValue("Gui.DefaultCanvasSize",s,kEnvChange);
//
// ---
//

    int sur= signalUserRoutines();
// --------------------------------

   TApplication theApp("App",&argc,argv);
   if (gROOT->IsBatch()) { fprintf(stderr, "%s: cannot run in batch mode\n",argv[0]); return 1; }

   int requestBlack=0,j,i=1;
   while (i<argc) { j= atoi(argv[i++]); if (j>0 && j<99) requestBlack= j; }

   FlukaMainFrame mainWindow(sur,gClient->GetRoot(), 700, 500);
   mainWindow.hiddenRequest(requestBlack);
   theApp.Run();

   return 0;
}

